c    Version: 05/09/2012
c modif February 10, 2007: changed conversion magAB-> fluxes used in the fit 
c       and used consistent conversion in input and output 
c modif April 07, 2010: revised input/output units 
c       OUTPUT_TYPE=0 [erg/cm2/s/A]
c       OUTPUT_TYPE=1 [muJy]
c       OUTPUT_TYPE=2 [mag AB]
c       checked for input in AB magnitudes (MAG_TYPE=1)
c modif August 21,2012: general revision
c modif September 04, 2012: changed method of reading and storing filters'  
c       transmission functions: removed convol_new, compos_new, filter0 
c       and filter.dec, englobed in a single routine read_filt 
      PROGRAM hyperz
      IMPLICIT NONE
c
      INTEGER i,ii,iii,j,k,l,ks,n_files,ncomp,kfil,iw_vega,iw,n_filt,
     .     iob,nob,id,iout_s,iout_m,law_rd,nfil,iroot,matrix,iw_ob,
     .     i_typ,i_red,i_age,i_lyf,nz,itype,i_bc,i_as,i_pg,iage,ilyf,
     .     nlyf,izmin,itypem,iagem,iredm,ilyfm,npoiz,n_sol,iwav,npoiz1,
     .     npoiz2,last,nred,ired,law_nd,i_lyman,mxz,izsol,mxage,
     .     mxage_bc,mxage_pg,mxtyp,mxtyp_bc,mxtyp_as,mxtyp_pg,
     .     mxfil,mxred,mxlyf,mxwl,mxwl_bc,mxwl_as,mxwl_pg,ndeg,magtyp,
     .     iunit_sed,i1,i2,icat,iblank,input,nparam,ipass,izmin1,mxwf,
     .     iagemax,iagemin,np,nfilt_mabs,iz_clus,n_fil_wa,n_fil_w,
     .     itypea,ireda,iagea,ilyfa,iztyp,idum,izphot,i_sol,iout,iz,
     .     iforbid,n_head,npercent0,npercent,istep,nsteps,nemline,
     .     imabs,mxvega,iband,ierr,iband_abs,ntyp_bc,ntyp_as,ntyp_pg,
     .     mxrp,law_err,irebin,iage_check,it_pg,ic1,iseg,imf,jo,nz_f,
     .     i_min,ifilt,mxafil
      REAL*8 scl,w_vega,f_vega,t_bc,t_pg,f_bc,f_as,f_pg,z1,z2,amag,
     .     amag1,err_p,mag_nd,err_nd,err_min,avmin,mag_nd1,avmax,averr,
     .     wl,surf,c_corr,val,p,err_fl,dz,zmax,zmin,zz,z,y,yb,zop,
     .     filter,z_min_array,av,q_pro,dz_f,zmin_f,zmax_f,age,fl,qq,
     .     poids,poids_z,q_pro1,q_pro2,q_proz,chi2_b1,chi2_b2,z_b,z_b1,
     .     z_b2,dd,z_poids,qq_p,w0,wmin1,wmax1,wmin0,wmax0,wsyn,ysyn,
     .     d1,d2,yob,zz1,zz2,vega,flux,flux0,pthresh,conv_mag,bp1,
     .     time_tot,part_time,f_jy,err_jy,deg,pchi2,qchi2,zero,chi2,
     .     r_chi2,amabs_1,amabs_2,amagb,dif_w,dif_w_min,fl_temp,
     .     mag_temp,func,prob,err,x1,x2,ww,h0,om,ov,ageuni,tz,r,z_clus,
     .     amagb_clus,p_clus,dummy,age_min,age_max,err_minf,dummyz,
     .     zphot,chi2sol,qq2,fl_nd,fl1,ebv_mw,av_mw,rlin,chi2min,
     .     bb_array,c,f2,trapz1,fact_lyf,r_lyf,frac,wlmax,wlmin,lsun,
     .     sn_lim,z_form,age_form,d_l,dl,dmod,aa8,fluxn,fluxerrn,xlam,
     .     rr2,amgal,amstar,sfr,tau,sn,dif(101)
      REAL*8 fff,bm,wt,sxx,sxy,b,bb,bbb,ddummy
      REAL wv,fv,ff,w_bc,w_as,w_pg,t_bc0,cputime,rmag,rerr_p,aa
c
      PARAMETER (err=1.D-8,nparam=45,imf=10,lsun=3.826D33)
      PARAMETER (c=2.99792458D+18) ! speed of light in AA/s
      INCLUDE 'dimensionz.dec'
      PARAMETER (mxtyp=mxtyp_bc+mxtyp_as+mxtyp_pg,mxz=301)

      LOGICAL header
      REAL ml,mu,xx(imf),lm(imf),um(imf),baux(imf),cn(imf),cc(imf),totm,
     .     totn,avs,tau0,zsun
      CHARACTER header_line*5000
      CHARACTER filesed(mxtyp)*160,sed_abc(mxtyp)*2,line*240
      CHARACTER*160 spectra,amatrix,filedef,filein,filt_file,
     .     cat_in,spectra1,spectra2,spectra3,spectra4,spectra5,
     .     spec_vega,filtresfile,filered,line_sed,filterout,copyright1,
     .     copyright2,copyright3
      CHARACTER clog*1,ccat*1,cz*1,csed1*1,csed2*1,cage*1,cout_m*1,
     .     cout_s*1,root*12,date*24,vv*5,cmag*5,cout*5,line_pg*80,
     .     string_id*80
      CHARACTER*250 fmt1,fmt2,fmt3,fmt4
      CHARACTER*40 cname,param(nparam)
c
      DIMENSION input(nparam),kfil(10),ks(mxtyp)
      DIMENSION ntyp_bc(mxtyp),ntyp_as(mxtyp),ntyp_pg(mxtyp)
      DIMENSION tau(mxtyp),zsun(mxtyp)
      DIMENSION nfil(mxfil+1),iw(mxtyp),i_lyman(mxfil)
      DIMENSION t_bc0(mxage_bc),t_bc(mxage_bc),t_pg(mxage_pg),ff(mxwl)
      DIMENSION w_vega(mxvega),f_vega(mxvega),vega(mxfil+1)
      DIMENSION bp1(mxfil+1),conv_mag(mxfil+1),surf(mxfil+1),f2(mxfil+1)
      DIMENSION c_corr(mxfil),fl_nd(mxfil),fl1(mxfil),err_minf(mxfil)
      DIMENSION f_jy(mxfil),err_jy(mxfil),fl_temp(mxfil),mag_temp(mxfil)
      DIMENSION rmag(mxfil),rerr_p(mxfil)
      DIMENSION amag(mxfil),amag1(mxfil),err_p(mxfil)
      DIMENSION mag_nd(mxfil),mag_nd1(mxfil),err_nd(mxfil),law_nd(mxfil)
      DIMENSION fl(mxfil),err_fl(mxfil)
      DIMENSION ysyn(mxwl),wsyn(mxwl),ww(mxwl)
      DIMENSION yob(mxwl),y(mxwl),yb(mxwl)
      DIMENSION z_min_array(mxz)
      DIMENSION i_typ(mxz),i_age(mxz),i_red(mxz),i_lyf(mxz)
      DIMENSION wl(mxfil+1),flux(mxfil+1,0:mxz,mxage,mxtyp,mxred,mxlyf)
      DIMENSION q_pro(mxz),q_pro1(mxz),q_pro2(mxz),q_proz(mxz)
      DIMENSION z(0:mxz),z_b(mxz),z_b1(mxz),z_b2(mxz)
      DIMENSION chi2_b1(mxz),chi2_b2(mxz),iforbid(mxz),bb_array(mxz)
      DIMENSION izphot(mxz),zphot(mxz),bb(mxz),chi2sol(mxz)
      DIMENSION val(3),zz1(3),zz2(3),p(3)
      DIMENSION n_fil_w(mxz)
      DIMENSION fluxn(mxfil+1),fluxerrn(mxfil+1)
      DIMENSION xlam(mxwf),rr2(mxwf)
      DIMENSION w_bc(mxwl_bc,mxtyp_bc),f_bc(mxwl_bc,mxage_bc,mxtyp_bc)
      DIMENSION w_as(mxwl_as,mxtyp_as),f_as(mxwl_as,1,mxtyp_as)
      DIMENSION w_pg(mxwl_pg,mxtyp_pg),f_pg(mxwl_pg,mxage_pg,mxtyp_pg)
c
      EXTERNAL cputime,rlin,filter,pchi2,qchi2,zero,func,tz,trapz1,d_l
c
      COMMON/compose/ifilt,np(mxfil)
      COMMON/rfilter/r(mxwf,mxfil,2)
      COMMON/nfree/deg,prob
      COMMON/filterres/filtresfile
      COMMON/lyf_sigma/fact_lyf
      COMMON/redfile/filered
c_________________________________________________________________________

      vv='2.1'
      copyright1='    Hyperz photometric redshift code - Version '//vv
     .     //' (November 12th, 2012)' 
      copyright2=' by Micol Bolzonella, Roser Pello'','
     .     //' Joan-Marc Miralles'
      copyright3=' Original web pages '
     .     //'http://webast.ast.obs-mip.fr/hyperz/'
      WRITE(*,*)
      WRITE(*,'(a80)') copyright1
      WRITE(*,*)
      WRITE(*,'(a80)') copyright2
      WRITE(*,'(a80)') copyright3
      WRITE(*,'(a)') ' New web pages: '
     &     //'http://www.bo.astro.it/~micol/Hyperz/'

      iband=1          ! bandpass response function unit for observed filters: 
                       ! 0.energy; 1.photons (see e.g. Bessell 2005)
                       ! this is not a free parameter, if you need to change
                       ! it modify the value here and recompile
      iband_abs=1      ! bandpass response function unit for Mabs filter
      nlyf=1           ! considering only the mean Madau value
      r_lyf=1.D0
      fact_lyf=1.D0
      law_err=0
      imabs=1
      amabs_1=-100.0D0
      amabs_2=100.0D0
      amabs_1=-100.0D0
      amabs_2=100.0D0
      sn_lim=-1.D0
      irebin=0
      imabs=1
      z_clus=-1.D0
c ..... Probabilities for the confidence intervals
      p(1)=0.99D0
      p(2)=0.90D0
      p(3)=0.68D0
      x1=0.D0
      x2=200.D0
      ndeg=1
      deg=DBLE(REAL(ndeg))
      DO i=1,3
         prob=p(i)
         val(i)=zero(func,x1,x2,err)  ! chi2 for P = p(i) 
      END DO

 11   filein='hyperz.param'
      last=INDEX(filein,'  ')-1
      WRITE(*,*) 'Name of parameter file'
      WRITE(*,*) '[default = ',filein(1:last),']'
      READ(*,'(A)') line
      IF (line.ne.' ') THEN
         READ(line,'(A)',ERR=11) filein
      END IF
      time_tot=DBLE(cputime())
c ------------------------------------------------------------------------
c                       Reading parameters file 
c ------------------------------------------------------------------------
c ..... Parameters' names
      param(1)='A0VSED'
      param(2)='FILTERS_RES'
      param(3)='FILTERS_FILE'
      param(4)='TEMPLATES_FILE'
      param(5)='CATALOG_FILE'
      param(6)='CATALOG_TYPE'
      param(7)='Z_MIN'
      param(8)='Z_MAX'
      param(9)='Z_STEP'
      param(10)='ZSTEP_TYPE'
      param(11)='MAG_TYPE'
      param(12)='ERR_MAG_MIN'
      param(13)='ERR_MIN_LAW'
      param(14)='SN_LIMIT'
      param(15)='REDDENING_LAW'
      param(16)='FILE_EXT_LAW'
      param(17)='AV_MIN'
      param(18)='AV_MAX'
      param(19)='AV_STEP'
      param(20)='EBV_MW'
      param(21)='LY_FOREST'
      param(22)='AGE_TYPE'
      param(23)='AGE_MIN'
      param(24)='AGE_MAX'
      param(25)='Z_FORM'
      param(26)='AGE_REBIN'
      param(27)='FILT_M_ABS'
      param(28)='M_ABS_ALG'
      param(29)='TRANS_ABS'
      param(30)='M_ABS_MIN'
      param(31)='M_ABS_MAX'
      param(32)='OUTPUT_FILE'
      param(33)='OUTPUT_TYPE'
      param(34)='ZPHOT_FILE'
      param(35)='SED_OBS_FILE'
      param(36)='SED_TEMP_FILE'
      param(37)='LOGPHOT_FILE'
      param(38)='CATPHOT_FILE'
      param(39)='MATRIX'
      param(40)='SPECTRUM'
      param(41)='PROB_THRESH'
      param(42)='Z_CLUSTER'
      param(43)='H0'
      param(44)='OMEGA_M'
      param(45)='OMEGA_V'

      DO i=1,nparam
         input(i)=0
      END DO
      ebv_mw=0.D0

      OPEN(77,FILE=filein,STATUS='old',ERR=11)
      WRITE(*,*) 'Reading parameter file :'

 7    READ(77,'(A)',ERR=10,END=10) line
      DO i=1,80
         IF (line(i:i).ne.' ') THEN
            line=line(i:)
            GO TO 8
         END IF
      END DO
      GO TO 7  ! blank line
 8    IF (line(1:1).eq.'#') GO TO 7 ! comment line
      iblank=INDEX(line,' ')
      cname=line(1:iblank-1) ! variable name
      line=line(iblank:)
      DO i=1,80
         IF (line(i:i).ne.' ') THEN
            line=line(i:)
            IF (line(1:1).eq.'#') THEN
               WRITE(*,*) 'Missed value of variable ', cname
               STOP
            END IF
            GO TO 9
         END IF
      END DO
      WRITE(*,*) 'Missed value of variable ', cname
      STOP
 9    iblank=INDEX(line,' ')
      line=line(1:iblank-1) ! part of string containing value of variable
c ..... File containing Vega spectrum
      IF (cname.eq.param(1)) THEN
         READ(line,'(A)') spec_vega
         input(1)=1
         GO TO 7
c ..... File FILTER.RES
      ELSE IF (cname.eq.param(2)) THEN
         READ(line,'(A)') filtresfile
         input(2)=1
         GO TO 7
c ..... File containing filter parameters and instructions for 
c       non detected objects (nd) or out of file (oof) for each filter
c       0 -> flux = -1 (filter not considered) for either nd or oof
c       1 -> flux = -1 for oof, flux = 0, err_flux = flux_nd for nd
c       2 -> flux = -1 for oof, flux = flux_nd/2, err_flux = flux_nd/2 for nd
c       3 -> flux = -1 for oof, mag = mag_nd,  err = err_nd for nd
      ELSE IF (cname.eq.param(3)) THEN
         READ(line,'(A)') filt_file
         input(3)=1
         GO TO 7
c ..... File containing synthetic spectra filenames
      ELSE IF (cname.eq.param(4)) THEN
         READ(line,'(A)') filedef
         input(4)=1
         GO TO 7
c ..... File containing photometric catalogue
      ELSE IF (cname.eq.param(5)) THEN
         READ(line,'(A)') cat_in
         input(5)=1
         GO TO 7
c ..... Catalogue format 
c       Format of objects catalogue: 
c       N,[z_min,z_max,](mag(i),i=1,n),(err(i),i=1,n)
      ELSE IF (cname.eq.param(6)) THEN
         READ(line,*) icat
         IF (icat.ne.0.and.icat.ne.1) THEN
            WRITE(*,*) 'CATALOG_TYPE must be 0 or 1'
            STOP
         END IF
         input(6)=1
         GO TO 7
c ..... Redshift range (utilized only if icat=0) and step for scan
      ELSE IF (cname.eq.param(7)) THEN
         READ(line,*) zmin
         input(7)=1
         GO TO 7
      ELSE IF (cname.eq.param(8)) THEN
         READ(line,*) zmax
         input(8)=1
         GO TO 7
c ..... Redshift step used to build hypercube
      ELSE IF (cname.eq.param(9)) THEN
         READ(line,*) dz
         input(9)=1
         GO TO 7
c ..... Type of redshift step: 
c       0 -> step = Z_STEP; 1 -> step = Z_STEP*(1+z)
      ELSE IF (cname.eq.param(10)) THEN
         READ(line,*) iztyp
         IF (iztyp.ne.0.and.iztyp.ne.1) THEN
            WRITE(*,*) 'ZSTEP_TYPE must be 0 or 1'
            STOP
         END IF
         input(10)=1
         GO TO 7
      ELSE IF (cname.eq.param(11)) THEN
         READ(line,*) magtyp
         IF (magtyp.ne.0.and.magtyp.ne.1.and.magtyp.ne.2) THEN
            WRITE(*,*) 'MAG_TYPE must be 0 , 1 or 2'
            STOP
         END IF
         IF (magtyp.eq.0) THEN
            cmag='Vega'
         ELSE IF (magtyp.eq.1) THEN
            cmag='AB'
         ELSE IF (magtyp.eq.2) THEN
            cmag='muJy'
         END IF
         input(11)=1
         GO TO 7
c ..... Minimum error in magnitude (if error < err_min => err = err_min)
      ELSE IF (cname.eq.param(12)) THEN
         READ(line,*) err_min
         input(12)=1
         GO TO 7
c ..... Photometric errors:
c       0 -> if error < err_min => err = err_min
c       1 -> err_min added in quadrature to err in catalogue
c       2 -> err_minf(i) read from filters' file added in quadrature 
c            to err in catalogue, err_min is also used as minimum error
      ELSE IF (cname.eq.param(13)) THEN
         READ(line,*) law_err
         IF (law_err.ne.0.and.law_err.ne.1.and.law_err.ne.2) THEN
            WRITE(*,*) 'ERR_MIN_LAW must be 0, 1 or 2'
            STOP
         END IF
         input(13)=1
         GO TO 7
c ..... Signal-to-noise ratio limit for detection/non detection
      ELSE IF (cname.eq.param(14)) THEN
         READ(line,*) sn_lim
         input(14)=1
         GO TO 7
c ..... Reddening:
c       0 -> No reddening
c       1 -> Allen, 1976, standard MW
c       2 -> Seaton, 1979, standard MW
c       3 -> Fitzpatrick, 1986, LMC
c       4 -> Prevot, 1984 + Bouchet, 1985, SMC
c       5 -> Calzetti et al., 2000
c      -1 -> user provided table with lambda[A],k(lambda)/RV
      ELSE IF (cname.eq.param(15)) THEN
         READ(line,*) law_rd
         IF (law_rd.ne.0.and.law_rd.ne.1.and.law_rd.ne.2.and.
     .        law_rd.ne.3.and.law_rd.ne.4.and.law_rd.ne.5.and.
     .        law_rd.ne.-1) THEN
            WRITE(*,*) 'REDDENING_LAW must be -1 -- 5'
            STOP
         END IF
         input(15)=1
         GO TO 7
c ..... File containing used provided extinction law (lambda[A],k(lambda)/RV)
      ELSE IF (cname.eq.param(16)) THEN
         READ(line,'(A)') filered
         input(16)=1
         GO TO 7
c ..... Av_max, Av_min
      ELSE IF (cname.eq.param(17)) THEN
         READ(line,*) avmin
         input(17)=1
         GO TO 7
      ELSE IF (cname.eq.param(18)) THEN
         READ(line,*) avmax
         input(18)=1
         GO TO 7
c ..... Reddening step used to build hypercube
      ELSE IF (cname.eq.param(19)) THEN
         READ(line,*) averr
         input(19)=1
         GO TO 7
c .... galactic dereddening
      ELSE IF (cname.eq.param(20)) THEN
         READ(line,*) ebv_mw
         input(20)=1
         GO TO 7
c .... Lyman Forest
      ELSE IF (cname.eq.param(21)) THEN
         READ(line,*) r_lyf
         IF (r_lyf.lt.1.D-4) r_lyf=1.D0
         IF (r_lyf.lt.1.D0) r_lyf=1.D0/r_lyf
         IF (ABS(r_lyf-1.D0).lt.1.D-4) THEN
            nlyf=1 ! considering only the mean Madau value
         ELSE
            nlyf=3 ! considering 3 values: mean Madau value + 2 values 
         END IF
         input(21)=1
         GO TO 7
c ..... Check the age of the object < universe age (y/n)
      ELSE IF (cname.eq.'AGE_CHECK') THEN
         WRITE(*,*) 'AGE_CHECK is obsolete, but it is OK for this time'
         cage=line(1:1)
         IF (cage.eq.'y'.or.cage.eq.'Y') THEN
            iage_check=1
         ELSE
            iage_check=0
         END IF
         input(22)=1
         GO TO 7
c ..... Constraint for age (it will supersede AGE_CHECK)
c       0. free
c       1. free with age <  age universe-age(T_FORM)
c       2. fixed age: age=age of universe-T(Z_FORM)
      ELSE IF (cname.eq.param(22)) THEN
         READ(line,*) iage_check
         IF (iage_check.ne.0.and.iage_check.ne.1.and.
     &        iage_check.ne.2) THEN
            WRITE(*,*) 'AGE_TYPE must be 0, 1 or 2'
            STOP
         END IF
         input(22)=1
         GO TO 7
c ..... Minimum age to be considered
      ELSE IF (cname.eq.param(23)) THEN
         READ(line,*) age_min
         input(23)=1
         GO TO 7
c ..... Maximum age to be considered
      ELSE IF (cname.eq.param(24)) THEN
         READ(line,*) age_max
         input(24)=1
         GO TO 7
c ..... Formation redshift (used only if AGE_TYPE=1 or 2)
      ELSE IF (cname.eq.param(25)) THEN
         READ(line,*) z_form
         input(25)=1
         GO TO 7
c ..... Age rebinning: 
c       0. no (221 ages) 1. yes (51 ages)
      ELSE IF (cname.eq.param(26)) THEN
         READ(line,*) irebin 
         IF (irebin.ne.0.and.irebin.ne.1) THEN
            WRITE(*,*) 'AGE_REBIN must be 0 or 1'
            STOP
         END IF
         input(26)=1
         GO TO 7
c ..... Filter for the absolute magnitude
      ELSE IF (cname.eq.param(27)) THEN
         READ(line,*) nfilt_mabs
         input(27)=1
         GO TO 7
c ..... Algorithm to compute absolute magnitudes: 
c       0. nearest filter 1. best fit normalization
      ELSE IF (cname.eq.param(28)) THEN
         READ(line,*) imabs 
         IF (imabs.ne.0.and.imabs.ne.1) THEN
            WRITE(*,*) 'MAG_ABS_ALG must be 0 or 1'
            STOP
         END IF
         input(28)=1
         GO TO 7
c ..... Transmission of absolute magnitude filter: 
c       0. energy 1. photons
      ELSE IF (cname.eq.param(29)) THEN
         READ(line,*) iband_abs
         IF (iband_abs.ne.0.and.iband_abs.ne.1) THEN
            WRITE(*,*) 'TRANS_ABS must be 0 or 1'
            STOP
         END IF
         input(29)=1
         GO TO 7
c ..... Limits for absolute magnitude
      ELSE IF (cname.eq.param(30)) THEN
         READ(line,*) amabs_1
         input(30)=1
         GO TO 7
      ELSE IF (cname.eq.param(31)) THEN
         READ(line,*) amabs_2
         input(31)=1
         GO TO 7
c ..... Output files: no extension (file = *)
c       *.cat_phot -> catalogue
c       *.log_phot -> log file
c       *.sed      -> SED
c       *.z_phot   -> catalogue with only first maximum
      ELSE IF (cname.eq.param(32)) THEN
         READ(line,'(A)') spectra
         iblank=INDEX(spectra,' ')
         spectra1=spectra(1:iblank-1)//'.cat_phot'
         spectra2=spectra(1:iblank-1)//'.log_phot'
         spectra3=spectra(1:iblank-1)//'.obs_sed'
         spectra4=spectra(1:iblank-1)//'.z_phot'
         spectra5=spectra(1:iblank-1)//'.temp_sed'
         filterout=spectra(1:iblank-1)//'.out_phot'
         input(32)=1
         GO TO 7
c ..... Output SED: 
c       0 -> erg/s/cm^2/A ; 1 -> microJansky ; 2 -> AB magnitudes
      ELSE IF (cname.eq.param(33)) THEN
         READ(line,*) iunit_sed
         IF (iunit_sed.ne.0.and.iunit_sed.ne.1.and.iunit_sed.ne.2) THEN
            WRITE(*,*) 'OUTPUT_TYPE must be 0, 1 or 2'
            STOP
         END IF
         IF (iunit_sed.eq.0) THEN
            cout='cgs'
         ELSE IF (iunit_sed.eq.1) THEN
            cout='muJy'
         ELSE IF (iunit_sed.eq.2) THEN
            cout='AB'
         END IF
         input(33)=1
         GO TO 7
c ..... File .z_phot (y/n)
      ELSE IF (cname.eq.param(34)) THEN
         cz=line(1:1)
         input(34)=1
         GO TO 7
c ..... File .obs_sed (y/n)
      ELSE IF (cname.eq.param(35)) THEN
         csed1=line(1:1)
         input(35)=1
         GO TO 7
c ..... File .temp_sed (y/n)
      ELSE IF (cname.eq.param(36)) THEN
         csed2=line(1:1)
         input(36)=1
         GO TO 7
c ..... File .log_phot (y/n)
      ELSE IF (cname.eq.param(37)) THEN
         clog=line(1:1)
         input(37)=1
         GO TO 7
c ..... File .cat_phot (y/n)
      ELSE IF (cname.eq.param(38)) THEN
         ccat=line(1:1)
         input(38)=1
         GO TO 7
c ..... Matrix/obj
      ELSE IF (cname.eq.param(39)) THEN
         cout_m=line(1:1)
         input(39)=1
         GO TO 7
c ..... Spectrum/obj
      ELSE IF (cname.eq.param(40)) THEN
         cout_s=line(1:1)
         input(40)=1
         GO TO 7
c ..... Probability threshold for the study of secondary maxima
      ELSE IF (cname.eq.param(41)) THEN
         READ(line,*) pthresh
         input(41)=1
         GO TO 7
c ..... Cluster redshift
      ELSE IF (cname.eq.param(42)) THEN
         READ(line,*) z_clus
         input(42)=1
         GO TO 7
c ..... Cosmological parameters to compute the universe age and M_abs 
      ELSE IF (cname.eq.param(43)) THEN
         READ(line,*) h0
         input(43)=1
         GO TO 7
      ELSE IF (cname.eq.param(44)) THEN
         READ(line,*) om
         input(44)=1
         GO TO 7
      ELSE IF (cname.eq.param(45)) THEN
         READ(line,*) ov
         input(45)=1
         GO TO 7
      ELSE 
         WRITE(*,'(a,1x,a)') 'Unknown parameter (ignored)',cname
         GO TO 7
      END IF

 10   CONTINUE
      CLOSE(77)

      IF (z_clus.gt.0.and.(z_clus.lt.zmin.or.z_clus.gt.zmax)) THEN
         WRITE(*,*) 'Z_CLUSTER must be in the interval [Z_MIN,Z_MAX]'
         STOP
      END IF
      iout_m=1
      iout_s=1
      IF (input(nparam-2).eq.1.and.
     .     cout_m.eq.'y'.or.cout_m.eq.'Y') iout_m=2
      IF (input(nparam-1).eq.1.and.
     .     cout_s.eq.'y'.or.cout_s.eq.'Y') iout_s=2

      av_mw=3.1D0*ebv_mw
      IF (law_rd.eq.0) THEN
         avmin=0.0D0
         avmax=0.0D0
         averr=1.0D0
      END IF
      OPEN(20,file=filered,status='old',iostat=ierr)
      IF (ierr.gt.0.and.law_rd.eq.-1) THEN
         iblank=INDEX(line,' ')
         WRITE(*,'(a)') 'User provided extinction law'
         WRITE(*,'(a)') 'File '//filered(1:iblank-1)//' not found'
         STOP
      END IF
      CLOSE(20)
      nred=NINT(ABS(avmax-avmin)/averr)+1
      IF (ABS(avmin+averr*(nred-1)-avmax).gt.1.D-6) nred=nred-1
      IF (nred.gt.mxred) THEN
         WRITE(*,'(1x,a,i3,a)') 
     .        'Number of reddening steps exceeding the maximum [max=',
     .        mxred,']'
         STOP
      END IF
      age_form=tz(h0,om,ov,z_form) ! age of universe at z_form

      OPEN(10,FILE=filedef,STATUS='old',ERR=78)
      iii=1
 2230 READ(10,'(A)',ERR=2220,END=2220) line_sed
      IF (line_sed(1:1).eq.'#'.or.line_sed.eq.' ') GO TO 2230
      last=INDEX(line_sed,' ')-1
      filesed(iii)=line_sed(1:last)
      line_sed=line_sed(last+1:)
      DO i=1,160
         IF (line_sed(i:i).ne.' ') THEN
            line_sed=line_sed(i:)
            GO TO 2221
         END IF
      END DO
      WRITE(*,*) 'Missed type of SED file ', filesed(iii)
      STOP
 2221 sed_abc(iii)=line_sed(1:2)
      iii=iii+1
      GO TO 2230
 2220 n_files=iii-1
      IF (n_files.gt.mxtyp) THEN
         WRITE(*,'(1x,a,i3,a)') 
     .        'Number of files exceeding the maximum [max=',mxtyp,']'
         STOP
      END IF
      WRITE(*,'(1x,a,1x,i4,1x,a)') 'There are ',n_files,
     &     ' synthetic spectra'
      CLOSE(10)
      OPEN(10,FILE=filt_file,STATUS='old',ERR=80)

      ifilt=0
 134  CONTINUE
      READ(10,'(A)',ERR=135,END=135) line
      IF (line(1:1).eq.'#'.or.line.eq.' ') GO TO 134
      ifilt=ifilt+1
      ncomp=1
      DO k=1,80
         IF (line(k:k).eq.'&') THEN
            line(k:k)=' '
            ncomp=ncomp+1

         ELSE IF (line(k:k).eq.'#') THEN
            GO TO 136
         END IF
      END DO
 136  CONTINUE
      IF (ncomp.eq.1) THEN 
         READ(line,*,ERR=82) nfil(ifilt),c_corr(ifilt),law_nd(ifilt),
     .        mag_nd(ifilt),err_nd(ifilt)
         kfil(1)=nfil(ifilt)
      ELSE 
         READ(line,*,ERR=82) (kfil(j),j=1,ncomp),c_corr(ifilt),
     .        law_nd(ifilt),mag_nd(ifilt),err_nd(ifilt)
      END IF
      IF (law_nd(ifilt).ne.0.and.law_nd(ifilt).ne.1.and.
     .     law_nd(ifilt).ne.2.and.law_nd(ifilt).ne.3.and.
     .     law_nd(ifilt).ne.4) THEN
         WRITE(*,'(a)') 'Non detection law must be 0, 1, 2, 3 or 4'
         WRITE(*,'(a,i3)') 'Check filter ', nfil(ifilt)
         IF (law_nd(i).eq.3.and.law_err.eq.2) THEN
            WRITE(*,'(a)') 
     .           'Cannot use simultaneously ERR_MIN_LAW=2 in main '
     .           //'parameters file and law_nd=3 in filters file'
         END IF
         STOP
      END IF
c read_filt subroutine 
      CALL read_filt(ncomp,kfil,wl(ifilt),surf(ifilt),bp1(ifilt),iband)
      GO TO 134

 135  n_filt=ifilt
      IF (n_filt.gt.mxfil) THEN
         WRITE(*,'(1x,a,i3,a)') 
     .        'Number of filters exceeding the maximum [max=',mxfil,']'
         STOP
      END IF
      WRITE(*,'(a,1x,i4,1x,a)') 'There are ',n_filt,' filters'

      IF (law_err.eq.2) THEN
         DO i=1,n_filt
            err_minf(i)=err_nd(i)
         END DO
      END IF

      ifilt=ifilt+1             ! hereafter ifilt is the abs mag filter
      nfil(ifilt)=nfilt_mabs    ! filter for absolute magnitude estimates
      kfil(1)=nfil(ifilt)
      CALL read_filt(1,kfil,wl(ifilt),surf(ifilt),bp1(ifilt),iband_abs)

      CLOSE(10)

      OPEN(10,FILE=cat_in,STATUS='old',ERR=79)
      header = .FALSE.
      READ(10,'(A)',ERR=79) header_line
      IF (header_line(1:1).eq.'#'.or.header_line.eq.' ') THEN
         header= .TRUE.
         i=1
 44      READ(10,'(A)',ERR=79) header_line
         IF (header_line(1:1).eq.'#'.or.header_line.eq.' ') THEN
            i=i+1
            GO TO 44
         ELSE
            n_head=i
         END IF
      END IF
      CLOSE(10)
      OPEN(10,FILE=cat_in,STATUS='old',ERR=79)
      IF (header) THEN
         DO i=1,n_head
            READ(10,'(A)') header_line
         END DO
      END IF

      IF (icat.eq.0) THEN
         iob=0
 1340    CONTINUE
         iob=iob+1
         READ(10,*,ERR=1350,END=1350) id,(rmag(i),i=1,n_filt),
     .        (rerr_p(i),i=1,n_filt)
         z1=zmin
         z2=zmax
         GO TO 1340
      ELSE IF (icat.eq.1) THEN
         iob=0
 1341    CONTINUE
         iob=iob+1
         READ(10,*,ERR=1350,END=1350) id,z1,z2,(rmag(i),i=1,n_filt),
     .        (rerr_p(i),i=1,n_filt)
         IF(z1.lt.zmin) zmin=z1
         IF(z2.gt.zmax) zmax=z2
         GO TO 1341
      ELSE
         GO TO 79
      END IF
 1350 nob=iob-1
      WRITE(*,'(1x,a,i7,a)') 'There are ',nob,
     &     ' objects in the catalogue'
      CLOSE(10)

      IF (iout_m.gt.1.and.nob.gt.100) THEN
         iout=0
         WRITE(*,'(a,i6,a)') ' You chose output matrix for all ',
     .        nob, ' objects' 
         WRITE(*,'(a)') ' Are you sure?'
         WRITE(*,*) 'Type 0 to continue with matrix, 1 without matrix'
         WRITE(*,*) '[<return>=1]'
         READ(*,'(a)') line 
         IF (line.ne.' ') THEN
            READ(line,*) iout
            IF (iout.eq.0) iout_m=2
         END IF
      END IF
      z(0)=0.D0
      z(1)=zmin
      i=1
 88   i=i+1
      IF (iztyp.eq.0) THEN
         z(i)=z(i-1)+dz
      ELSE IF (iztyp.eq.1) THEN
         z(i)=z(i-1)+(1.D0+z(i-1))*dz
      END IF
      IF (zmax-z(i).gt.1.D-3) GO TO 88
      nz=i
      IF (nz.gt.mxz) THEN
         WRITE(*,'(1x,a,i4,a)') 
     .        'Number of redshift steps exceeding the maximum [max=',
     .        mxz,']'
         WRITE(*,*) 'Choose a larger Z_STEP or a smaller Z_MAX'
         STOP
      END IF

c -----------------------------------------------------------------------
c                       Reading synthetic spectra 
c -----------------------------------------------------------------------
c ..... Vega
      WRITE (*,'(1x,a)') 'Vega SED:'
      OPEN(10,FILE=spec_vega,STATUS='old')
      READ(10,'(A)') line
      WRITE(*,'(a)') line(1:80)
c      scl=2.D-17
      scl=1.D0
      iii=1
 223  READ(10,*,ERR=222,END=222) wv,fv
      w_vega(iii)=DBLE(wv)
      f_vega(iii)=DBLE(fv)*scl
      iii=iii+1
      GO TO 223
 222  iw_vega=iii-1
      CLOSE(10)
      WRITE(*,'(a,1x,i6,1x,a)') 'There are ',iw_vega,' points in Vega'

c maximum and minimum wavelength in filters
      wlmax=0.D0
      wlmin=1.D12
      DO i=1,n_filt
         wlmax=MAX(wlmax,r(np(i),i,1))
         wlmin=MIN(wlmin,r(1,i,1))
      END DO
c maximum wavelength at the maximum redshift
      wlmax=wlmax*(1.D0+zmax)
c minimum wavelength at the minimum redshift
      wlmin=wlmin*(1.D0+zmin)

c ..... SED
      WRITE(*,*) 'Reading synthetic spectra :'
      i_bc=0
      i_as=0
      i_pg=0
      DO i=1,n_files
         ntyp_bc(i)=-1
         ntyp_as(i)=-1
         ntyp_pg(i)=-1
      END DO 
   
      DO i=1,n_files
         last=INDEX(filesed(i),' ')
         WRITE(*,2005) i,filesed(i)(1:last)
c GISSEL's templates
         IF (sed_abc(i).eq.'BC') THEN
            OPEN(1,FILE=filesed(i),STATUS='old',
     .           FORM='unformatted',ERR=25)
            i_bc=i_bc+1
            IF (i_bc.gt.mxtyp_bc) THEN
               WRITE(*,'(a,i3)') 
     .              ' Number of GISSEL templates exceeding the maximum.' 
     .              //' Max = ',mxtyp_bc
               WRITE(*,'(a)') 
     .              ' Reduce GISSEL SEDs or modify mxtyp_bc in '
     .              //'dimensionz.dec and recompile'
               STOP
            END IF
            ntyp_bc(i)=i_bc
c ks = n of temporal intervals, t_bc and t_bc0 in [yr]
            READ (1) ks(i),(t_bc0(ii),ii=1,ks(i)),ml,mu,iseg,
     &	   (xx(j),lm(j),um(j),baux(j),cn(j),cc(j),j=1,iseg),
     &	   totm,totn,avs,jo,tau0,string_id
c replace value of tau if SFH is not exponentially declining
c SFHs following jo parameter: 
c jo=0: SSP; jo=1: exp. declining with gas recycling; 
c jo=2: burst of finite length; jo=3: constant; jo=4: exp. declining; 
c jo=5: burst added; jo=6: delayed; jo=7: input SFH; 
c jo=8: linearly decreasing
         IF (jo.eq.0) THEN      ! SSP 
            tau(i)=0.D0
         ELSE IF (jo.eq.3) THEN
            tau(i)=-1.D0        ! constant SFR
         ELSE IF (jo.eq.4.or.jo.eq.1) THEN
            tau(i)=tau0/1.D9         ! TAU models
         ELSE
            tau(i)=-10.D0       ! other SFHs
         END IF
         ic1=INDEX(string_id,'Z=')
         string_id=string_id(ic1+2:)
         read(string_id,*) zsun(i) 
c iw = number of wavelengths, w_bc wavelength in [A]
            READ (1) iw(i),(w_bc(ii,i_bc),ii=1,iw(i)) 
            IF (iw(i).gt.mxwl_bc) THEN
               WRITE(*,'(a,i6)') 'Number of wavelengths in GISSEL '
     .              //'templates exceeding the maximum. Max = ',mxwl_bc
               WRITE(*,'(a)') 
     .              ' Reduce GISSEL wavelenghts or modify mxwl_bc in '
     .              //'dimensionz.dec and recompile'
               STOP
            END IF
            IF (w_bc(iw(i),i_bc).lt.wlmax) THEN
               WRITE(*,'(a,i3,a,f12.2,a,f12.2)') 
     .              'Warning: Template ',i,' lambda_max is ',
     .              w_bc(iw(i),i_bc),
     .              ' , lambda_max(zmax) should be ',wlmax
               WRITE(*,'(a)') 'Decrease zmax or change the template'
            END IF
            IF (w_bc(1,i_bc).gt.wlmin) THEN
               WRITE(*,'(a,i3,a,f12.2,a,f12.2)') 
     .              'Warning: Template ',i,'lambda_min is ',
     .              w_bc(1,i_bc),
     .              ' , lambda_min(zmin) should be ',wlmin
               WRITE(*,'(a)') 'Increase zmin or change the template'
            END IF
            k=0
            DO j=1,ks(i)
               READ (1) iw(i),(ff(ii),ii=1,iw(i))
               IF ((irebin.eq.1.and.(t_bc0(j)/1.E9.le.0.01.and.
     &              (FLOAT(j)/10.-FLOAT(j/10)).lt.1.E-6)
     &              .or.(t_bc0(j)/1.E9.gt.0.01.and.
     &              t_bc0(j)/1.E9.le.3..and.
     &              (FLOAT(j-49)/3.-FLOAT((j-49)/3)).lt.1.E-6)
     &              .or.(t_bc0(j)/1.E9.gt.3..and.
     &              t_bc0(j)/1.E9.le.20..and.
     &              (FLOAT(j-15)/4.-FLOAT((j-15)/4)).lt.1.E-6)).or.
     &              irebin.eq.0) THEN
                  k=k+1
                  t_bc(k)=DBLE(t_bc0(j))
                  DO ii=1,iw(i)
                     IF (w_bc(ii,i_bc).lt.912.) THEN
                        f_bc(ii,k,i_bc)=0.D0
                     ELSE
                        f_bc(ii,k,i_bc)=DBLE(ff(ii))
                     END IF
                  END DO
               END IF
            END DO
            ks(i)=k
            CLOSE(1)

c ASCII SEDs
         ELSE IF (sed_abc(i).eq.'AS'.or.sed_abc(i).eq.'A ') THEN
            OPEN(1,FILE=filesed(i),STATUS='old',
     .           FORM='formatted',ERR=25)
            i_as=i_as+1
            IF (i_as.gt.mxtyp_as) THEN
               WRITE(*,'(a,i3)') 
     .              ' Number of ASCII templates exceeding the maximum.' 
     .              //' Max = ',mxtyp_as
               WRITE(*,'(a)') 
     .              ' Reduce ASCII SEDs or modify mxtyp_as in '
     .              //'dimensionz.dec and recompile'
               STOP
            END IF
            ntyp_as(i)=i_as
            ks(i)=1
            ii=1

 33         READ(1,'(A)',ERR=34,END=34) line_sed
            IF (line_sed(1:1).eq.'#'.or.line_sed.eq.' ') GO TO 33

            READ(line_sed,*) w_as(ii,i_as),fff
c            f_as(ii,1,i_as)=DBLE(fff)
            f_as(ii,1,i_as)=fff
            ii=ii+1
            IF (ii.gt.mxwl_as) THEN
               WRITE(*,'(a,i6)') 'Number of wavelengths in ASCII '
     .              //'templates exceeding the maximum. Max = ',mxwl_as
               WRITE(*,'(a)') 
     .              ' Reduce ASCII wavelenghts or modify mxwl_as in '
     .              //'dimensionz.dec and recompile'
               STOP
            END IF
            GO TO 33
 34         iw(i)=ii-1
            IF (w_as(iw(i),i_as).lt.wlmax) THEN
               WRITE(*,'(a,i3,a,f12.2,a,f12.2)') 
     .              'Warning: Template ',i,' lambda_max is ',
     .              w_as(iw(i),i_as),
     .              ' , lambda_max(zmax) should be ',wlmax
               WRITE(*,'(a)') 'Decrease zmax or change the template'
            END IF
            IF (w_as(1,i_as).gt.wlmin) THEN
               WRITE(*,'(a,i3,a,f12.2,a,f12.2)') 
     .              'Warning: Template ',i,'lambda_min is ',
     .              w_as(1,i_as),
     .              ' , lambda_min(zmin) should be ',wlmin
               WRITE(*,'(a)') 'Increase zmin or change the template'
            END IF
            CLOSE(1)

c PEGASE templates
         ELSE IF (sed_abc(i).eq.'PG') THEN
            OPEN(1,FILE=filesed(i),STATUS='old',
     .           FORM='formatted',ERR=25)
            i_pg=i_pg+1
            IF (i_pg.gt.mxtyp_pg) THEN
               WRITE(*,'(a,i3)') 
     .              ' Number of PEGASE templates exceeding the maximum.' 
     .              //' Max = ',mxtyp_pg
               WRITE(*,'(a)') 
     .              ' Reduce PEGASE SEDs or modify mxtyp_pg in '
     .              //'dimensionz.dec and recompile'
               STOP
            END IF
            ntyp_pg(i)=i_pg
 35         READ (1,'(a)',ERR=36,END=36) line_pg 
            IF (line_pg(1:5).eq.'*****') GO TO 37
            GO TO 35
 37         READ (1,*,ERR=36,END=36) ks(i),iw(i),nemline
            IF (ks(i).gt.mxage_pg) THEN
               WRITE(*,'(a,i4)') 
     .              ' Number of ages in PEGASE templates exceeding '
     .              //'the maximum. Max = ', mxage_pg
               WRITE(*,'(a)') 
     .              'Change the SED or modify mxage_pg in '
     .              //'dimensionz.dec and recompile'
               STOP
            END IF
            IF (iw(i).gt.mxwl_pg) THEN
               WRITE(*,'(a,i6)') 'Number of wavelengths in PEGASE '
     .              //'templates exceeding the maximum. Max = ',mxwl_pg
               WRITE(*,'(a)') 
     .              ' Reduce PEGASE wavelenghts or modify mxwl_pg in '
     .              //'dimensionz.dec and recompile'
               STOP
            END IF
            READ(1,*) (w_pg(j,i_pg),j=1,iw(i))
            IF (w_pg(iw(i),i_pg).lt.wlmax) THEN
               WRITE(*,'(a,i3,a,f12.2,a,f12.2)') 
     .              'Warning: Template ',i,' lambda_max is ',
     .              w_pg(iw(i),i_pg),
     .              ' , lambda_max(zmax) should be ',wlmax
               WRITE(*,'(a)') 'Decrease zmax or change the template'
            END IF
            IF (w_pg(1,i_pg).gt.wlmin) THEN
               WRITE(*,'(a,i3,a,f12.2,a,f12.2)') 
     .              'Warning: Template ',i,'lambda_min is ',
     .              w_pg(1,i_pg),
     .              ' , lambda_min(zmin) should be ',wlmin
               WRITE(*,'(a)') 'Increase zmin or change the template'
            END IF
            READ(1,*) (aa8,j=1,nemline)
            DO j=1,ks(i)
c 1st line: 1.age[Myr](int), 2.Mgal[Msun], 3.Mstar[Msun], 4.MWD[Msun],
c           5.MBHNS[Msun], 6.Msub[Msun], 7.Mgas[Msun], 8.Zgas, 
c           9.<Zstars>_mass, 10.<Zstars>_Lbol
               READ(1,*) it_pg,amgal,amstar,(aa8,k=1,7)
c 2nd line: 1.L_bol[erg/s], 2. tauV, 3.Ldust/Lbol, 4.SFR[Msun/Myr],
c           5. nLymcont[s-1], 6.nSNII[Myr-1], 7.nSNIa[Myr-1], 
c           8.<age>_mass[Myr], 9.<age>_Lbol[Myr]
               READ(1,*) aa8,aa8,aa8,sfr,aa8,aa8,aa8,aa8,aa8
               READ(1,*) (ff(k),k=1,iw(i))
               t_pg(j)=DBLE(it_pg) ! it_pg is age[Myr] (integer)
               DO k=1,iw(i)
                  f_pg(k,j,i_pg)=DBLE(ff(k))
               END DO
               READ(1,*) (aa,k=1,nemline)
            END DO
c normalise in solar units
            DO k=1,ks(i)
               DO ii=1,iw(i)
                  f_pg(ii,k,i_pg)=f_pg(ii,k,i_pg)/lsun
               END DO
            END DO
c Pegase SEDs already = 0 at lambda < 912.A
            DO k=1,ks(i)
               DO ii=1,iw(i)
                  IF (w_pg(ii,i_pg).lt.912.) f_pg(ii,k,i_pg)=0.
               END DO
            END DO
 36         CLOSE(1)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         ELSE
            WRITE(*,*) 'Don''t know how to read :'
            WRITE(*,'(A)') filesed(i)(1:INDEX(filesed(i),' '))
            STOP
         END IF
      END DO
 2005 FORMAT(' Type ', I3, ' : ', A)
      WRITE(*,'(1x,a,i3,a)') 'Read ',i_bc,' GISSEL SEDs'
      WRITE(*,'(1x,a,i3,a)') '     ',i_as,' ASCII  SEDs'
      WRITE(*,'(1x,a,i3,a)') '     ',i_pg,' PEGASE SEDs'
c -----------------------------------------------------------------------
c                    Filters and .out_phot file
c -----------------------------------------------------------------------

      OPEN(18,FILE=filterout,STATUS='unknown')
      WRITE(18,'(a)')
     .     '##########################################################'
      WRITE(18,'(a,1x,a)')
     .     '# This is the output file of hyperz - Version '//vv
      WRITE(18,'(a)')
     .     '##########################################################'
      CALL fdate(date)
c      CALL fdate_(date)   ! IBM
      WRITE(18,'(a)') '# Date: '//date
      WRITE(18,'(a)') '# Photometric catalogue : '
      last=INDEX(cat_in,' ')-1
      WRITE(18,'(2x,a)')  cat_in(1:last)
      WRITE(18,'(a)') 
     .     '# Templates SEDs: i, file name, format'
      DO itype=1,n_files
         last=INDEX(filesed(itype),' ')-1
         WRITE(18,'(2x,i4,2x,a,2x,a)') itype,filesed(itype)(1:last),
     .     sed_abc(itype)
      END DO
      WRITE(18,'(a)') '# Characteristics of SED fitting filters'
      WRITE(18,'(a)') '#  n      wl_eff    surface  bandpass1  conv_AB'
     .     //' m_corr mlim(AB)   nd trans dm_min dm_law mtyp'
      WRITE(18,'(a)') '#  trans: 0 energy, 1 photons'
      zz=0.D0

c ..... Conversion from AB to standard magnitudes: conv_mag = AB - Vega
c computing AB magnitude of Vega
      DO k=1,n_filt+1
         vega(k)=filter(k,w_vega,f_vega,iw_vega,zz)
         DO i=1,np(k)
            xlam(i)=r(i,k,1) ! lambda
            rr2(i)=r(i,k,2)/(xlam(i)*xlam(i)) ! R/lambda^2
         END DO
         f2(k)=c*trapz1(xlam,rr2,np(k))
         conv_mag(k)=-2.5D0*DLOG10(vega(k)/f2(k))-48.60D0
      END DO
      DO k=1,n_filt
c ..... Flux corresponding to the limiting magnitude
         IF (magtyp.eq.0) THEN
            mag_nd1(k)=mag_nd(k) ! limiting mag written in filters file
            fl_nd(k)=vega(k)*
     .           10**(-0.4D0*(mag_nd(k)+c_corr(k)))/surf(k) 
c            mag_nd(k)=-2.5D0*DLOG10(fl_nd(k)*surf(k)/vega(k)) !Vega lim mag
            mag_nd(k)=mag_nd1(k)+c_corr(k)+conv_mag(k) ! AB limiting mag
         ELSE IF (magtyp.eq.1) THEN
            mag_nd1(k)=mag_nd(k)
            fl_nd(k)=10**(-0.4D0*(mag_nd1(k)+c_corr(k)+48.6D0))
            mag_nd(k)=mag_nd1(k)+c_corr(k) ! AB limiting mag
         ELSE IF (magtyp.eq.2) THEN 
            fl_nd(k)=(mag_nd(k)+c_corr(k))*1.D-29 
            mag_nd(k)=-2.5D0*DLOG10(fl_nd(k))-48.6 ! AB limiting mag
         END IF
         IF (law_err.eq.2) THEN
            WRITE(18,1998) nfil(k),wl(k),surf(k),bp1(k),conv_mag(k),
     .           c_corr(k),mag_nd(k),law_nd(k),iband,err_minf(k),
     .           law_err,cmag
         ELSE
            WRITE(18,1998) nfil(k),wl(k),surf(k),bp1(k),conv_mag(k),
     .           c_corr(k),mag_nd(k),law_nd(k),iband,err_min,law_err,
     .           cmag
         END IF
      END DO
 1998 FORMAT(I4,1X,F11.3,1X,2(F10.3,1X),1X,F7.3,1X,F6.3,1X,F7.3,
     .     4X,I2,4X,I2,2X,F5.3,3X,I2,3X,A5)
      IF (law_rd.eq.-1) THEN
         WRITE(18,'(a)') '#    AVmin     AVmax    AVstep  red_law file'
         WRITE(18,'(4X,3(F5.2,5X),I2,2x,A)') avmin,avmax,averr,law_rd,
     .        filered(1:INDEX(filered,' '))
      ELSE
         WRITE(18,'(a)') '#    AVmin     AVmax    AVstep  red_law'
         WRITE(18,'(4X,3(F5.2,5X),I2)') avmin,avmax,averr,law_rd
      END IF
      WRITE(18,'(a)') 
     .     '#    Lyman_forest [factor(s) multiplying <tau_eff>]'
      IF (nlyf.eq.1) WRITE(18,'(4X,F6.3)') r_lyf
      IF (nlyf.eq.3) WRITE(18,'(4X,3(F6.3,2X))') 
     .     1.D0/r_lyf,r_lyf/r_lyf,r_lyf
      WRITE(18,'(a)') '# nMabs   wl_eff    surface  bandpass1'
     .     //'   conv_AB     Mmin   Mmax algorithm '
     .     //'trans out_typ'
      WRITE(18,1999) nfilt_mabs,wl(ifilt),surf(ifilt),bp1(ifilt),
     .     conv_mag(ifilt),amabs_1,amabs_2,imabs,iband_abs,cout
 1999 FORMAT(I4,1X,F11.3,1X,2(F10.3,1X),1X,F7.3,2(2X,F7.2),2(5X,I2),
     .     2X,A5)
      WRITE(18,'(a)') '#    Age_type age_min[Gyr] age_max[Gyr]  z_form'
      WRITE(18,'(6X,I3,6X,F7.3,6X,F7.3,6X,F6.2)') 
     .     iage_check,age_min,age_max,z_form
      WRITE(18,'(a)') '#    Omega_0   Omega_v  H_0   minimum S/N'
      WRITE(18,'(4X,3(F5.2,5X),2X,F5.2)') om,ov,h0,sn_lim
c -----------------------------------------------------------------------
c                          Building Hypercube! 
c -----------------------------------------------------------------------
      WRITE(*,'(1x,a)') 'Building hypercube ...'
      part_time=DBLE(cputime())
c     compute the number of steps to report the completed percentage
      nsteps=0
      DO ired=1,nred
         DO i=0,nz
            IF (z(i).le.0.) THEN
               ageuni=tz(h0,om,ov,0.D0) ! in Gyr
            ELSE
               ageuni=tz(h0,om,ov,z(i))
            END IF
            DO itype=1,n_files
               IF (sed_abc(itype).eq.'BC') THEN
                  iagemin=2
                  iagemax=ks(itype)
c if age_min and age_max are not in the range of values considered by BC SEDs
c and iage_check=0 then iagemin=2  and iagemax=ks(itype)
                  DO iage=2,ks(itype)
                     IF (age_min.gt.(t_bc(iage-1)*1.D-9).and.
     .                    age_min.le.(t_bc(iage)*1.D-9)) iagemin=iage
                     IF (age_max.gt.(t_bc(iage-1)*1.D-9).and.
     .                    age_max.le.(t_bc(iage)*1.D-9)) iagemax=iage
                  END DO
c free age between age_min and age(z)
                  IF (iage_check.eq.1) THEN 
                     DO iage=2,ks(itype)
                        IF (ageuni-age_form.gt.(t_bc(iage-1)*1.D-9).and.
     .                       ageuni-age_form.le.(t_bc(iage)*1.D-9).and.
c choose the minimum between age(z) and age_max
     .                       ageuni-age_form.le.t_bc(iagemax)*1.D-9) 
     .                       iagemax=iage
                     END DO
c only the two ages around the age(z)
                  ELSE IF (iage_check.eq.2) THEN  
                     iagemin=2
                     iagemax=3
                     DO iage=3,ks(itype)
                        IF (ageuni-age_form.gt.(t_bc(iage-1)*1.D-9).and.
     .                       ageuni-age_form.le.(t_bc(iage)*1.D-9)) THEN
                           iagemin=iage-1
                           iagemax=iage
                        END IF
                     END DO
                  END IF
               ELSE IF (sed_abc(itype).eq.'PG') THEN
                  IF (t_pg(1).lt.1.E-8) THEN ! skip age=0
                     iagemin=2
                  ELSE
                     iagemin=1
                  END IF
                  iagemax=ks(itype)
                  DO iage=iagemin,ks(itype)
                     IF (age_min.gt.(t_pg(iage-1)*1.D-3).and.
     .                    age_min.le.(t_pg(iage)*1.D-3)) iagemin=iage
                     IF (age_max.gt.(t_pg(iage-1)*1.D-3).and.
     .                    age_max.le.(t_pg(iage)*1.D-3)) iagemax=iage
                  END DO
c free age between age_min and age(z)
                  IF (iage_check.eq.1) THEN 
                     DO iage=iagemin,ks(itype)
                        IF (ageuni-age_form.gt.(t_pg(iage-1)*1.D-3).and.
     .                       ageuni-age_form.le.(t_pg(iage)*1.D-3).and.
c choose the minimum between age(z) and age_max
     .                       ageuni-age_form.le.t_pg(iagemax)*1.D-3) 
     .                       iagemax=iage
                     END DO
c only the two ages around the age(z)
                  ELSE IF (iage_check.eq.2) THEN  
                     IF (t_pg(1).lt.1.E-8) THEN ! skip age=0
                        iagemin=2
                     ELSE
                        iagemin=1
                     END IF
                     iagemax=iagemin+1
                     DO iage=iagemin+1,ks(itype)
                        IF (ageuni-age_form.gt.(t_pg(iage-1)*1.D-3).and.
     .                       ageuni-age_form.le.(t_pg(iage)*1.D-3)) THEN
                           iagemin=iage-1
                           iagemax=iage
                        END IF
                     END DO
                  END IF
               ELSE IF (sed_abc(itype).eq.'AS'.or. 
     &                 sed_abc(itype).eq.'A ') THEN
                  iagemin=1
                  iagemax=1
               END IF
               DO iage=iagemin,iagemax
                  DO ilyf=1,nlyf
                     nsteps=nsteps+1
                  END DO
               END DO
            END DO
         END DO
      END DO

      istep=0
      npercent0=0
      WRITE(*,'(a,i4,a)') ' Hypercube: ',25*npercent0,'% done'
      DO ired=1,nred
         av=avmin+(ired-1)*averr
         DO i=0,nz
            IF (z(i).le.0.) THEN
               ageuni=tz(h0,om,ov,0.D0)
            ELSE
               ageuni=tz(h0,om,ov,z(i))
            END IF
            DO itype=1,n_files
               IF (sed_abc(itype).eq.'BC') THEN
                  iagemin=2
                  iagemax=ks(itype)
                  DO iage=2,ks(itype)
                     IF (age_min.gt.(t_bc(iage-1)*1.D-9).and.
     .                    age_min.le.(t_bc(iage)*1.D-9)) iagemin=iage
                     IF (age_max.gt.(t_bc(iage-1)*1.D-9).and.
     .                    age_max.le.(t_bc(iage)*1.D-9)) iagemax=iage
                  END DO
                  IF (iage_check.eq.1) THEN 
                     DO iage=2,ks(itype)
                        IF (ageuni-age_form.gt.(t_bc(iage-1)*1.D-9).and.
     .                       ageuni-age_form.le.(t_bc(iage)*1.D-9).and.
     .                       ageuni-age_form.le.t_bc(iagemax)*1.D-9) 
     .                       iagemax=iage
                     END DO
                  ELSE IF (iage_check.eq.2) THEN  
                     iagemin=2
                     iagemax=3
                     DO iage=3,ks(itype)
                        IF (ageuni-age_form.gt.(t_bc(iage-1)*1.D-9).and.
     .                       ageuni-age_form.le.(t_bc(iage)*1.D-9)) THEN
                           iagemin=iage-1
                           iagemax=iage
                        END IF
                     END DO
                  END IF
               ELSE IF (sed_abc(itype).eq.'PG') THEN
                  IF (t_pg(1).lt.1.E-8) THEN ! skip age=0
                     iagemin=2
                  ELSE
                     iagemin=1
                  END IF
                  iagemax=ks(itype)
                  DO iage=iagemin,ks(itype)
                     IF (age_min.gt.(t_pg(iage-1)*1.D-3).and.
     .                    age_min.le.(t_pg(iage)*1.D-3)) iagemin=iage
                     IF (age_max.gt.(t_pg(iage-1)*1.D-3).and.
     .                    age_max.le.(t_pg(iage)*1.D-3)) iagemax=iage
                  END DO
                  IF (iage_check.eq.1) THEN 
                     DO iage=iagemin,ks(itype)
                        IF (ageuni-age_form.gt.(t_pg(iage-1)*1.D-3).and.
     .                       ageuni-age_form.le.(t_pg(iage)*1.D-3).and.
     .                       ageuni-age_form.le.t_pg(iagemax)*1.D-3) 
     .                       iagemax=iage
                     END DO
                  ELSE IF (iage_check.eq.2) THEN  
                     IF (t_pg(1).lt.1.E-8) THEN ! skip age=0
                        iagemin=2
                     ELSE
                        iagemin=1
                     END IF
                     iagemax=iagemin+1
                     DO iage=iagemin+1,ks(itype)
                        IF (ageuni-age_form.gt.(t_pg(iage-1)*1.D-3).and.
     .                       ageuni-age_form.le.(t_pg(iage)*1.D-3)) THEN
                           iagemin=iage-1
                           iagemax=iage
                        END IF
                     END DO
                  END IF
               ELSE IF (sed_abc(itype).eq.'AS'.or.
     &                 sed_abc(itype).eq.'A ') THEN
                  iagemin=1
                  iagemax=1
               END IF
c -----------------------------------------------------------------------
               DO iage=iagemin,iagemax 
                  IF (sed_abc(itype).eq.'BC') THEN
                     DO k=1,iw(itype)
                        y(k)=f_bc(k,iage,ntyp_bc(itype))
                        ww(k)=DBLE(w_bc(k,ntyp_bc(itype)))
                     END DO
                  ELSE IF (sed_abc(itype).eq.'PG') THEN
                     DO k=1,iw(itype)
                        y(k)=f_pg(k,iage,ntyp_pg(itype))
                        ww(k)=DBLE(w_pg(k,ntyp_pg(itype)))
                     END DO
                  ELSE IF (sed_abc(itype).eq.'AS'.or.
     .                    sed_abc(itype).eq.'A ') THEN
                     DO k=1,iw(itype)
                        y(k)=f_as(k,iage,ntyp_as(itype))
                        ww(k)=DBLE(w_as(k,ntyp_as(itype)))
                     END DO
                  END IF
                  IF (av.gt.0.0.and.law_rd.ne.0) THEN
                     CALL red_spec(ww,y,av,yob,1,iw(itype),law_rd) 
                     DO k=1,iw(itype)
                        y(k)=yob(k)
                     END DO
                  END IF
                  DO ilyf=1,nlyf
                     istep=istep+1
                     frac=DBLE(FLOAT(istep)/FLOAT(nsteps))
                     npercent=INT(frac/0.25D0)
                     IF (npercent.gt.npercent0) THEN
                        WRITE(*,'(a,i4,a)') 
     .                       ' Hypercube: ',25*npercent,'% done'
                        npercent0=npercent
                     END IF
                     fact_lyf=r_lyf**(ilyf-1)*(1.D0/r_lyf)
                     DO k=1,iw(itype)
                        yob(k)=y(k)
                     END DO
c ..... Lyman alpha forest
                     CALL lyman_forest(ww,yob,iw(itype),z(i))
                     DO k=1,n_filt+1
                        flux(k,i,iage,itype,ired,ilyf)=
     .                       filter(k,ww,yob,iw(itype),z(i))
                     END DO
                  END DO
               END DO
            END DO
         END DO
      END DO

c      WRITE(*,'(1x,a)') '                      ... done'
      part_time=DBLE(cputime())-part_time
      WRITE(*,'(1X,A,F12.3,A)') 'CPU time involved : ',part_time,
     .     ' seconds'
c -----------------------------------------------------------------------
c                          Loop over the objects 
c -----------------------------------------------------------------------
      WRITE(*,'(1x,a)') 'I''m working ...'

      IF (ccat.eq.'y'.or.ccat.eq.'Y') 
     .     OPEN(10,FILE=spectra1,STATUS='unknown',ERR=81)
      IF (clog.eq.'y'.or.clog.eq.'Y')
     .     OPEN(14,FILE=spectra2,STATUS='unknown',ERR=81)
      IF (csed1.eq.'y'.or.csed1.eq.'Y')
     .     OPEN(15,FILE=spectra3,STATUS='unknown',ERR=81)
      IF (cz.eq.'y'.or.cz.eq.'Y') THEN
         OPEN(17,FILE=spectra4,STATUS='unknown',ERR=81)
         WRITE(17,'(a)') 
     .        '#       ID  redshift    chi2 P_chi2 iSED iage '
     .        //'age[Gyr] A_V      norm zp99_l zp99_h zp90_l zp90_h '
     .        //'zp68_l zp68_h  zp_wm P(zp_wm)  Mabs   ly_f    zp2  '
     .        //'P(zp2)'
      END IF
      IF (csed2.eq.'y'.or.csed2.eq.'Y')
     .     OPEN(19,FILE=spectra5,STATUS='unknown',ERR=81)

      WRITE(fmt1,2006) n_filt,n_filt
      WRITE(fmt2,2007) n_filt,n_filt
      WRITE(fmt3,2010) n_filt
      WRITE(fmt4,2011) n_filt
 2006 FORMAT('(1x,i12,',i2,'(1x,F8.4),',i2,'(1x,F8.4))')
 2007 FORMAT('(1x,i12,',i2,'(1x,ES12.5),',i2,'(1x,ES12.5))')
 2010 FORMAT('(1x,i12,',i2,'(1x,F8.4))')
 2011 FORMAT('(1x,i12,',i2,'(1x,ES12.5))')

      OPEN(16,FILE=cat_in,STATUS='old',ERR=79)
      IF (header) THEN
         DO i=1,n_head
            READ(16,'(A)') header_line
         END DO
      END IF
      iob=0
13400 CONTINUE
      iob=iob+1
      IF (icat.eq.0) THEN
         READ(16,*,ERR=13500,END=13500) id,(rmag(i),i=1,n_filt),
     .        (rerr_p(i),i=1,n_filt)
      ELSE IF (icat.eq.1) THEN
         READ(16,*,ERR=13500,END=13500) id,z1,z2,(rmag(i),i=1,n_filt),
     .        (rerr_p(i),i=1,n_filt)
      END IF
      DO iii=1,n_filt
         IF (((magtyp.eq.0.or.magtyp.eq.1).and.
     .        (rmag(iii).lt.90.0.and.rmag(iii).gt.1.)).or.
     .        (magtyp.eq.2.and.rmag(iii).ge.0.)) GO TO 13401
      END DO
      WRITE(*,*) 'WARNING: non detected object id ', id
c ..... Write outputs in any case (except .m and .spe)
c ..... File .z_phot
      zphot(1)=99.D0
      r_chi2=99.D0
      qq=0.D0
      itypem=0
      iagem=0
      age=99.D0
      av=0.D0
      bb(1)=0.D0
      DO i=1,3
         zz1(i)=99.D0
         zz2(i)=99.D0
      END DO
      z_poids=99.D0
      qq_p=0.D0
      amagb=99.D0
      zphot(2)=99.D0
      qq2=0.D0
      amagb_clus=99.D0
      p_clus=0.D0
      amag(1)=99.D0
      i_sol=1
      fact_lyf=1.D0
      IF (z_clus.ge.0.D0) THEN
         IF (cz.eq.'y'.or.cz.eq.'Y') WRITE(17,2009) id,zphot(1),r_chi2,
     .        qq,itypem,iagem,age,av,bb(1),zz1(1),zz2(1),zz1(2),
     .        zz2(2),zz1(3),zz2(3),z_poids,qq_p,amagb,fact_lyf,zphot(2),
     .        qq2,amagb_clus,p_clus,amag(1)
      ELSE
        IF (cz.eq.'y'.or.cz.eq.'Y') WRITE(17,2008) id,zphot(1),r_chi2,
     .        qq,itypem,iagem,age,av,bb(1),zz1(1),zz2(1),zz1(2),
     .        zz2(2),zz1(3),zz2(3),z_poids,qq_p,amagb,fact_lyf,
     .        zphot(2),qq2
      END IF
c ..... File .cat_phot
      IF (ccat.eq.'y'.or.ccat.eq.'Y') WRITE(10,2001) id,zphot(1),r_chi2,
     .     qq,itypem,iagem,age,av,bb(1),zz1(1),zz2(1),zz1(2),
     .     zz2(2),zz1(3),zz2(3),z_poids,qq_p,amagb,fact_lyf,i_sol
c ..... File .log_phot
      IF(clog.eq.'y'.or.clog.eq.'Y') THEN
         DO i=1,nz
            WRITE(14,2002) id,z(i),r_chi2,qq,itypem,age,av,fact_lyf
         END DO
      END IF
c ..... File .obs_sed
      IF (csed1.eq.'y'.or.csed1.eq.'Y') THEN
         DO i=1,n_filt
            fl1(i)=-1.D0
            err_fl(i)=0.D0
            amag(i)=99.D0
            err_p(i)=99.D0
         END DO
         IF (iunit_sed.eq.0.or.iunit_sed.eq.1) THEN
            WRITE(15,fmt2) id,(fl1(i),i=1,n_filt),
     .           (err_fl(i),i=1,n_filt)
         ELSE IF (iunit_sed.eq.2) THEN
            WRITE(15,fmt1) id,(amag(i),i=1,n_filt),
     .           (err_p(i),i=1,n_filt)
         END IF
      END IF
c ..... File .temp_sed
      IF (csed2.eq.'y'.or.csed2.eq.'Y') THEN 
         DO k=1,n_filt
            mag_temp(k)=99.D0
            fl_temp(k)=-1.D0
         END DO
         IF (iunit_sed.eq.0.or.iunit_sed.eq.1) THEN
            WRITE(19,fmt4) id,(fl_temp(k),k=1,n_filt)
         ELSE IF (iunit_sed.eq.2) THEN
            WRITE(19,fmt3) id,(mag_temp(k),k=1,n_filt)
         END IF
      END IF

      GO TO 13400
         
c ..... Computing the fluxes and errors in the filters
13401 iw_ob=0
      DO iii=1,n_filt
         amag(iii)=DBLE(rmag(iii))
         err_p(iii)=DBLE(rerr_p(iii))
         i_lyman(iii)=0
         sn=-1.D0
c ..... check the S/N in each filter if mag is detected
         IF (((magtyp.eq.0.or.magtyp.eq.1).and.amag(iii).gt.0.D0
     &        .and.amag(iii).lt.90.D0.and.err_p(iii).lt.90.D0.and.
     &        err_p(iii).gt.0.D0).or.(magtyp.eq.2.and.
     &        amag(iii).gt.0.D0.and.err_p(iii).gt.0.D0)) THEN 
            IF (magtyp.eq.0.or.magtyp.eq.1) THEN
               IF (err_p(iii).lt.err_min) THEN ! avoid to divide by zero
                  sn=(2.5D0/DLOG(10.D0))/err_min
               ELSE
                  sn=(2.5D0/DLOG(10.D0))/err_p(iii)
               END IF
            ELSE
               IF (err_p(iii).lt.err_min) THEN ! avoid to divide by zero
                  sn=amag(iii)/err_min
               ELSE
                  sn=amag(iii)/err_p(iii)
               END IF
            END IF
            IF (sn.lt.sn_lim) THEN ! don't use the filter
               amag(iii)=-99.D0
               err_p(iii)=99.D0
            END IF
         END IF
c photometric errors
         IF (law_err.eq.0) THEN
            IF (err_p(iii).lt.err_min) err_p(iii)=err_min
         ELSE IF (law_err.eq.1) THEN
c added in quadrature
            err_p(iii)=DSQRT(err_min**2+err_p(iii)**2)
         ELSE IF (law_err.eq.2) THEN
c added in quadrature with values given filter by filter
            err_p(iii)=DSQRT(err_minf(iii)**2+err_p(iii)**2)
            IF (err_p(iii).lt.err_min) err_p(iii)=err_min
         END IF

c ..... Detected object in filter iii - Vega or AB magnitudes
         IF ((magtyp.eq.0.or.magtyp.eq.1).and.
     .        (amag(iii).gt.1.D0.and.amag(iii).lt.90.D0).and.
     .        err_p(iii).lt.90.D0) THEN
            iw_ob=iw_ob+1
c Vega mag -> erg/cm2/s/A
            IF (magtyp.eq.0) fl(iii)=vega(iii)*
     .           10**(-0.4D0*(amag(iii)+c_corr(iii)))/surf(iii) 
c AB mag -> erg/cm2/s/Hz
            IF (magtyp.eq.1) fl(iii)=10**(-0.4D0*(amag(iii)+
     &           c_corr(iii)+48.6D0))
            err_fl(iii)=0.4D0*DLOG(10.D0)*fl(iii)*err_p(iii)
c amag1: reference Vega or AB magnitude for absolute magnitudes
            amag1(iii)=amag(iii)+c_corr(iii)
c ..... Detected object in filter iii - flux in microJansky
        ELSE IF (magtyp.eq.2.and.amag(iii).ge.0.D0
     .           .and.err_p(iii).ge.0.D0) THEN ! input in muJy
            iw_ob=iw_ob+1
            f_jy(iii)=amag(iii)
            err_jy(iii)=err_p(iii)
c muJy -> erg/cm2/s/Hz
            fl(iii)=(amag(iii)+c_corr(iii))*1.D-29
            err_fl(iii)=err_p(iii)*1.D-29
c amag: flux[muJy] -> AB magnitude
            amag1(iii)=-2.5*DLOG10(fl(iii))-48.60
c dereddening
            IF (ebv_mw.gt.0.D0) THEN
               CALL red_spec(wl(iii),fl(iii),av_mw,yob,2,1,1)
               fl(iii)=yob(1)
            END IF
c ..... Detected object in filter iii as upper limit - Vega or AB magnitudes
c       use non detection law 2
         ELSE IF ((magtyp.eq.0.or.magtyp.eq.1).and.
     .           (amag(iii).gt.1.D0.and.amag(iii).lt.90.D0).and.
     .           err_p(iii).gt.90.D0) THEN
            iw_ob=iw_ob+1
            IF (magtyp.eq.0) fl(iii)=vega(iii)*
     .           10**(-0.4D0*(amag(iii)+c_corr(iii)))/surf(iii) 
            IF (magtyp.eq.1) fl(iii)=10**(-0.4D0*(amag(iii)+
     &           c_corr(iii)+48.6D0))
            fl(iii)=0.5D0*fl(iii)
            err_fl(iii)=fl(iii)
            i_lyman(iii)=1
c amag1: reference Vega or AB magnitude for absolute magnitudes
               amag1(iii)=amag(iii)+c_corr(iii)
c ..... Detected object in filter iii as upper limit - flux in microJansky
c       use non detection law 2
         ELSE IF (magtyp.eq.2.and.amag(iii).ge.0..and.
     .           err_p(iii).lt.0.) THEN 
            iw_ob=iw_ob+1
            fl(iii)=(amag(iii)+c_corr(iii))*1.D-29
            err_fl(iii)=err_p(iii)*1.D-29
            amag1(iii)=-2.5*DLOG10(fl(iii))-48.60
            fl(iii)=0.5D0*fl(iii)
            err_fl(iii)=fl(iii)
            f_jy(iii)=0.5D0*amag(iii)
            err_jy(iii)=f_jy(iii)
            i_lyman(iii)=1

c ..... Non observed object in filter iii - Vega or AB magnitudes
         ELSE IF ((magtyp.eq.0.or.magtyp.eq.1).and.
     .           amag(iii).le.1.D0) THEN ! out of file objects
            fl(iii)=-1.0D0
            err_fl(iii)=0.0D0
            amag1(iii)=-1.0D0

c ..... Non observed object in filter iii - flux in microJansky
         ELSE IF (magtyp.eq.2.and.ABS(amag(iii)+1.D0).lt.1.D-6) THEN 
            fl(iii)=-1.0D0
            err_fl(iii)=0.0D0
            amag1(iii)=-1.0D0
            f_jy(iii)=-1.0D0
            err_jy(iii)=0.0D0

c ..... Non detected object in filter iii - Vega or AB magnitudes or flux 
c       use selected non detection law and input limiting magnitude or flux
         ELSE IF (((magtyp.eq.0.or.magtyp.eq.1).and.
     .           amag(iii).ge.90.D0).or.
     .           (magtyp.eq.2.and.amag(iii).lt.-90.D0)) THEN 
c ..... Non detection laws: 
c       0. the filter will not be used
c       1. the flux in the filter is set = 0 with 
c          photometric error = limiting flux 
c       2. the flux in the filter and the photometric error are set =
c          0.5*limiting flux
c       3. the flux in the filter is = limiting flux and the photometric
c          error is computed from column 5 of the parameter file
c       4. the filter will not be used in chi2, but solutions with 
c          flux > limiting flux will be rejected
            IF (law_nd(iii).eq.0) THEN
               fl(iii)=-1.0D0
               err_fl(iii)=0.D0
               amag1(iii)=99.D0
               f_jy(iii)=-1.0D0
               err_jy(iii)=0.D0
            ELSE IF (law_nd(iii).eq.1) THEN
               fl(iii)=0.D0
               err_fl(iii)=fl_nd(iii)
               amag1(iii)=99.D0
               i_lyman(iii)=2
               iw_ob=iw_ob+1
            ELSE IF (law_nd(iii).eq.2) THEN
               fl(iii)=0.5D0*fl_nd(iii)
               err_fl(iii)=fl(iii)
               amag1(iii)=99.D0
               i_lyman(iii)=1
               iw_ob=iw_ob+1
            ELSE IF (law_nd(iii).eq.3) THEN
               fl(iii)=fl_nd(iii)
               err_p(iii)=err_nd(iii)
               amag1(iii)=99.D0
               IF (magtyp.eq.0.or.magtyp.eq.1) THEN
                  err_fl(iii)=0.4D0*DLOG(10.D0)*fl(iii)*err_p(iii)
               ELSE
                  err_fl(iii)=err_p(iii)*1.D-29
               END IF
               i_lyman(iii)=1
               iw_ob=iw_ob+1
            ELSE IF (law_nd(iii).eq.4) THEN
               fl(iii)=-1.D0
               err_fl(iii)=0.D0
               amag1(iii)=99.D0
               i_lyman(iii)=2
            END IF
         END IF
      END DO

      ndeg=iw_ob-1  ! degrees of freedom
      deg=DBLE(REAL(ndeg))

      IF (ndeg.lt.1) THEN
         WRITE(*,'(a,i12)') 
     &        'WARNING: impossible to compute object ID = ',id
c ..... Write outputs in any case (except .m and .spe)
c ..... File .z_phot
         zphot(1)=99.D0
         r_chi2=99.D0
         qq=0.D0
         itypem=0
         iagem=0
         age=99.D0
         av=0.D0
         bb(1)=0.D0
         DO i=1,3
            zz1(i)=99.D0
            zz2(i)=99.D0
         END DO
         z_poids=99.D0
         qq_p=0.D0
         amagb=99.D0
         zphot(2)=99.D0
         qq2=0.D0
         amagb_clus=99.D0
         p_clus=0.D0
         amag(1)=99.D0
         i_sol=1
         fact_lyf=1.D0
         IF (z_clus.ge.0.D0) THEN
            IF (cz.eq.'y'.or.cz.eq.'Y') WRITE(17,2009) id,zphot(1),
     .           r_chi2,qq,itypem,iagem,age,av,bb(1),zz1(1),zz2(1),
     .           zz1(2),zz2(2),zz1(3),zz2(3),z_poids,qq_p,amagb,
     .           fact_lyf,zphot(2),qq2,amagb_clus,p_clus,amag(1)
         ELSE
            IF (cz.eq.'y'.or.cz.eq.'Y') WRITE(17,2008) id,zphot(1),
     .           r_chi2,qq,itypem,iagem,age,av,bb(1),zz1(1),zz2(1),
     .           zz1(2),zz2(2),zz1(3),zz2(3),z_poids,qq_p,amagb,
     .           fact_lyf,zphot(2),qq2
         END IF
c ..... File .cat_phot
         IF (ccat.eq.'y'.or.ccat.eq.'Y') WRITE(10,2001) id,zphot(1),
     .        r_chi2,qq,itypem,iagem,age,av,bb(1),zz1(1),zz2(1),zz1(2),
     .        zz2(2),zz1(3),zz2(3),z_poids,qq_p,amagb,fact_lyf,i_sol
c ..... File .log_phot
         IF(clog.eq.'y'.or.clog.eq.'Y') THEN
            DO i=1,nz
               WRITE(14,2002) id,z(i),r_chi2,qq,itypem,age,av,fact_lyf
            END DO
         END IF
c ..... File .obs_sed
         IF (csed1.eq.'y'.or.csed1.eq.'Y') THEN
            DO i=1,n_filt
               fl1(i)=-1.D0
               err_fl(i)=0.D0
               amag(i)=99.D0
               err_p(i)=99.D0
            END DO
            IF (iunit_sed.eq.0.or.iunit_sed.eq.1) THEN
               WRITE(15,fmt2) id,(fl1(i),i=1,n_filt),
     .              (err_fl(i),i=1,n_filt)
            ELSE IF (iunit_sed.eq.2) THEN
               WRITE(15,fmt1) id,(amag(i),i=1,n_filt),
     .              (err_p(i),i=1,n_filt)
            END IF
         END IF
c ..... File .temp_sed
         IF (csed2.eq.'y'.or.csed2.eq.'Y') THEN 
            DO k=1,n_filt
               mag_temp(k)=99.D0
               fl_temp(k)=-1.D0
            END DO
            IF (iunit_sed.eq.0.or.iunit_sed.eq.1) THEN
               WRITE(19,fmt4) id,(fl_temp(k),k=1,n_filt)
            ELSE IF (iunit_sed.eq.2) THEN
               WRITE(19,fmt3) id,(mag_temp(k),k=1,n_filt)
            END IF
         END IF

         GO TO 13400
      END IF
c -----------------------------------------------------------------------
c                         Computation 
c -----------------------------------------------------------------------
c ..... Open file for the matrix of results (if case)
      matrix=0
      WRITE(root,'(i12)') id
      DO k=1,12
         IF (root(k:k).ne.' ') THEN
            root=root(k:)
            GO TO 22
         END IF
      END DO
 22   iroot=INDEX(root,' ')-1
      IF (iout_m.gt.1) THEN
         amatrix=root(1:iroot)//'.m'
         matrix=1
         OPEN(11,FILE=amatrix,STATUS='unknown')
      END IF

      IF (icat.eq.1) THEN
         DO i=1,nz-1
            IF (z1.ge.z(i).and.z1.lt.z(i+1)) i1=i
            IF (z2.gt.z(i).and.z2.le.z(i+1)) i2=i+1
         END DO
         IF (z2.gt.z(nz)) i2=nz
      ELSE IF (icat.eq.0) THEN
         i1=1
         i2=nz
      END IF

      IF (z_clus.ge.0.D0) THEN
         DO i=1,nz-1
            IF (z_clus.ge.z(i).and.z_clus.lt.z(i+1)) iz_clus=i
         END DO
         IF (z_clus.eq.z(nz)) iz_clus=nz
      END IF
c -----------------------------------------------------------------------
      DO i=i1,i2                                 !Scan in z
c -----------------------------------------------------------------------
         z_min_array(i)=1.D+30
         i_typ(i)=1
         i_age(i)=2
         i_red(i)=1
         IF (z(i).le.0.) THEN
            ageuni=tz(h0,om,ov,0.D0)
         ELSE
            ageuni=tz(h0,om,ov,z(i))
         END IF
         dif_w_min=1.D12
         n_fil_wa=1
         DO k=1,n_filt
            dif_w=ABS(wl(k)-wl(ifilt)*(z_clus+1.D0))
            IF (((magtyp.eq.0.or.magtyp.eq.1).and.
     .           (amag(k).gt.1.D0.and.amag(k).lt.90.D0)).or.
     .           (magtyp.eq.2.and.amag(k).gt.0.D0)) THEN
               IF (dif_w.lt.dif_w_min) THEN 
                  dif_w_min=dif_w
                  n_fil_wa=k
               END IF
            END IF
         END DO
c -----------------------------------------------------------------------
         DO itype=1,n_files     !Scan types
            IF (sed_abc(itype).eq.'BC') THEN
               iagemin=2
               iagemax=ks(itype)
               DO iage=2,ks(itype)
                  IF (age_min.gt.(t_bc(iage-1)*1.D-9).and.
     .                 age_min.le.(t_bc(iage)*1.D-9)) iagemin=iage
                  IF (age_max.gt.(t_bc(iage-1)*1.D-9).and.
     .                 age_max.le.(t_bc(iage)*1.D-9)) iagemax=iage
               END DO
               IF (iage_check.eq.1) THEN 
                  DO iage=2,ks(itype)
                     IF (ageuni-age_form.gt.(t_bc(iage-1)*1.D-9).and.
     .                    ageuni-age_form.le.(t_bc(iage)*1.D-9).and.
     .                    ageuni-age_form.le.t_bc(iagemax)*1.D-9) 
     .                    iagemax=iage
                  END DO
               ELSE IF (iage_check.eq.2) THEN  
                  iagemin=2
                  iagemax=3
                  DO iage=3,ks(itype)
                     IF (ageuni-age_form.gt.(t_bc(iage-1)*1.D-9).and.
     .                    ageuni-age_form.le.(t_bc(iage)*1.D-9)) THEN
                        iagemin=iage-1
                        iagemax=iage
                     END IF
                  END DO
               END IF
            ELSE IF (sed_abc(itype).eq.'PG') THEN
               IF (t_pg(1).lt.1.E-8) THEN ! skip age=0
                  iagemin=2
               ELSE
                  iagemin=1
               END IF
               iagemax=ks(itype)
               DO iage=iagemin,ks(itype)
                  IF (age_min.gt.(t_pg(iage-1)*1.D-3).and.
     .                 age_min.le.(t_pg(iage)*1.D-3)) iagemin=iage
                  IF (age_max.gt.(t_pg(iage-1)*1.D-3).and.
     .                 age_max.le.(t_pg(iage)*1.D-3)) iagemax=iage
               END DO
               IF (iage_check.eq.1) THEN 
                  DO iage=iagemin,ks(itype)
                     IF (ageuni-age_form.gt.(t_pg(iage-1)*1.D-3).and.
     .                    ageuni-age_form.le.(t_pg(iage)*1.D-3).and.
     .                    ageuni-age_form.le.t_pg(iagemax)*1.D-3) 
     .                    iagemax=iage
                  END DO
               ELSE IF (iage_check.eq.2) THEN  
                  IF (t_pg(1).lt.1.E-8) THEN ! skip age=0
                     iagemin=2
                  ELSE
                     iagemin=1
                  END IF
                  iagemax=iagemin+1
                  DO iage=iagemin+1,ks(itype)
                     IF (ageuni-age_form.gt.(t_pg(iage-1)*1.D-3).and.
     .                    ageuni-age_form.le.(t_pg(iage)*1.D-3)) THEN
                        iagemin=iage-1
                        iagemax=iage
                     END IF
                  END DO
               END IF
            ELSE IF (sed_abc(itype).eq.'AS'.or.
     &              sed_abc(itype).eq.'A ') THEN
               iagemin=1
               iagemax=1
            END IF
c -----------------------------------------------------------------------
            DO iage=iagemin,iagemax ! Scan ages
c -----------------------------------------------------------------------
               DO ired=1,nred   ! Scan reddening
c -----------------------------------------------------------------------
                  DO ilyf=1,nlyf ! Scan Lyman Forest
                     fact_lyf=r_lyf**(ilyf-1)*(1.D0/r_lyf)
c -----------------------------------------------------------------------
                     av=avmin+(ired-1)*averr
                     sxx=0.D0
                     sxy=0.D0
                     b=0.D0
c ..... Probability for z(i), iage, itype, ired, ilyf
                     DO k=1,n_filt
                        IF (magtyp.eq.0) THEN 
                           fluxn(k)=flux(k,i,iage,itype,ired,ilyf)/
     .                          surf(k)
                        ELSE IF (magtyp.eq.1.or.magtyp.eq.2) THEN
                           fluxn(k)=flux(k,i,iage,itype,ired,ilyf)/
     .                          f2(k)
                        END IF
                        IF (fl(k).ge.0.) THEN ! no oof objects
                           IF (flux(k,i,iage,itype,ired,ilyf).lt.1.D-12
     .                          .and.i_lyman(k).eq.1) THEN
                              fl1(k)=0.D0
                           ELSE
                              fl1(k)=fl(k)
                              wt=1.D0/(err_fl(k)**2)
                              sxx=sxx+fluxn(k)*fluxn(k)*wt
                              sxy=sxy+fl1(k)*wt*fluxn(k)
                           END IF
                        ELSE
                           fl1(k)=-1.D0
                        END IF
                     END DO
                     b=sxy/sxx
                     chi2=0.D0
                     DO k=1,n_filt
                        IF (fl1(k).ge.0.D0) THEN ! no oof obj.
                           chi2=chi2+((fl1(k)-b*fluxn(k))/err_fl(k))**2
                        END IF
                     END DO
                     IF (nlyf.gt.1.and.fact_lyf.eq.1..and. 
     .                    ABS(chi2-z_min_array(i)).lt.err) THEN
                        z_min_array(i)=chi2
                        bb_array(i)=b
                        i_typ(i)=itype
                        i_age(i)=iage
                        i_red(i)=ired
                        i_lyf(i)=ilyf
                     ELSE IF (chi2-z_min_array(i).lt.0.D0) THEN
                        z_min_array(i)=chi2
                        bb_array(i)=b
                        i_typ(i)=itype
                        i_age(i)=iage
                        i_red(i)=ired
                        i_lyf(i)=ilyf
                     END IF
                     IF (z_clus.ge.0..and.i.eq.iz_clus) THEN
                        itypea=itype
                        iagea=iage
                        ireda=ired
                        ilyfa=ilyf
                     END IF

                     IF (sed_abc(itype).eq.'BC') THEN
                        age=t_bc(iage)*1.D-9
                     ELSE IF (sed_abc(itype).eq.'AS'.or.
     .                       sed_abc(itype).eq.'A ') THEN
                        age=19.9999D0
                     ELSE IF (sed_abc(itype).eq.'PG') THEN
                        age=t_pg(iage)*1.D-3
                     END IF
                     IF (matrix.gt.0) THEN
                        r_chi2=chi2/deg ! reduced chi2
                        WRITE(11,2012) id,z(i),itype,iage,age,av,
     .                       fact_lyf,r_chi2
                     END IF
                  END DO
               END DO
            END DO
         END DO

         q_pro(i)=100.D0*qchi2(0.5D0*deg,0.5D0*z_min_array(i))
         
         IF (sed_abc(i_typ(i)).eq.'BC') THEN
            age=t_bc(i_age(i))*1.D-9
         ELSE IF (sed_abc(i_typ(i)).eq.'AS'.or.
     .           sed_abc(i_typ(i)).eq.'A ') THEN
            age=19.9999D0
         ELSE IF (sed_abc(itype).eq.'PG') THEN
            age=t_pg(iage)*1.D-3
          END IF
         
         r_chi2=z_min_array(i)/deg ! reduced chi2
         fact_lyf=r_lyf**(i_lyf(i)-1)*(1.D0/r_lyf)

         IF(clog.eq.'y'.or.clog.eq.'Y') THEN
            WRITE(14,2002) id,z(i),r_chi2,q_pro(i),i_typ(i),age,
     .                     avmin+(i_red(i)-1)*averr,fact_lyf
         END IF

      END DO
      CLOSE(11)                 !close output matrix
c -----------------------------------------------------------------------
c                     End scan
c -----------------------------------------------------------------------
c ..... Searching minima of chi2
      n_sol=0
      DO i=i1,i2
         dif_w_min=1.D12
         n_fil_w(i)=1
         DO k=1,n_filt
            dif_w=ABS(wl(k)-wl(ifilt)*(z(i)+1.D0))
            IF ((magtyp.eq.0.or.magtyp.eq.1).and.
     .           amag(k).gt.1.D0.and.amag(k).lt.90.D0
     .           .and.i_lyman(k).lt.1) THEN
               IF (dif_w.lt.dif_w_min) THEN   
                  dif_w_min=dif_w 
                  n_fil_w(i)=k  
               END IF
            ELSE IF (magtyp.eq.2.and.amag(k).ge.0.D0) THEN
               IF (dif_w.lt.dif_w_min) THEN   
                  dif_w_min=dif_w 
                  n_fil_w(i)=k  
               END IF
            END IF
         END DO
         dd=1.D0
         IF (i.eq.i1) THEN
            dd=z_min_array(i1)-z_min_array(i1+1)
            d1=z_min_array(i1)-z_min_array(i1+1)
         ELSE IF (i.eq.i2) THEN
            dd=z_min_array(i2)-z_min_array(i2-1)
            d1=z_min_array(i2)-z_min_array(i2-1)
         ELSE
            d1=z_min_array(i)-z_min_array(i-1)
            d2=z_min_array(i+1)-z_min_array(i)
            IF (d1.ne.0.D0) dd=d2/d1
         END IF
         IF (dd.le.0.D0.and.d1.lt.0.D0) THEN ! dd < 0 extrema
            n_sol=n_sol+1
            izphot(n_sol)=i
         END IF
      END DO

c ..... Refinement around minima
      DO i=1,n_sol
         izsol=izphot(i)
         IF (izsol.eq.i1) THEN
            dz_f=(z(izsol+1)-z(izsol))/10.D0
            zmax_f=z(izsol+1)
            zmin_f=z(izsol)
         ELSE IF (izsol.eq.i2) THEN
            dz_f=(z(izsol)-z(izsol-1))/10.D0
            zmax_f=z(izsol)
            zmin_f=z(izsol-1)
         ELSE
            dz_f=(z(izsol+1)-z(izsol-1))/20.D0
            zmax_f=z(izsol+1)
            zmin_f=z(izsol-1)
         END IF
         IF (zmin_f.lt.z(i1)) zmin_f=z(i1)
         IF (zmax_f.gt.z(i2)) zmax_f=z(i2)
         av=avmin+(i_red(izsol)-1)*averr
         fact_lyf=r_lyf**(i_lyf(izsol)-1)*(1.D0/r_lyf)
         itypem=i_typ(izsol)
         iagem=i_age(izsol)
c SED itypem
         IF (sed_abc(i_typ(izsol)).eq.'BC') THEN
            DO k=1,iw(itypem) 
               y(k)=f_bc(k,iagem,ntyp_bc(itypem)) !age et type minimum
               ww(k)=DBLE(w_bc(k,ntyp_bc(itypem)))
            END DO
         ELSE IF (sed_abc(i_typ(izsol)).eq.'AS'.or.
     &           sed_abc(i_typ(izsol)).eq.'A ') THEN
            DO k=1,iw(itypem) 
               y(k)=f_as(k,iagem,ntyp_as(itypem)) !age et type minimum
               ww(k)=DBLE(w_as(k,ntyp_as(itypem)))
            END DO
         ELSE IF (sed_abc(i_typ(izsol)).eq.'PG') THEN
            DO k=1,iw(itypem) 
               y(k)=f_pg(k,iagem,ntyp_pg(itypem)) !age et type minimum
               ww(k)=DBLE(w_pg(k,ntyp_pg(itypem)))
            END DO
         END IF
         IF (av.gt.0.D0.and.law_rd.ne.0) THEN
            CALL red_spec(ww,y,av,yob,1,iw(itypem),law_rd)
            DO k=1,iw(itypem)
               y(k)=yob(k)
            END DO
         END IF

c refine solution using the SED itypem
         nz_f=NINT((zmax_f-zmin_f)/dz_f)+1
         chi2=1.D+12
         DO j=2,nz_f-1          !Scan in z excluding limits of range
            zz=zmin_f+(j-1)*dz_f
            DO k=1,iw(itypem)
               yob(k)=y(k)
            END DO
            CALL lyman_forest(ww,yob,iw(itypem),zz)
            dif(j)=0.0D0
            sxx=0.D0
            sxy=0.D0
            b=0.D0
            DO k=1,n_filt
               IF (magtyp.eq.1.or.magtyp.eq.2) THEN
                  fluxn(k)=filter(k,ww,yob,iw(itypem),zz)/f2(k)
               ELSE
                  fluxn(k)=filter(k,ww,yob,iw(itypem),zz)/surf(k)
               END IF
            END DO
            DO k=1,n_filt
               IF (fl(k).ge.0.) THEN ! no oof objects
                  IF (fluxn(k).lt.1.D-12.and.i_lyman(k).eq.1) THEN
                     fl1(k)=0.D0
                  ELSE
                     fl1(k)=fl(k)
                     wt=1.D0/(err_fl(k)*err_fl(k))
                     sxx=sxx+(fluxn(k)*fluxn(k))*wt
                     sxy=sxy+fluxn(k)*fl1(k)*wt
                  END IF
               ELSE
                  fl1(k)=-1.D0
               END IF
            END DO
            b=sxy/sxx
            DO k=1,n_filt
               IF (fl1(k).ge.0.D0) THEN ! no oof objects
                  dif(j)=dif(j)+((fl1(k)-b*fluxn(k))/err_fl(k))**2
               END IF
            END DO
            IF (dif(j).lt.chi2) THEN
               chi2=dif(j)
               i_min=j
               bm=b
            END IF
         END DO
         zop=zmin_f+(i_min-1)*dz_f

         IF (izsol.eq.i1.or.izsol.eq.i2) THEN 
            IF (chi2.lt.z_min_array(izsol)) THEN
               zphot(i)=zop
               chi2sol(i)=chi2
               bb(i)=bm
            ELSE 
               zphot(i)=z(izsol)
               chi2sol(i)=z_min_array(izsol)
               bb(i)=bb_array(izsol)
            END IF
         ELSE
            zphot(i)=zop
            chi2sol(i)=chi2
            bb(i)=bm
         END IF
      END DO

c ..... Ordering solutions
      DO i=2,n_sol
         IF (chi2sol(i).lt.chi2sol(i-1)) THEN
            DO j=i-1,1,-1
               IF (chi2sol(j+1).lt.chi2sol(j)) THEN
                  dummy=chi2sol(j+1)
                  chi2sol(j+1)=chi2sol(j)
                  chi2sol(j)=dummy
                  dummy=zphot(j+1)
                  zphot(j+1)=zphot(j)
                  zphot(j)=dummy
                  idum=izphot(j+1)
                  izphot(j+1)=izphot(j)
                  izphot(j)=idum
                  ddummy=bb(j+1)
                  bb(j+1)=bb(j)
                  bb(j)=ddummy
               END IF
            END DO
         END IF
      END DO

c ..... Check absolute magnitude of the first solution
c       if amagb not in [amabs_1,amabs_2] search the next 
c       solution satisfying constraint
      DO i=1,nz
         iforbid(i)=0
      END DO
      iz=izphot(1)
c Absolute magnitude:
c 0. use the nearest observed filter to minimize k-correction
c 1. compute directly from the SED best fit 
      IF (sed_abc(i_typ(iz)).eq.'BC') THEN
         DO k=1,iw(i_typ(iz))
            y(k)=f_bc(k,i_age(iz),ntyp_bc(i_typ(iz)))
            ww(k)=DBLE(w_bc(k,ntyp_bc(i_typ(iz))))
         END DO
      ELSE IF (sed_abc(i_typ(iz)).eq.'PG') THEN
         DO k=1,iw(i_typ(iz))
            y(k)=f_pg(k,i_age(iz),ntyp_pg(i_typ(iz)))
            ww(k)=DBLE(w_pg(k,ntyp_pg(i_typ(iz))))
         END DO
      ELSE IF (sed_abc(i_typ(iz)).eq.'AS'.or.
     .        sed_abc(i_typ(iz)).eq.'A ') THEN
         DO k=1,iw(i_typ(iz))
            y(k)=f_as(k,i_age(iz),ntyp_as(i_typ(iz)))
            ww(k)=DBLE(w_as(k,ntyp_as(i_typ(iz))))
         END DO
      END IF
      av=avmin+(i_red(iz)-1)*averr
      IF (av.gt.0.0) THEN
         CALL red_spec(ww,y,av,yob,1,iw(i_typ(iz)),law_rd) 
         DO k=1,iw(i_typ(iz))
            y(k)=yob(k)
         END DO
      END IF
      CALL lyman_forest(ww,y,iw(i_typ(iz)),zphot(1))
c distance modulus
      IF (zphot(1).lt.1.D-4) THEN
         dl=0.D0
      ELSE
         dl=d_l(h0,om,ov,zphot(1))    !luminosity distance in Mpc
      END IF
      IF (dl.gt.0.D0) dmod=5.D0*DLOG10(dl)+25.D0
c minimum dmod: corresponding to d(~M31)=1000 Kpc
      IF (dmod.lt.25.D0) dmod=25.D0
c Absolute magnitude:
c 0. use the nearest observed filter to minimize k-correction
c 1. compute directly from the SED best fit 
      amagb=99.
      flux0=filter(ifilt,ww,y,iw(i_typ(iz)),0.D0)
      IF (imabs.eq.0) THEN      ! use the nearest rest frame filter 
         IF (flux(n_fil_w(iz),iz,i_age(iz),i_typ(iz),i_red(iz),
     &        i_lyf(iz)).gt.0.D0) THEN
            IF (magtyp.eq.0) THEN
               amagb=amag1(n_fil_w(iz))-dmod-
     .              2.5D0*DLOG10((flux0/vega(ifilt))*(vega(n_fil_w(iz))/
     .              filter(n_fil_w(iz),ww,y,iw(i_typ(iz)),zphot(1))))
            ELSE                ! AB magnitude
               amagb=amag1(n_fil_w(iz))-dmod-
     .              2.5D0*DLOG10((flux0/f2(ifilt))*(f2(n_fil_w(iz))/
     .              filter(n_fil_w(iz),ww,y,iw(i_typ(iz)),zphot(1))))
            END IF
         ELSE 
c use the best fit if it is impossible to compute it from the nearest filter
            IF (magtyp.eq.0) THEN
               amagb=-2.5D0*DLOG10(bb(1)*flux0/vega(ifilt))-dmod
            ELSE
               amagb=-2.5D0*DLOG10(bb(1)*flux0/f2(ifilt))-dmod-48.6
            END IF
         END IF
      ELSE IF (imabs.eq.1) THEN ! use the best fit normalization
         IF (magtyp.eq.0) THEN
            amagb=-2.5D0*DLOG10(bb(1)*flux0/vega(ifilt))-dmod
         ELSE
            amagb=-2.5D0*DLOG10(bb(1)*flux0/f2(ifilt))-dmod-48.6
         END IF
      END IF

c constraint absolute magnitude
      IF (amagb.ge.amabs_1.and.amagb.le.amabs_2) GO TO 2000 ! solution ok

c first solution forbidden, search the next one
      iforbid(iz)=1

 200  chi2min=1.D15
      DO i=i1,i2
         IF (iforbid(i).ne.1) GO TO 201
      END DO 
      GO TO 202

c find the following possible solution in chi2 order
 201  CONTINUE
      DO i=i1,i2
         IF (z_min_array(i).lt.chi2min.and.iforbid(i).ne.1) THEN
            chi2min=z_min_array(i)
            iz=i
         END IF
      END DO

      DO i=1,n_sol
         IF (iz.eq.izphot(i)) THEN 
c check the absolute magnitude for the i-th solution
c 0. use the nearest observed filter to minimize k-correction (to be checked)
c 1. compute directly from the SED best fit 
            IF (sed_abc(i_typ(iz)).eq.'BC') THEN
               DO k=1,iw(i_typ(iz))
                  y(k)=f_bc(k,i_age(iz),ntyp_bc(i_typ(iz)))
                  ww(k)=DBLE(w_bc(k,ntyp_bc(i_typ(iz))))
               END DO
            ELSE IF (sed_abc(i_typ(iz)).eq.'PG') THEN
               DO k=1,iw(i_typ(iz))
                  y(k)=f_pg(k,i_age(iz),ntyp_pg(i_typ(iz)))
                  ww(k)=DBLE(w_pg(k,ntyp_pg(i_typ(iz))))
               END DO
            ELSE IF (sed_abc(i_typ(iz)).eq.'AS'.or.
     .              sed_abc(i_typ(iz)).eq.'A ') THEN
               DO k=1,iw(i_typ(iz))
                  y(k)=f_as(k,i_age(iz),ntyp_as(i_typ(iz)))
                  ww(k)=DBLE(w_as(k,ntyp_as(i_typ(iz))))
               END DO
            END IF
            av=avmin+(i_red(iz)-1)*averr
            IF (av.gt.0.0) THEN
               CALL red_spec(ww,y,av,yob,1,iw(i_typ(iz)),law_rd) 
               DO k=1,iw(i_typ(iz))
                  y(k)=yob(k)
               END DO
            END IF
            CALL lyman_forest(ww,y,iw(i_typ(iz)),z(iz))

c distance modulus
            IF (z(iz).lt.1.D-4) THEN
               dl=0.D0
            ELSE
               dl=d_l(h0,om,ov,z(iz)) !luminosity distance in Mpc
            END IF
            IF (dl.gt.0.D0) dmod=5.D0*DLOG10(dl)+25.D0
c minimum dmod: corresponding to d(~M31)=1000 Kpc
            IF (dmod.lt.25.D0) dmod=25.D0
c Absolute magnitude:
c 0. use the nearest observed filter to minimize k-correction
c 1. compute directly from the SED best fit 
            amagb=99.
            flux0=filter(ifilt,ww,y,iw(i_typ(iz)),0.D0)
            IF (imabs.eq.0) THEN ! use the nearest rest frame filter 
               IF (flux(n_fil_w(iz),iz,i_age(iz),i_typ(iz),i_red(iz),
     &              i_lyf(iz)).gt.0.D0) THEN
                  IF (magtyp.eq.0) THEN
                     amagb=amag1(n_fil_w(iz))-dmod-
     .                    2.5D0*DLOG10((flux0/vega(ifilt))*
     .                    (vega(n_fil_w(iz))/
     .                    filter(n_fil_w(iz),ww,y,iw(i_typ(iz)),z(iz))))
                  ELSE          ! AB magnitude
                     amagb=amag1(n_fil_w(iz))-dmod-
     .                    2.5D0*DLOG10((flux0/f2(ifilt))*
     .                    (f2(n_fil_w(iz))/
     .                    filter(n_fil_w(iz),ww,y,iw(i_typ(iz)),z(iz))))
                  END IF
               ELSE 
c use the best fit if it is impossible to compute it from the nearest filter
                  IF (magtyp.eq.0) THEN
                     amagb=-2.5D0*DLOG10(bb_array(iz)*flux0/vega(ifilt))
     .                    -dmod
                  ELSE
                     amagb=-2.5D0*DLOG10(bb_array(iz)*flux0/f2(ifilt))
     .                    -dmod-48.6
                  END IF
               END IF
            ELSE IF (imabs.eq.1) THEN ! use the best fit normalization
               IF (magtyp.eq.0) THEN
                  amagb=-2.5D0*DLOG10(bb_array(iz)*flux0/
     .                 vega(ifilt))-dmod
               ELSE
                  amagb=-2.5D0*DLOG10(bb_array(iz)*flux0/f2(ifilt))
     .                 -dmod-48.6
               END IF
            END IF

c constraint absolute magnitude
c i-th solution ok -> re-order solutions
            IF (amagb.ge.amabs_1.and.amagb.le.amabs_2) THEN
               GO TO 3000
            ELSE
c i-th solution forbidden, try again
               iforbid(iz)=1
               GO TO 200
            END IF 
         END IF
      END DO

c refinement if the new minimum is not a secondary solution
      IF (iz.eq.i1) THEN
         dz_f=(z(iz+1)-z(iz))/10.D0
         zmax_f=z(iz+1)
         zmin_f=z(iz)
      ELSE IF (iz.eq.i2) THEN
         dz_f=(z(iz)-z(iz-1))/10.D0
         zmax_f=z(iz)
         zmin_f=z(iz-1)
      ELSE
         dz_f=(z(iz+1)-z(iz-1))/20.D0
         zmax_f=z(iz+1)
         zmin_f=z(iz-1)
      END IF
      IF (zmin_f.lt.z(i1)) zmin_f=z(i1)
      IF (zmax_f.gt.z(i2)) zmax_f=z(i2)
      av=avmin+(i_red(iz)-1)*averr
      fact_lyf=r_lyf**(i_lyf(iz)-1)*(1.D0/r_lyf)

      IF (sed_abc(i_typ(iz)).eq.'BC') THEN
         DO k=1,iw(i_typ(iz))
            y(k)=f_bc(k,i_age(iz),ntyp_bc(i_typ(iz)))
            ww(k)=DBLE(w_bc(k,ntyp_bc(i_typ(iz))))
         END DO
      ELSE IF (sed_abc(i_typ(iz)).eq.'PG') THEN
         DO k=1,iw(i_typ(iz))
            y(k)=f_pg(k,i_age(iz),ntyp_pg(i_typ(iz)))
            ww(k)=DBLE(w_pg(k,ntyp_pg(i_typ(iz))))
         END DO
      ELSE IF (sed_abc(i_typ(iz)).eq.'AS'.or.
     .        sed_abc(i_typ(iz)).eq.'A ') THEN
         DO k=1,iw(i_typ(iz))
            y(k)=f_as(k,i_age(iz),ntyp_as(i_typ(iz)))
            ww(k)=DBLE(w_as(k,ntyp_as(i_typ(iz))))
         END DO
      END IF

      IF (av.gt.0.D0.and.law_rd.ne.0) THEN
         CALL red_spec(ww,y,av,yob,1,iw(i_typ(iz)),law_rd)
         DO k=1,iw(i_typ(iz))
            y(k)=yob(k)
         END DO
      END IF

c refine solution using the SED itypem
      nz_f=NINT((zmax_f-zmin_f)/dz_f)+1
      chi2=1.D+12
      DO i=2,nz_f-1             !Scan in z excluding limits of range
         zz=zmin_f+(i-1)*dz_f
         DO k=1,iw(i_typ(iz))
            yob(k)=y(k)
         END DO
         CALL lyman_forest(ww,yob,iw(i_typ(iz)),zz)
         dif(i)=0.0D0
         sxx=0.D0
         sxy=0.D0
         b=0.D0
         DO k=1,n_filt
            IF (magtyp.eq.1.or.magtyp.eq.2) THEN
               fluxn(k)=filter(k,ww,yob,iw(i_typ(iz)),zz)/f2(k)
            ELSE
               fluxn(k)=filter(k,ww,yob,iw(i_typ(iz)),zz)/surf(k)
            END IF
         END DO
         DO k=1,n_filt
            IF (fl(k).ge.0.) THEN ! no oof objects
               IF (fluxn(k).lt.1.D-12.and.i_lyman(k).eq.1) THEN
                  fl1(k)=0.D0
               ELSE
                  fl1(k)=fl(k)
                  wt=1.D0/(err_fl(k)*err_fl(k))
                  sxx=sxx+(fluxn(k)*fluxn(k))*wt
                  sxy=sxy+fluxn(k)*fl1(k)*wt
               END IF
            ELSE
               fl1(k)=-1.D0
            END IF
         END DO
         b=sxy/sxx
         DO k=1,n_filt
            IF (fl1(k).ge.0.D0) THEN ! no oof objects
               dif(i)=dif(i)+((fl1(k)-b*fluxn(k))/err_fl(k))**2
            END IF
         END DO
         IF (dif(i).lt.chi2) THEN
            chi2=dif(i)
            i_min=i
            bm=b
         END IF
      END DO
      zop=zmin_f+(i_min-1)*dz_f
      CALL lyman_forest(ww,y,iw(i_typ(iz)),zop)

c distance modulus
      IF (zop.lt.1.D-4) THEN
         dl=0.D0
      ELSE
         dl=d_l(h0,om,ov,zop) !luminosity distance in Mpc
      END IF
      IF (dl.gt.0.D0) dmod=5.D0*DLOG10(dl)+25.D0
c minimum dmod: corresponding to d(~M31)=1000 Kpc
      IF (dmod.lt.25.D0) dmod=25.D0
c Absolute magnitude:
c 0. use the nearest observed filter to minimize k-correction
c 1. compute directly from the SED best fit 
      amagb=99.
      flux0=filter(ifilt,ww,y,iw(i_typ(iz)),0.D0)
      IF (imabs.eq.0) THEN      ! use the nearest rest frame filter 
         IF (flux(n_fil_w(iz),iz,i_age(iz),i_typ(iz),i_red(iz),
     &        i_lyf(iz)).gt.0.D0) THEN
            IF (magtyp.eq.0) THEN
               amagb=amag1(n_fil_w(iz))-dmod-
     .              2.5D0*DLOG10((flux0/vega(ifilt))*
     .              (vega(n_fil_w(iz))/
     .              filter(n_fil_w(iz),ww,y,iw(i_typ(iz)),zop)))
            ELSE                ! AB magnitude
               amagb=amag1(n_fil_w(iz))-dmod-
     .              2.5D0*DLOG10((flux0/f2(ifilt))*(f2(n_fil_w(iz))/
     .              filter(n_fil_w(iz),ww,y,iw(i_typ(iz)),zop)))
            END IF
         ELSE 
c use the best fit if it is impossible to compute it from the nearest filter
            IF (magtyp.eq.0) THEN
               amagb=-2.5D0*DLOG10(bm*flux0/vega(ifilt))-dmod
            ELSE
               amagb=-2.5D0*DLOG10(bm*flux0/f2(ifilt))-dmod-48.6
            END IF
         END IF
      ELSE IF (imabs.eq.1) THEN ! use the best fit normalization
         IF (magtyp.eq.0) THEN
            amagb=-2.5D0*DLOG10(bm*flux0/vega(ifilt))-dmod
         ELSE
            amagb=-2.5D0*DLOG10(bm*flux0/f2(ifilt))-dmod-48.6
         END IF
      END IF
      
      IF (amagb.ge.amabs_1.and.amagb.le.amabs_2) THEN
c found new first solution, add solution and shift the others
         n_sol=n_sol+1
         DO i=n_sol,2,-1
            chi2sol(i)=chi2sol(i-1)
            zphot(i)=zphot(i-1)
            izphot(i)=izphot(i-1)
            bb(i)=bb(i-1)
         END DO
         zphot(1)=zop
         chi2sol(1)=chi2
         bb(1)=bm
         izphot(1)=iz
         GO TO 2000
      ELSE 
c         IF (iz.ne.i2) THEN
c forbidden solution, try again
            iforbid(iz)=1
            GO TO 200
c         END IF
      END IF

 202  WRITE(*,'(a,i12)') 'WARNING: impossible to find a '//
     .     'solution within constraints for object ', id
c ..... Write outputs in any case (except .m and .spe)
c ..... File .z_phot
      zphot(1)=-9.9D0
      r_chi2=99.D0
      qq=0.D0
      itypem=0
      iagem=0
      age=99.D0
      av=0.D0
      bb(1)=0.D0
      DO i=1,3
         zz1(i)=99.D0
         zz2(i)=99.D0
      END DO
      z_poids=99.D0
      qq_p=0.D0
      amagb=99.D0
      zphot(2)=99.D0
      qq2=0.D0
      amagb_clus=99.D0
      p_clus=0.D0
      amag(1)=99.D0
      i_sol=1
      fact_lyf=1.D0
      IF (z_clus.ge.0.D0) THEN
         IF (cz.eq.'y'.or.cz.eq.'Y') WRITE(17,2009) id,zphot(1),
     .        r_chi2,qq,itypem,iagem,age,av,bb(1),zz1(1),zz2(1),
     .        zz1(2),zz2(2),zz1(3),zz2(3),z_poids,qq_p,amagb,
     .        fact_lyf,zphot(2),qq2,amagb_clus,p_clus,amag(1)
      ELSE
         IF (cz.eq.'y'.or.cz.eq.'Y') WRITE(17,2008) id,zphot(1),
     .        r_chi2,qq,itypem,iagem,age,av,bb(1),zz1(1),zz2(1),
     .        zz1(2),zz2(2),zz1(3),zz2(3),z_poids,qq_p,amagb,
     .        fact_lyf,zphot(2),qq2
      END IF
c..... File .cat_phot
      IF (ccat.eq.'y'.or.ccat.eq.'Y') WRITE(10,2001) id,zphot(1),
     .     r_chi2,qq,itypem,iagem,age,av,bb(1),zz1(1),zz2(1),
     .     zz1(2),zz2(2),zz1(3),zz2(3),z_poids,qq_p,amagb,
     .     fact_lyf,i_sol

c..... File .obs_sed
      IF (csed1.eq.'y'.or.csed1.eq.'Y') THEN
c +++++ output in erg/cm2/s/A
         IF (iunit_sed.eq.0) THEN
c ----- input Vega magnitudes; fl(k) already in erg/cm2/s/A
            IF (magtyp.eq.0) THEN 
               DO k=1,n_filt
c detected and undetected filters and errors
                  fluxn(k)=fl(k)
                  fluxerrn(k)=err_fl(k)
c keep the negative sign of err_p for IR or UV not used filters
                  fluxn(k)=sign(fluxn(k),err_p(k))
c non detection/not observed
                  IF ((rmag(k).ge.90..and.law_nd(k).eq.0).or.
     &                 rerr_p(k).lt.0..or.rmag(k).le.0.) THEN
                     fluxn(k)=-1.D0
                     fluxerrn(k)=0.D0
c non detection with constraint on upper limit
                  ELSE IF (rmag(k).gt.90..and.law_nd(k).eq.4) THEN
                     fluxn(k)=fl_nd(k)
                     fluxerrn(k)=-1.D0                        
                  END IF
               END DO
c ----- input AB magnitudes; fl(k) in erg/cm2/s/Hz
            ELSE IF (magtyp.eq.1) THEN
               DO k=1,n_filt
                  fluxn(k)=fl(k)*f2(k)/surf(k)
                  fluxerrn(k)=err_fl(k)*f2(k)/surf(k)
c keep the negative sign of err_p for IR or UV not used filters
                  fluxn(k)=sign(fluxn(k),err_p(k))
c non detection/not observed
                  IF ((rmag(k).ge.90..and.law_nd(k).eq.0).or.
     &                 rerr_p(k).lt.0..or.rmag(k).le.0.) THEN
                     fluxn(k)=-1.D0
                     fluxerrn(k)=0.D0
c non detection with constraint on upper limit
                  ELSE IF (rmag(k).gt.90..and.law_nd(k).eq.4) THEN
                     fluxn(k)=fl_nd(k)*f2(k)/surf(k)
                     fluxerrn(k)=-1.D0                        
                  END IF
               END DO
c ----- input muJy; fl(k) in erg/cm2/s/Hz
            ELSE IF (magtyp.eq.2) THEN
               DO k=1,n_filt
                  fluxn(k)=fl(k)*f2(k)/surf(k)
                  fluxerrn(k)=err_fl(k)*f2(k)/surf(k)
c keep the negative sign of err_p for IR or UV not used filters
                  fluxn(k)=sign(fluxn(k),err_p(k))
c non detection/not observed
                  IF ((rmag(k).lt.-90..and.law_nd(k).eq.0).or.
     &                 rerr_p(k).lt.0..or.ABS(rmag(k)+1.D0).lt.1.D-6) 
     &                 THEN
                     fluxn(k)=-1.D0
                     fluxerrn(k)=0.D0
c non detection with constraint on upper limit
                  ELSE IF (rmag(k).lt.-90..and.law_nd(k).eq.4) THEN
                     fluxn(k)=fl_nd(k)*f2(k)/surf(k)
                     fluxerrn(k)=-1.D0                        
                  END IF
               END DO
            END IF
            WRITE(15,fmt2) id,(fluxn(k),k=1,n_filt),
     &           (fluxerrn(k),k=1,n_filt)
c +++++ output in muJy
         ELSE IF (iunit_sed.eq.1) THEN
c ----- input Vega magnitudes; fl(k) in erg/cm2/s/A
            IF (magtyp.eq.0) THEN
               DO k=1,n_filt
                  f_jy(k)=fl(k)*surf(k)/f2(k)*1.D+29
                  err_jy(k)=err_fl(k)*surf(k)/f2(k)*1.D+29
                  f_jy(k)=sign(f_jy(k),err_p(k))
                  IF ((rmag(k).ge.90..and.law_nd(k).eq.0).or.
     &                 rerr_p(k).lt.0..or.rmag(k).le.0.) THEN
                     f_jy(k)=-1.D0
                     err_jy(k)=0.D0
                  ELSE IF (rmag(k).gt.90..and.law_nd(k).eq.4) THEN
                     f_jy(k)=fl_nd(k)*surf(k)/f2(k)*1.D+29
                     err_jy(k)=-1.D0
                  END IF
               END DO
c ----- input AB magnitudes; fl(k) in erg/cm2/s/Hz
            ELSE IF (magtyp.eq.1) THEN
               DO k=1,n_filt
c detected filter and error
                  f_jy(k)=fl(k)*1.D29
                  err_jy(k)=err_fl(k)*1.D29
                  f_jy(k)=sign(f_jy(k),err_p(k))
                  IF ((rmag(k).ge.90..and.law_nd(k).eq.0).or.
     &                 rerr_p(k).lt.0..or.rmag(k).le.0.) THEN
                     f_jy(k)=-1.D0
                     err_jy(k)=0.D0
                  ELSE IF (rmag(k).gt.90..and.law_nd(k).eq.4) THEN
                     f_jy(k)=fl_nd(k)*1.D+29
                     err_jy(k)=-1.D0
                  END IF
               END DO
c ----- input muJy; fl(k) in erg/cm2/s/Hz
            ELSE IF (magtyp.eq.2) THEN
               DO k=1,n_filt
c detected & non detected filter and error; f_jy is the input
                  IF (rmag(k).gt.0..and.(rerr_p(k).gt.0..or.
     &                 rmag(k).lt.-90.)) THEN 
                     f_jy(k)=sign(f_jy(k),err_p(k))
c non detection/not observed
                  ELSE IF ((rmag(k).lt.-90..and.law_nd(k).eq.0).or.
     &                    rerr_p(k).lt.0..or.ABS(rmag(k)+1.D0).lt.1.D-6) 
     &                    THEN
                     f_jy(k)=-1.D0
                     err_jy(k)=0.D0
                  ELSE IF (rmag(k).lt.-90..and.law_nd(k).eq.4) THEN
                     f_jy(k)=fl_nd(k)*1.D+29
                     err_jy(k)=-1.D0
                  END IF
               END DO
            END IF
            WRITE(15,fmt2) id,(f_jy(i),i=1,n_filt),
     .           (err_jy(i),i=1,n_filt)
c +++++ output in AB magnitudes
         ELSE IF (iunit_sed.eq.2) THEN
c ----- input Vega magnitudes; fl(k) in erg/cm2/s/A
            IF (magtyp.eq.0) THEN
               DO k=1,n_filt
                  amag(k)=amag1(k)+conv_mag(k)
                  amag(k)=sign(amag(k),err_p(k))
                  IF (amag1(k).gt.90.D0) THEN
                     amag(k)=mag_nd(k)
                     err_p(k)=99.D0
                  ELSE IF (amag1(k).lt.1.D0) THEN
                     amag(k)=-1.D0
                     err_p(k)=-1.D0
                  END IF
               END DO
c ----- input AB magnitudes; amag1 AB magnitudes
            ELSE IF (magtyp.eq.1) THEN
               DO k=1,n_filt
                  amag(k)=sign(amag(k),err_p(k))
                  IF (amag1(k).gt.90.D0) THEN
                     amag(k)=mag_nd(k)
                     err_p(k)=99.D0
                  ELSE IF (amag1(k).lt.1.D0) THEN
                     amag(k)=-1.D0
                     err_p(k)=-1.D0
                  END IF
               END DO
c ----- input muJy; amag1 AB magnitudes
            ELSE IF (magtyp.eq.2) THEN
               DO k=1,n_filt
                  amag(k)=amag1(k)
                  err_p(k)=2.5D0/DLOG(10.D0)*err_jy(k)/f_jy(k)
                  amag(k)=sign(amag(k),err_p(k))
                  IF (rmag(k).lt.-90.) THEN
                     amag(k)=mag_nd(k)
                     err_p(k)=99.D0
                  ELSE IF (ABS(rmag(iii)+1.).lt.1.D-6) THEN
                     amag(k)=-1.D0
                     err_p(k)=-1.D0
                  END IF
               END DO
            END IF
            WRITE(15,fmt1) id,(amag(i),i=1,n_filt),
     .           (err_p(i),i=1,n_filt)
         END IF
      END IF

c..... File .temp_sed
      IF (csed2.eq.'y'.or.csed2.eq.'Y') THEN 
         DO k=1,n_filt
            mag_temp(k)=99.D0
            fl_temp(k)=-1.D0
         END DO
         IF (iunit_sed.eq.0.or.iunit_sed.eq.1) THEN
            WRITE(19,fmt4) id,(fl_temp(k),k=1,n_filt)
         ELSE IF (iunit_sed.eq.2) THEN
            WRITE(19,fmt3) id,(mag_temp(k),k=1,n_filt)
         END IF
      END IF
      GO TO 13400

c re-ordering
 3000 izmin=izphot(i)
      dummy=chi2sol(i)
      dummyz=zphot(i)
      idum=izphot(i)
      ddummy=bb(i)
      i_sol=i
      DO i=i_sol,2,-1
         chi2sol(i)=chi2sol(i-1)
         zphot(i)=zphot(i-1)
         izphot(i)=izphot(i-1)
         bb(i)=bb(i-1)
      END DO
      chi2sol(1)=dummy
      zphot(1)=dummyz
      izphot(1)=idum
      bb(1)=ddummy

c ..... main solution 
 2000 i_sol=1
      izmin=izphot(1)
      itypem=i_typ(izmin)
      iagem=i_age(izmin)
      iredm=i_red(izmin)
      av=avmin+(iredm-1)*averr
      ilyfm=i_lyf(izmin)
      fact_lyf=r_lyf**(ilyfm-1)*(1.D0/r_lyf)
      DO k=1,n_filt
         IF (ABS(flux(k,izmin,iagem,itypem,iredm,ilyfm)).lt.1.D-12.and.
     .        i_lyman(k).eq.1) THEN
            fl1(k)=0.D0
         ELSE 
            fl1(k)=fl(k)
         END IF
      END DO
      IF (sed_abc(i_typ(izmin)).eq.'BC') THEN
         age=t_bc(i_age(izmin))/1.D9
      ELSE IF (sed_abc(i_typ(izmin)).eq.'AS'.or.
     .        sed_abc(i_typ(izmin)).eq.'A ') THEN
         age=19.9999D0
      ELSE IF (sed_abc(i_typ(izmin)).eq.'PG') THEN
         age=t_pg(i_age(izmin))/1.D3
      END IF
      r_chi2=chi2sol(1)/deg
      IF (r_chi2.ge.1.D4) r_chi2=9999.99D0
      qq=100.D0*qchi2(0.5D0*deg,0.5D0*chi2sol(1))      
      IF (z(izmin)-zphot(1).gt.0.5D0*dz_f) THEN
         izmin1=izmin-1
      ELSE
         izmin1=izmin
      END IF

c ..... study of confidence intervals
      DO i=1,3
         zz1(i)=z(i1)
         zz2(i)=z(i2)
      END DO
      DO i=1,mxz
         q_pro1(i)=0.D0
         q_pro2(i)=0.D0
         q_proz(i)=0.D0
      END DO
      poids=0.0D0
      poids_z=0.0D0
      z_poids=0.D0
      qq_p=0.D0

c ..... Values after izmin
      z_b1(1)=zphot(1)
      chi2_b1(1)=chi2sol(1)
      q_pro1(1)=qq
      i=izmin1+1
      npoiz1=1
      IF (ABS(z(izmin1)-zphot(1)).lt.1.D-5.and.izmin1.eq.i2) THEN
         DO ii=1,3              ! z at P = 99 90 and 68%
            zz2(ii)=z(i2)
         END DO
         npoiz1=1
      ELSE
 1001    CONTINUE
         k=i-izmin1+1
         q_pro1(k)=q_pro(i)
         z_b1(k)=z(i)
         chi2_b1(k)=z_min_array(i)

         IF (i.lt.i2.and.i.le.izmin1) THEN
            i=i+1
            GO TO 1001
         ELSE IF (i.lt.i2.and.(chi2_b1(k)-chi2sol(1)).le.val(1)) THEN
            i=i+1
            GO TO 1001
         END IF
         npoiz1=k

         DO ii=1,3              ! z at P = 99 90 and 68%
            l=0
            zz2(ii)=rlin(val(ii)+chi2sol(1),chi2_b1,z_b1,npoiz1,l)
            IF (zz2(ii).lt.z(i1)) zz2(ii)=z(i1)
            IF (zz2(ii).gt.z(i2)) zz2(ii)=z(i2)
            IF (zz2(ii).lt.zphot(1)) zz2(ii)=z2
         END DO
      END IF

c ..... Values before izmin
      z_b2(1)=zphot(1)
      chi2_b2(1)=chi2sol(1)
      i=izmin1
      ipass=0
      npoiz2=1
      IF (ABS(z(izmin1)-zphot(1)).lt.1.D-5) THEN
         q_pro2(1)=q_pro(izmin1)
         ipass=1
      END IF
      IF (ABS(z(izmin1)-zphot(1)).lt.1.e-5.and.izmin1.eq.i1) THEN
         DO ii=1,3                 !z at P = 99 90 and 68%
            zz1(ii)=z(i1)
         END DO
         npoiz2=1
      ELSE
 1003    CONTINUE
         k=izmin1-i+2
         q_pro2(k)=q_pro(i-ipass)
         z_b2(k)=z(i-ipass)
         chi2_b2(k)=z_min_array(i-ipass)
         IF (i-ipass.gt.1.and.i-ipass.ge.izmin1) THEN
            i=i-1
            GO TO 1003
         ELSE IF (i-ipass.gt.1.and.
     .           (chi2_b2(k)-chi2sol(1)).le.val(1)) THEN
            i=i-1
            GO TO 1003
         END IF
         npoiz2=k

         DO ii=1,3                 !z at P = 99 90 and 68%
         l=0
            zz1(ii)=rlin(val(ii)+chi2sol(1),chi2_b2,z_b2,npoiz2,l)
            IF (zz1(ii).lt.z(i1)) zz1(ii)=z(i1)
            IF (zz1(ii).gt.z(i2)) zz1(ii)=z(i2)
            IF (zz1(ii).gt.zphot(1)) zz1(ii)=zphot(1)
         END DO
      END IF

c ..... Ordering q_proz et z_b
      IF (ABS(z(izmin1)-zphot(1)).lt.1.e-5.and.izmin1.eq.i1) THEN
         npoiz=npoiz1           ! points after only 
         DO ii=1,npoiz
            q_proz(ii)=q_pro1(ii)
            z_b(ii)=z_b1(ii)
         END DO         
      ELSE IF (ABS(z(izmin1)-zphot(1)).lt.1.D-5.and.izmin1.eq.i2) THEN
         npoiz=npoiz2           ! points before only  
         DO ii=1,npoiz
            q_proz(ii)=q_pro2(npoiz2-(ii-1))
            z_b(ii)=z_b2(npoiz2-(ii-1))
         END DO         
      ELSE IF (ABS(z(izmin1)-zphot(1)).lt.1.D-5.and.
     .        izmin1.ne.1.and.izmin1.ne.i2) THEN
         npoiz=npoiz1+npoiz2-1
         DO ii=1,npoiz2         ! points before
            q_proz(ii)=q_pro2(npoiz2-(ii-1))
            z_b(ii)=z_b2(npoiz2-(ii-1))
         END DO
         DO ii=1,npoiz1-1       ! points after (skip zphot(1))
            q_proz(npoiz2+ii)=q_pro1(ii+1)
            z_b(npoiz2+ii)=z_b1(ii+1)
         END DO
      ELSE
         npoiz=npoiz1+npoiz2-2
         DO ii=1,npoiz2-1       ! points before (skip zphot(1))
            q_proz(ii)=q_pro2(npoiz2-(ii-1))
            z_b(ii)=z_b2(npoiz2-(ii-1))
         END DO
         DO ii=1,npoiz1-1       ! points after (skip zphot(1))
            q_proz(npoiz2+ii-1)=q_pro1(ii+1)
            z_b(npoiz2+ii-1)=z_b1(ii+1)
         END DO
      END IF

      DO ii=1,npoiz
         poids=poids+q_proz(ii)
         poids_z=poids_z+q_proz(ii)*z_b(ii)
      END DO

c ..... z weighted mean
      IF (poids.gt.0.0D0) THEN
         z_poids=poids_z/poids
         l=0
         qq_p=rlin(z_poids,z_b,q_proz,npoiz,l)
      ELSE
         z_poids=zphot(1)
         qq_p=qq
      END IF

c ..... secondary solution
      IF (n_sol.lt.2) THEN      ! no secondary solution
         zphot(2)=9.999D0
         qq2=0.D0
      ELSE
         qq2=100.D0*qchi2(0.5D0*deg,0.5D0*chi2sol(2))
      END IF
      bbb=bb(1)

c ..... Probability to be in the cluster
      IF (z_clus.ge.0.D0) THEN
         IF (z_clus.eq.z(iz_clus)) THEN
            p_clus=q_pro(iz_clus)
         ELSE
            p_clus=q_pro(iz_clus)+(q_pro(iz_clus+1)-q_pro(iz_clus))
     .           *(z_clus-z(iz_clus))/(z(iz_clus+1)-z(iz_clus))
         END IF
         
c ..... Absolute magnitude in the cluster
         IF (sed_abc(itypea).eq.'BC') THEN
            DO k=1,iw(itypea)
               y(k)=f_bc(k,iagea,ntyp_bc(itypea))
               ww(k)=DBLE(w_bc(k,ntyp_bc(itypea)))
            END DO
         ELSE IF (sed_abc(itypea).eq.'PG') THEN
            DO k=1,iw(itypea)
               y(k)=f_pg(k,iagea,ntyp_pg(itypea))
               ww(k)=DBLE(w_pg(k,ntyp_pg(itypea)))
            END DO
         ELSE IF (sed_abc(itypea).eq.'AS'.or.
     .           sed_abc(itypea).eq.'A ') THEN
            DO k=1,iw(itypea)
               y(k)=f_as(k,iagea,ntyp_as(itypea))
               ww(k)=DBLE(w_as(k,ntyp_as(itypea)))
            END DO
         END IF
         
         IF (avmin+(ireda-1)*averr.gt.0.D0) THEN
            CALL red_spec(ww,y,av,yob,1,iw(itypea),law_rd)
            DO k=1,iw(itypea)
               y(k)=yob(k)
            END DO
         END IF
         fact_lyf=r_lyf**(ilyfa-1)*(1.D0/r_lyf)
         CALL lyman_forest(ww,y,iw(itypea),z_clus)
c distance modulus
         IF (z_clus.lt.1.D-4) THEN
            dl=0.D0
         ELSE
            dl=d_l(h0,om,ov,z_clus) !luminosity distance in Mpc
         END IF
         IF (dl.gt.0.D0) dmod=5.D0*DLOG10(dl)+25.D0
c minimum dmod: corresponding to d(~M31)=1000 Kpc
         IF (dmod.lt.25.D0) dmod=25.D0
c Absolute magnitude:
c 0. use the nearest observed filter to minimize k-correction
c 1. compute directly from the SED best fit 
         amagb=99.
         flux0=filter(ifilt,ww,y,iw(itypea),0.D0)

         IF (imabs.eq.0) THEN   ! use the nearest rest frame filter 
            IF (magtyp.eq.0) THEN
               IF (flux(n_fil_wa,iz_clus,iagea,itypea,ireda,
     &              ilyfa).gt.0.D0) THEN
                  amagb_clus=amag1(n_fil_wa)-dmod-
     .                 2.5D0*DLOG10((flux0/vega(ifilt))*(vega(n_fil_wa)/
     .                 filter(n_fil_wa,ww,y,iw(itypea),z_clus)))
               ELSE             ! AB magnitude
                  amagb_clus=amag1(n_fil_wa)-dmod-2.5D0*DLOG10((flux0/
     .                 f2(ifilt))*(f2(n_fil_wa)/
     .                 filter(n_fil_wa,ww,y,iw(itypea),z_clus)))
               END IF
            ELSE 
c use the best fit if it is impossible to compute it from the nearest filter
               IF (magtyp.eq.0) THEN
                  amagb_clus=-2.5D0*DLOG10(bbb*flux0/vega(ifilt))-dmod
               ELSE
                  amagb_clus=-2.5D0*DLOG10(bbb*flux0/f2(ifilt))
     .                 -dmod-48.6
               END IF
            END IF
         ELSE IF (imabs.eq.1) THEN ! use the best fit normalization
            IF (magtyp.eq.0) THEN
               amagb_clus=-2.5D0*DLOG10(bbb*flux0/vega(ifilt))-dmod
            ELSE
               amagb_clus=-2.5D0*DLOG10(bbb*flux0/f2(ifilt))-dmod-48.6
            END IF
         END IF

c ..... writing output files
         fact_lyf=r_lyf**(ilyfm-1)*(1.D0/r_lyf)
         IF (cz.eq.'y'.or.cz.eq.'Y') WRITE(17,2009) id,zphot(1),r_chi2,
     .        qq,itypem,iagem,age,av,bbb,zz1(1),zz2(1),zz1(2),
     .        zz2(2),zz1(3),zz2(3),z_poids,qq_p,amagb,fact_lyf,
     .        zphot(2),qq2,amagb_clus,p_clus,amag(n_fil_wa)
      ELSE
         IF (cz.eq.'y'.or.cz.eq.'Y') WRITE(17,2008) id,zphot(1),r_chi2,
     .        qq,itypem,iagem,age,av,bbb,zz1(1),zz2(1),zz1(2),zz2(2),
     .        zz1(3),zz2(3),z_poids,qq_p,amagb,fact_lyf,zphot(2),qq2
      END IF

      IF (ccat.eq.'y'.or.ccat.eq.'Y') WRITE(10,2001) id,zphot(1),r_chi2,
     .     qq,itypem,iagem,age,av,bbb,zz1(1),zz2(1),zz1(2),zz2(2),
     .     zz1(3),zz2(3),z_poids,qq_p,amagb,fact_lyf,i_sol

c -------------------------------------------------------------------------
c ..... other solutions (if .cat_phot requested, check threshold)
      IF (ccat.eq.'y'.or.ccat.eq.'Y') THEN
         DO i_sol=2,n_sol
            qq=100.D0*qchi2(0.5D0*deg,0.5D0*chi2sol(i_sol))
            IF (qq.ge.pthresh) THEN
               izmin=izphot(i_sol)
               IF (sed_abc(i_typ(izmin)).eq.'BC') THEN
                  age=t_bc(i_age(izmin))/1.D9
               ELSE IF (sed_abc(i_typ(izmin)).eq.'AS'.or.
     .                 sed_abc(i_typ(izmin)).eq.'A ') THEN
                  age=19.9999D0
               ELSE IF (sed_abc(i_typ(izmin)).eq.'PG') THEN
                  age=t_pg(i_age(izmin))/1.D3
               END IF
               r_chi2=chi2sol(i_sol)/deg
               IF (r_chi2.ge.1.D4) r_chi2=9999.99D0
               qq=100.D0*qchi2(0.5D0*deg,0.5D0*chi2sol(i_sol))      
               IF (z(izmin)-zphot(i_sol).gt.0.5D0*dz_f) THEN
                  izmin1=izmin-1
               ELSE
                  izmin1=izmin
               END IF

c ..... study of confidence intervals
               DO i=1,3
                  zz1(i)=z(i1)
                  zz2(i)=z(i2)
               END DO
               DO i=1,mxz
                  q_pro1(i)=0.D0
                  q_pro2(i)=0.D0
                  q_proz(i)=0.D0
               END DO
               poids=0.0D0
               poids_z=0.0D0
               z_poids=0.D0
               qq_p=0.D0

c ..... Values after izmin
               z_b1(1)=zphot(i_sol)
               chi2_b1(1)=chi2sol(i_sol)
               q_pro1(1)=qq
               i=izmin1+1
               npoiz1=1
               IF (ABS(z(izmin1)-zphot(i_sol)).lt.1.D-5.and.
     .              izmin1.eq.i2) THEN
                  DO ii=1,3     ! z at P = 99 90 and 68%
                     zz2(ii)=z(i2)
                  END DO
                  npoiz1=1
               ELSE
 1002             CONTINUE
                  k=i-izmin1+1
                  q_pro1(k)=q_pro(i)
                  z_b1(k)=z(i)
                  chi2_b1(k)=z_min_array(i)

                  IF (i.lt.i2.and.i.le.izmin1) THEN
                     i=i+1
                     GO TO 1002
                  ELSE IF (i.lt.i2.and.
     .                    (chi2_b1(k)-chi2sol(i_sol)).le.val(1)) THEN
                     i=i+1
                     GO TO 1002
                  END IF
                  npoiz1=k

                  DO ii=1,3     ! z at P = 99 90 and 68%
                     l=0
                     zz2(ii)=rlin(val(ii)+chi2sol(i_sol),
     .                    chi2_b1,z_b1,npoiz1,l)
                     IF (zz2(ii).lt.z(i1)) zz2(ii)=z(i1)
                     IF (zz2(ii).gt.z(i2)) zz2(ii)=z(i2)
                     IF (zz2(ii).lt.zphot(i_sol)) zz2(ii)=z2
                  END DO
               END IF

c ..... Values before izmin
               z_b2(1)=zphot(i_sol)
               chi2_b2(1)=chi2sol(i_sol)
               i=izmin1
               ipass=0
               npoiz2=1
               IF (ABS(z(izmin1)-zphot(i_sol)).lt.1.e-5) THEN
                  q_pro2(1)=q_pro(izmin1)
                  ipass=1
               END IF
               IF (ABS(z(izmin1)-zphot(i_sol)).lt.1.e-5.and.
     .              izmin1.eq.i1) THEN
                  DO ii=1,3
                     zz1(ii)=z(i1)
                  END DO
                  npoiz2=1
               ELSE
 1004             CONTINUE
                  k=izmin1-i+2
                  q_pro2(k)=q_pro(i-ipass)
                  z_b2(k)=z(i-ipass)
                  chi2_b2(k)=z_min_array(i-ipass)
                  IF (i-ipass.gt.1.and.i-ipass.ge.izmin1) THEN
                     i=i-1
                     GO TO 1004
                  ELSE IF (i-ipass.gt.1.and.
     .                    (chi2_b2(k)-chi2sol(i_sol)).le.val(1)) THEN
                     i=i-1
                     GO TO 1004
                  END IF
                  npoiz2=k

                  DO ii=1,3     !z at P = 99 90 and 68%
                     l=0
                     zz1(ii)=rlin(val(ii)+chi2sol(i_sol),
     .                    chi2_b2,z_b2,npoiz2,l)
                     IF (zz1(ii).lt.z(i1)) zz1(ii)=z(i1)
                     IF (zz1(ii).gt.z(i2)) zz1(ii)=z(i2)
                     IF (zz1(ii).gt.zphot(i_sol)) zz1(ii)=zphot(i_sol)
                  END DO
               END IF

c ..... Ordering q_proz et z_b
               IF (ABS(z(izmin1)-zphot(i_sol)).lt.1.e-5.
     .              and.izmin1.eq.i1) THEN
                  npoiz=npoiz1  ! points after only 
                  DO ii=1,npoiz
                     q_proz(ii)=q_pro1(ii)
                     z_b(ii)=z_b1(ii)
                  END DO         
               ELSE IF (ABS(z(izmin1)-zphot(i_sol)).lt.1.e-5.and.
     .                 izmin1.eq.i2) THEN
                  npoiz=npoiz2  ! points before only  
                  DO ii=1,npoiz
                     q_proz(ii)=q_pro2(npoiz2-(ii-1))
                     z_b(ii)=z_b2(npoiz2-(ii-1))
                  END DO         
               ELSE IF (ABS(z(izmin1)-zphot(i_sol)).lt.1.e-5.and.
     .                 izmin1.ne.1.and.izmin1.ne.i2) THEN
                  npoiz=npoiz1+npoiz2-1
                  DO ii=1,npoiz2 ! points before
                     q_proz(ii)=q_pro2(npoiz2-(ii-1))
                     z_b(ii)=z_b2(npoiz2-(ii-1))
                  END DO
                  DO ii=1,npoiz1-1 ! points after (skip zphot(i_sol))
                     q_proz(npoiz2+ii)=q_pro1(ii+1)
                     z_b(npoiz2+ii)=z_b1(ii+1)
                  END DO
               ELSE
                  npoiz=npoiz1+npoiz2-2
                  DO ii=1,npoiz2-1 ! points before (skip zphot(i_sol))
                     q_proz(ii)=q_pro2(npoiz2-(ii-1))
                     z_b(ii)=z_b2(npoiz2-(ii-1))
                  END DO
                  DO ii=1,npoiz1-1 ! points after (skip zphot(i_sol))
                     q_proz(npoiz2+ii-1)=q_pro1(ii+1)
                     z_b(npoiz2+ii-1)=z_b1(ii+1)
                  END DO
               END IF

               DO ii=1,npoiz
                  poids=poids+q_proz(ii)
                  poids_z=poids_z+q_proz(ii)*z_b(ii)
               END DO

c ..... absolute magnitude
               itypem=i_typ(izmin)
               iagem=i_age(izmin)
               iredm=i_red(izmin)
               av=avmin+(iredm-1)*averr
               ilyfm=i_lyf(izmin)
               fact_lyf=r_lyf**(ilyfm-1)*(1.D0/r_lyf)
               IF (sed_abc(itypem).eq.'BC') THEN
                  DO k=1,iw(itypem)
                     y(k)=f_bc(k,iagem,ntyp_bc(itypem))
                     ww(k)=DBLE(w_bc(k,ntyp_bc(itypem)))
                  END DO
               ELSE IF (sed_abc(itypem).eq.'PG') THEN
                  DO k=1,iw(itypem)
                     y(k)=f_pg(k,iagem,ntyp_pg(itypem))
                     ww(k)=DBLE(w_pg(k,ntyp_pg(itypem)))
                  END DO
               ELSE IF (sed_abc(itypem).eq.'AS'.or.
     .                 sed_abc(itypem).eq.'A ') THEN
                  DO k=1,iw(itypem)
                     y(k)=f_as(k,iagem,ntyp_as(itypem))
                     ww(k)=DBLE(w_as(k,ntyp_as(itypem)))
                  END DO
               END IF
               IF (av.gt.0.0) THEN
                  CALL red_spec(ww,y,av,yob,1,iw(itypem),law_rd) 
                  DO k=1,iw(itypem)
                     y(k)=yob(k)
                  END DO
               END IF
               CALL lyman_forest(ww,y,iw(itypem),zphot(i_sol))

c distance modulus
               IF (zphot(i_sol).lt.1.D-4) THEN
                  dl=0.D0
               ELSE
                  dl=d_l(h0,om,ov,zphot(i_sol)) !luminosity distance in Mpc
               END IF
               IF (dl.gt.0.D0) dmod=5.D0*DLOG10(dl)+25.D0
c minimum dmod: corresponding to d(~M31)=1000 Kpc
               IF (dmod.lt.25.D0) dmod=25.D0
               amagb=99.
               flux0=filter(ifilt,ww,y,iw(itypem),0.D0)
               IF (imabs.eq.0) THEN ! use the nearest rest frame filter 
                  IF (flux(n_fil_w(izmin),izmin,iagem,itypem,iredm,
     &                 ilyfm).gt.0.D0) THEN
                     IF (magtyp.eq.0) THEN
                        amagb=amag1(n_fil_w(izmin))-dmod-
     .                       2.5D0*DLOG10((flux0/vega(ifilt))*
     .                       (vega(n_fil_w(izmin))/
     .                       filter(n_fil_w(izmin),ww,y,iw(itypem),
     .                       zphot(i_sol))))
                     ELSE       ! AB magnitude
                        amagb=amag1(n_fil_w(izmin))-dmod-
     .                       2.5D0*DLOG10((flux0/f2(ifilt))*
     .                       (f2(n_fil_w(izmin))/filter(n_fil_w(iz),
     .                       ww,y,iw(itypem),zphot(i_sol))))
                     END IF
                  ELSE 
c use the best fit if it is impossible to compute it from the nearest filter
                     IF (magtyp.eq.0) THEN
                        amagb=-2.5D0*DLOG10(bb_array(izmin)*flux0/
     .                       vega(ifilt))-dmod
                     ELSE
                        amagb=-2.5D0*DLOG10(bb_array(izmin)*flux0/
     .                       f2(ifilt))-dmod-48.6
                     END IF
                  END IF
               ELSE IF (imabs.eq.1) THEN ! use the best fit normalization
                  IF (magtyp.eq.0) THEN
                     amagb=-2.5D0*DLOG10(bb_array(izmin)*flux0/
     .                    vega(ifilt))-dmod
                  ELSE
                     amagb=-2.5D0*DLOG10(bb_array(izmin)*flux0/
     .                    f2(ifilt))-dmod-48.6
                  END IF
               END IF

c ..... z weighted mean
               IF (poids.gt.0.0) THEN
                  z_poids=poids_z/poids
                  l=0
                  qq_p=rlin(z_poids,z_b,q_proz,npoiz,l)
               ELSE 
                  z_poids=zphot(i_sol)
                  qq_p=qq
               END IF

               bbb=bb(i_sol)
               WRITE(10,2001) id,zphot(i_sol),r_chi2,qq,itypem,iagem,
     .              age,av,bbb,zz1(1),zz2(1),zz1(2),zz2(2),
     .              zz1(3),zz2(3),z_poids,qq_p,amagb,fact_lyf,i_sol
            END IF
         END DO
      END IF

c -----------------------------------------------------------------------
c                    Graphics: Synthetic spectrum at zphot
c -----------------------------------------------------------------------
c ..... Write SED of object 'id'
      izmin=izphot(1)
      itypem=i_typ(izmin)
      iagem=i_age(izmin)
      iredm=i_red(izmin)
      av=avmin+(iredm-1)*averr
      ilyfm=i_lyf(izmin)
      fact_lyf=r_lyf**(ilyfm-1)*(1.D0/r_lyf)

c..... File .obs_sed
      IF (csed1.eq.'y'.or.csed1.eq.'Y') THEN
c +++++ output in erg/cm2/s/A
         IF (iunit_sed.eq.0) THEN
c ----- input Vega magnitudes; fl(k) already in erg/cm2/s/A
            IF (magtyp.eq.0) THEN 
               DO k=1,n_filt
c detected and undetected filters and errors
                  fluxn(k)=fl(k)
                  fluxerrn(k)=err_fl(k)
c keep the negative sign of err_p for IR or UV not used filters
                  fluxn(k)=sign(fluxn(k),err_p(k))
c non detection/not observed
                  IF ((rmag(k).ge.90..and.law_nd(k).eq.0).or.
     &                 rerr_p(k).lt.0..or.rmag(k).le.0.) THEN
                     fluxn(k)=-1.D0
                     fluxerrn(k)=0.D0
c non detection with constraint on upper limit
                  ELSE IF (rmag(k).gt.90..and.law_nd(k).eq.4) THEN
                     fluxn(k)=fl_nd(k)
                     fluxerrn(k)=-1.D0                        
                  END IF
               END DO
c ----- input AB magnitudes; fl(k) in erg/cm2/s/Hz
            ELSE IF (magtyp.eq.1) THEN
               DO k=1,n_filt
                  fluxn(k)=fl(k)*f2(k)/surf(k)
                  fluxerrn(k)=err_fl(k)*f2(k)/surf(k)
c keep the negative sign of err_p for IR or UV not used filters
                  fluxn(k)=sign(fluxn(k),err_p(k))
c non detection/not observed
                  IF ((rmag(k).ge.90..and.law_nd(k).eq.0).or.
     &                 rerr_p(k).lt.0..or.rmag(k).le.0.) THEN
                     fluxn(k)=-1.D0
                     fluxerrn(k)=0.D0
c non detection with constraint on upper limit
                  ELSE IF (rmag(k).gt.90..and.law_nd(k).eq.4) THEN
                     fluxn(k)=fl_nd(k)*f2(k)/surf(k)
                     fluxerrn(k)=-1.D0                        
                  END IF
               END DO
c ----- input muJy; fl(k) in erg/cm2/s/Hz
            ELSE IF (magtyp.eq.2) THEN
               DO k=1,n_filt
                  fluxn(k)=fl(k)*f2(k)/surf(k)
                  fluxerrn(k)=err_fl(k)*f2(k)/surf(k)
c keep the negative sign of err_p for IR or UV not used filters
                  fluxn(k)=sign(fluxn(k),err_p(k))
c non detection/not observed
                  IF ((rmag(k).lt.-90..and.law_nd(k).eq.0).or.
     &                 rerr_p(k).lt.0..or.ABS(rmag(k)+1.D0).lt.1.D-6) 
     &                 THEN
                     fluxn(k)=-1.D0
                     fluxerrn(k)=0.D0
c non detection with constraint on upper limit
                  ELSE IF (rmag(k).lt.-90..and.law_nd(k).eq.4) THEN
                     fluxn(k)=fl_nd(k)*f2(k)/surf(k)
                     fluxerrn(k)=-1.D0                        
                  END IF
               END DO
            END IF
            WRITE(15,fmt2) id,(fluxn(k),k=1,n_filt),
     &           (fluxerrn(k),k=1,n_filt)
c +++++ output in muJy
         ELSE IF (iunit_sed.eq.1) THEN
c ----- input Vega magnitudes; fl(k) in erg/cm2/s/A
            IF (magtyp.eq.0) THEN
               DO k=1,n_filt
                  f_jy(k)=fl(k)*surf(k)/f2(k)*1.D+29
                  err_jy(k)=err_fl(k)*surf(k)/f2(k)*1.D+29
                  f_jy(k)=sign(f_jy(k),err_p(k))
                  IF ((rmag(k).ge.90..and.law_nd(k).eq.0).or.
     &                 rerr_p(k).lt.0..or.rmag(k).le.0.) THEN
                     f_jy(k)=-1.D0
                     err_jy(k)=0.D0
                  ELSE IF (rmag(k).gt.90..and.law_nd(k).eq.4) THEN
                     f_jy(k)=fl_nd(k)*surf(k)/f2(k)*1.D+29
                     err_jy(k)=-1.D0
                  END IF
               END DO
c ----- input AB magnitudes; fl(k) in erg/cm2/s/Hz
            ELSE IF (magtyp.eq.1) THEN
               DO k=1,n_filt
c detected filter and error
                  f_jy(k)=fl(k)*1.D29
                  err_jy(k)=err_fl(k)*1.D29
                  f_jy(k)=sign(f_jy(k),err_p(k))
                  IF ((rmag(k).ge.90..and.law_nd(k).eq.0).or.
     &                 rerr_p(k).lt.0..or.rmag(k).le.0.) THEN
                     f_jy(k)=-1.D0
                     err_jy(k)=0.D0
                  ELSE IF (rmag(k).gt.90..and.law_nd(k).eq.4) THEN
                     f_jy(k)=fl_nd(k)*1.D+29
                     err_jy(k)=-1.D0
                  END IF
               END DO
c ----- input muJy; fl(k) in erg/cm2/s/Hz
            ELSE IF (magtyp.eq.2) THEN
               DO k=1,n_filt
c detected & non detected filter and error; f_jy is the input
                  IF (rmag(k).gt.0..and.(rerr_p(k).gt.0..or.
     &                 rmag(k).lt.-90.)) THEN 
                     f_jy(k)=sign(f_jy(k),err_p(k))
c non detection/not observed
                  ELSE IF ((rmag(k).lt.-90..and.law_nd(k).eq.0).or.
     &                    rerr_p(k).lt.0..or.ABS(rmag(k)+1.D0).lt.1.D-6) 
     &                    THEN
                     f_jy(k)=-1.D0
                     err_jy(k)=0.D0
                  ELSE IF (rmag(k).lt.-90..and.law_nd(k).eq.4) THEN
                     f_jy(k)=fl_nd(k)*1.D+29
                     err_jy(k)=-1.D0
                  END IF
               END DO
            END IF
            WRITE(15,fmt2) id,(f_jy(i),i=1,n_filt),
     .           (err_jy(i),i=1,n_filt)
c +++++ output in AB magnitudes
         ELSE IF (iunit_sed.eq.2) THEN
c ----- input Vega magnitudes; fl(k) in erg/cm2/s/A
            IF (magtyp.eq.0) THEN
               DO k=1,n_filt
                  amag(k)=amag1(k)+conv_mag(k)
                  amag(k)=sign(amag(k),err_p(k))
                  IF (amag1(k).gt.90.D0) THEN
                     amag(k)=mag_nd(k)
                     err_p(k)=99.D0
                  ELSE IF (amag1(k).lt.1.D0) THEN
                     amag(k)=-1.D0
                     err_p(k)=-1.D0
                  END IF
               END DO
c ----- input AB magnitudes; amag1 AB magnitudes
            ELSE IF (magtyp.eq.1) THEN
               DO k=1,n_filt
                  amag(k)=sign(amag(k),err_p(k))
                  IF (amag1(k).gt.90.D0) THEN
                     amag(k)=mag_nd(k)
                     err_p(k)=99.D0
                  ELSE IF (amag1(k).lt.1.D0) THEN
                     amag(k)=-1.D0
                     err_p(k)=-1.D0
                  END IF
               END DO
c ----- input muJy; amag1 AB magnitudes
            ELSE IF (magtyp.eq.2) THEN
               DO k=1,n_filt
                  amag(k)=amag1(k)
                  err_p(k)=2.5D0/DLOG(10.D0)*err_jy(k)/f_jy(k)
                  amag(k)=sign(amag(k),err_p(k))
                  IF (rmag(k).lt.-90.) THEN
                     amag(k)=mag_nd(k)
                     err_p(k)=99.D0
                  ELSE IF (ABS(rmag(iii)+1.).lt.1.D-6) THEN
                     amag(k)=-1.D0
                     err_p(k)=-1.D0
                  END IF
               END DO
            END IF
            WRITE(15,fmt1) id,(amag(i),i=1,n_filt),
     .           (err_p(i),i=1,n_filt)
         END IF
      END IF

c file .temp_sed
      IF (csed2.eq.'y'.or.csed2.eq.'Y'.or.iout_s.gt.1) THEN 
         IF (sed_abc(itypem).eq.'BC') THEN
            DO k=1,iw(itypem)
               y(k)=f_bc(k,iagem,ntyp_bc(itypem))
               ww(k)=DBLE(w_bc(k,ntyp_bc(itypem)))
            END DO
         ELSE IF (sed_abc(itypem).eq.'AS'.or.
     .           sed_abc(itypem).eq.'A ') THEN
            DO k=1,iw(itypem)
               y(k)=f_as(k,iagem,ntyp_as(itypem))
               ww(k)=DBLE(w_as(k,ntyp_as(itypem)))
            END DO
         ELSE IF (sed_abc(itypem).eq.'PG') THEN
            DO k=1,iw(itypem)
               y(k)=f_pg(k,iagem,ntyp_pg(itypem))
               ww(k)=DBLE(w_pg(k,ntyp_pg(itypem)))
            END DO
         END IF
         av=avmin+(iredm-1)*averr
         IF (av.gt.0.0) THEN
            CALL red_spec(ww,y,av,yob,1,iw(itypem),law_rd)
            DO k=1,iw(itypem)  
               y(k)=yob(k)
            END DO
         END IF
         CALL lyman_forest(ww,y,iw(itypem),zphot(1))
      END IF

      IF (csed2.eq.'y'.or.csed2.eq.'Y') THEN 
         DO k=1,n_filt
            fl_temp(k)=filter(k,ww,y,iw(itypem),zphot(1))
         END DO
         IF (iunit_sed.eq.0) THEN
            WRITE(19,fmt4) id,(bb(1)*fl_temp(k)/surf(k),k=1,n_filt)
         ELSE IF (iunit_sed.eq.1) THEN
            WRITE(19,fmt4) id,(bb(1)*fl_temp(k)/f2(k)*1.D+29,
     &           k=1,n_filt)
         ELSE IF (iunit_sed.eq.2) THEN
            DO k=1,n_filt
               IF (fl_temp(k).gt.0.D0) THEN
                  mag_temp(k)=-2.5D0*DLOG10(bb(1)*fl_temp(k)/f2(k))
     &                 -48.60
               ELSE
                  mag_temp(k)=99.D0
               END IF
            END DO
            WRITE(19,fmt3) id,(mag_temp(k),k=1,n_filt)
         END IF
      END IF

c file .spe
      IF (iout_s.gt.1) THEN
         spectra=root(1:iroot)//'.spe'
         IF (iunit_sed.eq.0) THEN
            DO k=1,iw(itypem)
               yb(k)=bb(1)*y(k)/(1.D0+zphot(1))
            END DO
         ELSE IF (iunit_sed.eq.1) THEN
            DO k=1,iw(itypem)
               yb(k)=bb(1)*y(k)*(ww(k)**2/c)*1.D+29*
     .              (1.D0+zphot(1))
            END DO
         ELSE IF (iunit_sed.eq.2) THEN
            DO k=1,iw(itypem)
               yb(k)=bb(1)*y(k)*(ww(k)**2/c)*(1.D0+zphot(1))
               IF (y(k).ne.0.D0) THEN
                  yb(k)=-2.5D0*DLOG10(yb(k))-48.60D0
               ELSE
                  yb(k)=100.D0
               END IF
            END DO
         END IF
         iwav=0
         wmin1=1.D5
         wmax1=0.D0
         DO k=1,n_filt
            wmin0=wl(k)-0.5D0*surf(k)-1000.D0
            wmax0=wl(k)+0.5D0*surf(k)+1000.D0
            IF (wmin0.lt.wmin1) wmin1=wmin0
            IF (wmax0.gt.wmax1) wmax1=wmax0
         END DO
c Uncomment the following 2 lines and select the range 
c of lambda you prefer for the .zspe output
c         wmin1=1000.D0          ! lambda min in Angstrom
c         wmax1=100000000.D0         ! lambda max in Angstrom
         DO k=1,iw(itypem)
            w0=ww(k)*(1.D0+zphot(1))
            IF ((w0.ge.wmin1.and.w0.le.wmax1).or.
     .           (w0.le.wmin1.and.w0.ge.wmax1)) THEN
               iwav=iwav+1
               wsyn(iwav)=ww(k)*(1.D0+zphot(1))
               ysyn(iwav)=y(k)
            END IF
         END DO
         OPEN(12,FILE=spectra,STATUS='unknown')
         DO k=1,iwav
            WRITE(12,2013) wsyn(k),ysyn(k)
         END DO
         CLOSE(12)
      END IF


c.......................................................................
      GO TO 13400
13500 CONTINUE
c.......................................................................

      CLOSE(16)
      IF (ccat.eq.'y'.or.ccat.eq.'Y') CLOSE(10)
      IF (clog.eq.'y'.or.clog.eq.'Y') CLOSE(14)
      IF (csed1.eq.'y'.or.csed1.eq.'Y') CLOSE(15)
      IF (cz.eq.'y'.or.cz.eq.'Y') CLOSE(17)
      IF (csed2.eq.'y'.or.csed2.eq.'Y') CLOSE(19)

      time_tot=DBLE(cputime())-time_tot
      WRITE(*,'(a)') ' Done !!!'
      WRITE(*,'(1X,A,F12.3,A)') 'Total CPU time involved : ',time_tot, 
     .     ' seconds'
      WRITE(18,'(A,F12.3,A)') '#  Total CPU time involved : ',time_tot,
     .     ' seconds'
      CLOSE(18)
      STOP
 2001 FORMAT(i10,1x,f6.3,1x,f8.3,1x,f6.2,1x,i3,1x,i3,1x,f8.4,1x,f5.2,
     .     1x,es9.3,1x,6(f6.3,1x),f6.3,1x,f6.2,1x,f7.2,1x,F6.3,1x,i3)
 2002 FORMAT(i10,1x,f6.3,1x,es11.4,1x,f10.5,1x,i3,1x,f8.4,1x,F4.2,1x,
     .     F6.3)
 2008 FORMAT(i10,1x,f8.5,1x,f8.3,1x,f6.2,1x,i3,1x,i3,1x,f8.4,1x,
     .     f5.2,1x,es9.3,1x,6(f6.3,1x),f6.3,1x,f6.2,1x,f7.2,1x,F6.3,1x,
     .     f6.3,1x,f6.2)
 2009 FORMAT(i10,1x,f8.5,1x,f8.3,1x,f6.2,1x,i3,1x,i3,1x,f8.4,1x,
     .     f5.2,1x,es9.3,1x,6(f6.3,1x),f6.3,1x,f6.2,1x,f7.2,1x,f6.3,1x,
     .     f6.3,1x,f6.2,1x,F7.2,1x,f6.2,1x,f6.2)
 2012 FORMAT(i10,1x,f6.3,1x,i3,1x,i3,1x,f8.4,1x,f5.2,1x,F6.3,1x,ES11.5)
 2013 FORMAT(1x,f15.4,4x,ES20.13)
 25   STOP 'Error opening synthetic spectra files'
 78   STOP 'Error opening templates file'
 79   STOP 'Error opening or reading photometric catalog'
 80   STOP 'Error opening filters file'
 81   STOP 'Error opening output files'
 82   STOP 'Error reading filters file'
      END
c----------------------------------------------------------------------
      FUNCTION func(x)
      IMPLICIT NONE
      REAL*8 func,pchi2,x,deg,prob
      EXTERNAL pchi2
      COMMON/nfree/deg,prob
c
      func=prob-pchi2(0.5D0*deg,0.5D0*x)
      RETURN
      END

c ----------------------------------------------------------------------
c ..... Luminosity distance [Mpc] 
      FUNCTION d_l(h0,om,ov,za)
      IMPLICIT NONE
      INTEGER nstep,i
      REAL*8 h0,om,ov,z,za,c,d_l,ee,s,s1,s2,dz,a,b,x
      PARAMETER (c=2.9979D+5,nstep=500)
      ee(x)=DSQRT(om*(1.D0+x)**3+(1.D0-om-ov)*(1.D0+x)**2+ov)
c
      IF (za.lt.1.D-5) THEN
         z=1.D-5
      ELSE
         z=za
      END IF
      IF (om.lt.0.001D0.and.ov.lt.1.D-8) THEN
         d_l=(1.D0+z)*DLOG(1.D0+z)
      ELSE IF ((om-1.D0).lt.1.D-8.and.ov.lt.1.D-8) THEN
         d_l=2.D0*(1.D0+z)*(1.D0-1.D0/DSQRT(1.D0+z))
      ELSE IF (om.lt.1.D0.and.om.gt.0.01D0.and.ov.lt.1.D-8) THEN
         d_l=(2.D0/om**2)*(om*z-(2.D0-om)*(-1.D0+DSQRT(om*z+1.D0))) ! Mattig
      ELSE
         dz=z/DBLE(FLOAT(nstep))
         s=0.D0
         d_l=0.D0
         DO i=1,nstep+1
            a=(i-1)*dz
            b=i*dz
            s1=(1.D0/ee(a))
            s2=(1.D0/ee(b))
            s=dz*(s1+s2)*0.5D0
            d_l=d_l+s
         END DO
         d_l=(1.D0+z)*d_l
      END IF
      d_l=c/h0*d_l ! luminosity distance in Mpc
      RETURN
      END
c ----------------------------------------------------------------------

