      PROGRAM make_catalog
c     Version: 09/11/2012
      IMPLICIT NONE
      INTEGER mxwl,mxwl_bc,mxwl_as,mxwl_pg,mxwf,mxfil,mxage_bc,mxage_pg,
     .     mxtyp,mxtyp_bc,mxtyp_as,mxtyp_pg,input,nparam,iseed,i_bc,
     .     i_as,i_pg,nemline,mxvega,ks,i,ii,iii,j,k,kk,ityp,kfil,nfil,
     .     iblank,inoise,iw,i_ob,last,law_rd,nob,mxobj,nnn,np,ntyp_bc,
     .     ntyp_as,ntyp_pg,mxrp,magtyp,ncomp,n_filt,n_files,i1,i2,
     .     i_age,iw_vega,nfil_ref,ilyf,nlyf,mxlyf,mxred,mxage,irebin,
     .     it_pg,ic1,iseg,imf,jo,ifilt,mxafil,iband,ierr
      REAL*8 yz,yob,amag,av,avmax,avmin,averr,bmag,bp1,dif,time_tot,
     .     z_int,err_p,f_bc,f_as,f_pg,rangauss,ran1,f2,h0,om,ov,r,
     .     sig,surf,tz,t_bc,t_pg,wl,w_vega,f_vega,flux,fl_jy,z,vega,
     .     age,age_z,age_form,zmax,zmin,z_form,filter,t1,t2,tx,a1,a2,
     .     ww,am_min,am_max,fl_ref,zero,am1,am2,err,sn0,am0,sn,f_sn,
     .     sn_0,am_0,amlimit,err_min,conv_mag,trapz1,z0,c,rlin,tau,scl,
     .     lsun,r_lyf,fact_lyf,aa,bb,fl1,fl2,wlmin,wlmax,aa8,amgal,
     .     amstar,sfr,xlam,rr2
      REAL wv,fv,ff,w_bc,w_as,w_pg,t_bc0,cputime
      PARAMETER (c=2.99792458D+18) ! speed of light in AA/s
      INCLUDE 'dimensionz.dec'
      PARAMETER (mxtyp=mxtyp_bc+mxtyp_as+mxtyp_pg)
      PARAMETER (nparam=25,mxobj=100000,am1=10.D0,am2=40.D0,
     .     err=1.D-8,imf=10,lsun=3.826D33)
      REAL ml,mu,xx(imf),lm(imf),um(imf),baux(imf),cn(imf),cc(imf),totm,
     .     totn,avs,tau0,zsun
      CHARACTER filesed(mxtyp)*160,sed_abc(mxtyp)*2,line*240,line_pg*80
      CHARACTER*160 spectra,spectra1,spectra2,outfile,filedef,filein,
     .     spec_vega,filered,filtresfile,filt_file,fmt,fmt2,fmtjy,
     .     fmt2jy,line_sed,copyright1,copyright2,copyright3,date*24,
     .     vv*5,string_id*80

      CHARACTER*40 cname,param(nparam)

      DIMENSION input(nparam),kfil(10),ks(mxtyp),iw(mxtyp)
      DIMENSION ntyp_bc(mxtyp),ntyp_as(mxtyp),ntyp_pg(mxtyp)
      DIMENSION tau(mxtyp),zsun(mxtyp)
      DIMENSION w_bc(mxwl_bc,mxtyp_bc),f_bc(mxwl_bc,mxage_bc,mxtyp_bc)
      DIMENSION w_as(mxwl_as,mxtyp_as),f_as(mxwl_as,1,mxtyp_as)
      DIMENSION w_pg(mxwl_pg,mxtyp_pg),f_pg(mxwl_pg,mxage_pg,mxtyp_pg)
      DIMENSION t_bc0(mxage_bc),t_bc(mxage_bc),t_pg(mxage_pg),ff(mxwl)
      DIMENSION fl1(mxwl),fl2(mxwl),ww(mxwl),yz(mxwl),yob(mxwl)
      DIMENSION nfil(mxfil+1),amag(mxfil),amlimit(mxfil),fl_jy(mxfil)
      DIMENSION err_p(mxfil),sn0(mxfil),am0(mxfil)
      DIMENSION w_vega(mxvega),f_vega(mxvega),vega(mxfil+1)
      DIMENSION conv_mag(mxfil+1),f2(mxfil+1)
      DIMENSION wl(mxfil+1),bp1(mxfil+1),surf(mxfil+1)
      DIMENSION xlam(mxwf),rr2(mxwf)

      COMMON/compose/ifilt,np(mxfil)
      COMMON/rfilter/r(mxwf,mxfil,2)
      COMMON/filterres/filtresfile
      COMMON/lyf_sigma/fact_lyf
      COMMON/redfile/filered
      COMMON/s2n/sn_0,am_0
      EXTERNAL ran1,rangauss,filter,tz,zero,f_sn,trapz1,rlin,cputime
c_________________________________________________________________________

      vv='2.0'
      copyright1=
     .     '  make_catalog - synthetic catalogue code - Version '//vv
     .     //' (November 8th, 2012)' 
      copyright2=' by Micol Bolzonella, Roser Pello'','
     .     //' Joan-Marc Miralles'
      copyright3=' More information at '
     .     //'http://webast.ast.obs-mip.fr/hyperz/'
      WRITE(*,*)
      WRITE(*,'(a80)') copyright1
      WRITE(*,*)
      WRITE(*,'(a80)') copyright2
      WRITE(*,'(a80)') copyright3
      WRITE(*,'(a)') ' New web pages: '
     &     //'http://www.bo.astro.it/~micol/Hyperz/'

      iband=1          ! bandpass response function unit for observed filters: 
                       ! 0.energy; 1.photons (see e.g. Bessell 2005)
                       ! this is not a free parameter, if you need to change
                       ! it modify the value here and recompile
      nlyf=1           ! considering only the mean Madau value
      r_lyf=1.D0
      fact_lyf=1.D0
      magtyp=1
      irebin=0
      time_tot=DBLE(cputime())

      param(1)='A0VSED'
      param(2)='FILTERS_RES'
      param(3)='FILTERS_FILE'
      param(4)='TEMPLATES_FILE'
      param(5)='MAG_TYPE'
      param(6)='ERR_MAG_MIN'
      param(7)='Z_MIN'
      param(8)='Z_MAX'
      param(9)='REDDENING_LAW'
      param(10)='FILE_EXT_LAW'
      param(11)='AV_MIN'
      param(12)='AV_MAX'
      param(13)='LY_FOREST'
      param(14)='OUTPUT_FILE'
      param(15)='H0'
      param(16)='OMEGA_M'
      param(17)='OMEGA_V'
      param(18)='REF_FILTER'
      param(19)='MAG_MIN'
      param(20)='MAG_MAX'
      param(21)='NOISE_TYPE'
      param(22)='N_OBJ'
      param(23)='Z_FORM'
      param(24)='AGE_RANDOM'
      param(25)='RAND_SEED'
      DO i=1,nparam
         input(i)=0
      END DO

 44   filein='hyperz_makecat.param'
      last=INDEX(filein,'  ')-1
      WRITE(*,*) 'Name of parameter file' 
      WRITE(*,*) '[default = ',filein(1:last),']'
      READ (*,'(A)') line
      IF (line.ne.' ') THEN
         READ(line,'(A)') filein
      END IF

      OPEN(77,FILE=filein,STATUS='old',ERR=44)
 7    READ(77,'(A)',ERR=10,END=10) line
      DO i=1,80
         IF (line(i:i).ne.' ') THEN
            line=line(i:)
            GO TO 8
         END IF
      END DO
      GO TO 7  ! blank line
 8    IF (line(1:1).eq.'#') GO TO 7 ! comment line
      iblank=INDEX(line,' ')
      cname=line(1:iblank-1) ! variable name
      line=line(iblank:)
      DO i=1,80
         IF (line(i:i).ne.' ') THEN
            line=line(i:)
            IF (line(1:1).eq.'#') THEN
               WRITE(*,*) 'Missed value of variable ', cname
               STOP
            END IF
            GO TO 9
         END IF
      END DO
      WRITE(*,*) 'Missed value of variable ', cname
      STOP
 9    iblank=INDEX(line,' ')
      line=line(1:iblank-1) ! part of string containing value of variable
c Parameters in common hyperz & make_catalog
c ..... A0VSED file
      IF (cname.eq.param(1)) THEN
         READ(line,'(A)') spec_vega
         input(1)=1
         GO TO 7
c .... FILTER file
      ELSE IF (cname.eq.param(2)) THEN
         READ(line,'(A)') filtresfile
         input(2)=1
         GO TO 7
c ..... File containing filters and noise sigma
      ELSE IF (cname.eq.param(3)) THEN
         READ(line,'(A)') filt_file
         input(3)=1
         GO TO 7
c ..... File containing synthetic spectra filenames
      ELSE IF (cname.eq.param(4)) THEN
         READ(line,'(A)') filedef
         input(4)=1
         GO TO 7
c ..... Magnitude type:
c       0 -> standard magnitudes
c       1 -> AB magnitudes
c       2 -> Flux in microJansky 
      ELSE IF (cname.eq.param(5)) THEN
         READ(line,*) magtyp
         IF (magtyp.ne.0.and.magtyp.ne.1.and.magtyp.ne.2) THEN
            WRITE(*,*) 'MAG_TYPE must be 0 , 1 or 2'
            STOP
         END IF
         input(5)=1
         GO TO 7
c ..... Minimum photometric error (if NOISE_TYPE = 1)
      ELSE IF (cname.eq.param(6)) THEN
         READ(line,*) err_min
         INPUT(6)=1
         GO TO 7
c ..... Redshift range
      ELSE IF (cname.eq.param(7)) THEN
         READ(line,*) zmin
         INPUT(7)=1
         GO TO 7
      ELSE IF (cname.eq.param(8)) THEN
         READ(line,*) zmax
         INPUT(8)=1
         GO TO 7
c ..... Reddening:
c       0 -> No reddening
c       1 -> Allen, 1976, standard MW
c       2 -> Seaton, 1979, standard MW
c       3 -> Fitzpatrick, 1986, LMC
c       4 -> Prevot, 1984 + Bouchet, 1985, SMC
c       5 -> Calzetti et al., 2000
c      -1 -> user provided table with lambda[A],k(lambda)/RV
      ELSE IF (cname.eq.param(9)) THEN
         READ(line,*) law_rd
         IF (law_rd.ne.0.and.law_rd.ne.1.and.law_rd.ne.2.and.
     .        law_rd.ne.3.and.law_rd.ne.4.and.law_rd.ne.5.and.
     .        law_rd.ne.-1) THEN
            WRITE(*,*) 'REDDENING_LAW must be -1 -- 5'
            STOP
         END IF
         input(9)=1
         GO TO 7
c ..... File containing used provided extinction law (lambda[A],k(lambda)/RV)
      ELSE IF (cname.eq.param(10)) THEN
         READ(line,'(A)') filered
         input(10)=1
         GO TO 7
c ..... Av_max, Av_min
      ELSE IF (cname.eq.param(11)) THEN
         READ(line,*) avmin
         input(11)=1
         GO TO 7
      ELSE IF (cname.eq.param(12)) THEN
         READ(line,*) avmax
         input(12)=1
         GO TO 7
c .... Lyman Forest
      ELSE IF (cname.eq.param(13)) THEN
         READ(line,*) r_lyf
         IF (r_lyf.lt.1.D-4) r_lyf=1.D0
         IF (r_lyf.lt.1.D0) r_lyf=1.D0/r_lyf
         IF (ABS(r_lyf-1.D0).lt.1.D-4) THEN
            nlyf=1 ! considering only the mean Madau value
         ELSE
            nlyf=3 ! considering 3 values: mean Madau value + 2 values 
         END IF
         input(13)=1
         GO TO 7
c ..... Output files: no extension (file = *)
c       *.model -> model catalogue
c       *.cat   -> catalogue with noise
      ELSE IF (cname.eq.param(14)) THEN
         READ(line,'(A)') spectra
         iblank=INDEX(spectra,' ')
         spectra1=spectra(1:iblank-1)//'.model'
         spectra2=spectra(1:iblank-1)//'.cat'
         outfile=spectra(1:iblank-1)//'.out_cat'
         input(14)=1
         GO TO 7
c ..... Cosmological parameters: H_0, Omega_matter, Omega_lambda
      ELSE IF (cname.eq.param(15)) THEN
         READ(line,*) h0
         INPUT(15)=1
         GO TO 7
      ELSE IF (cname.eq.param(16)) THEN
         READ(line,*) om
         INPUT(16)=1
         GO TO 7
      ELSE IF (cname.eq.param(17)) THEN
         READ(line,*) ov
         INPUT(17)=1
         GO TO 7
c Parameters relative to make_catalog only
c ..... Reference filter 
      ELSE IF (cname.eq.param(18)) THEN
         READ(line,*) nfil_ref
         input(18)=1
         GO TO 7
c ..... Minimum magnitude in reference filter
      ELSE IF (cname.eq.param(19)) THEN
         READ(line,*) am_min
         input(19)=1
         GO TO 7
c ..... Maximum magnitude in reference filter
      ELSE IF (cname.eq.param(20)) THEN
         READ(line,*) am_max
         input(20)=1
         GO TO 7
c ..... Type of noise:
c       0. random with fixed sigma in magnitudes
c       1. with dm(m)
      ELSE IF (cname.eq.param(21)) THEN
         READ(line,*) inoise
         IF (inoise.ne.0.and.inoise.ne.1) THEN
            WRITE(*,*) 'NOISE_TYPE must be 0 or 1'
            STOP
         END IF
         INPUT(21)=1
         GO TO 7
c ..... Number of objects
      ELSE IF (cname.eq.param(22)) THEN
         READ(line,*) nob
         IF (nob.gt.mxobj) THEN
            WRITE(*,'(1x,a,i7,a)') 
     .           'Number of objects exceeding the maximum [max=',
     .           mxobj,']'
            STOP
         END IF
         INPUT(22)=1
         GO TO 7
c ..... Formation redshift
      ELSE IF (cname.eq.param(23)) THEN
         READ(line,*) z_form
         INPUT(23)=1
         GO TO 7
c ..... Age: choice for galaxy age
c       0. age = age of universe T(z_form)
c       1. age = random between 0 and T(z)-T(z_form)
      ELSE IF (cname.eq.param(24)) THEN
         READ(line,*) i_age
         IF (i_age.ne.0.and.i_age.ne.1) THEN
            WRITE(*,*) 'AGE_RANDOM must be 0 or 1'
            STOP
         END IF
         INPUT(24)=1
         GO TO 7
c ..... Seed for random generator
      ELSE IF (cname.eq.param(25)) THEN
         READ(line,*) iseed
         input(25)=1
         GO TO 7
      ELSE 
c         WRITE(*,'(a,1x,a)') 'Unknown parameter (ignored)',cname
         GO TO 7
      END IF
 10   CONTINUE
      CLOSE(77)
      IF (law_rd.eq.0) THEN
         avmin=0.0D0
         avmax=0.0D0
      END IF
      OPEN(20,file=filered,status='old',iostat=ierr)
      IF (ierr.gt.0.and.law_rd.eq.-1) THEN
         iblank=INDEX(line,' ')
         WRITE(*,'(a)') 'User provided extinction law'
         WRITE(*,'(a)') 'File '//filered(1:iblank-1)//' not found'
         STOP
      END IF
      CLOSE(20)
      IF (zmax.gt.z_form) zmax=z_form

      OPEN(10,FILE=filedef,STATUS='old',ERR=78)
      iii=1
 2230 READ(10,'(A)',ERR=2220,END=2220) line_sed
      IF (line_sed(1:1).eq.'#'.or.line_sed.eq.' ') GO TO 2230
      last=INDEX(line_sed,' ')-1
      filesed(iii)=line_sed(1:last)
      line_sed=line_sed(last+1:)
      DO i=1,160
         IF (line_sed(i:i).ne.' ') THEN
            line_sed=line_sed(i:)
            GO TO 2221
         END IF
      END DO
      WRITE(*,*) 'Missed type of SED file ', filesed(iii)
      STOP
 2221 sed_abc(iii)=line_sed(1:2)
      iii=iii+1
      GO TO 2230
 2220 n_files=iii-1
      IF (n_files.gt.mxtyp) THEN
         WRITE(*,'(1x,a,i3,a)') 
     .        'Number of files exceeding the maximum [max=',mxtyp,']'
         STOP
      END IF
      WRITE(*,'(1x,a,1x,i4,1x,a)') 'There are ',n_files,
     &     ' synthetic spectra'
      CLOSE(10)
c filters
      OPEN(10,FILE=filt_file,STATUS='old',ERR=80)
      ifilt=0
 134  CONTINUE
      READ(10,'(A)',ERR=135,END=135) line
      IF (line(1:1).eq.'#'.or.line.eq.' ') GO TO 134
      ifilt=ifilt+1
      ncomp=1
      DO k=1,80
         IF (line(k:k).eq.'&') THEN
            line(k:k)=' '
            ncomp=ncomp+1
         ELSE IF (line(k:k).eq.'#') THEN
            GO TO 136
         END IF
      END DO
 136  CONTINUE
      IF (ncomp.eq.1) THEN 
         IF (inoise.eq.0) THEN
            READ(line,*,ERR=82) nfil(ifilt),err_p(ifilt)
         ELSE
            READ(line,*,ERR=81) nfil(ifilt),sn0(ifilt),am0(ifilt)
            IF (ABS(sn0(ifilt)).lt.err) THEN
               WRITE(*,*) 'Reference S/N must be > 0'
               STOP
            END IF
         END IF
         kfil(1)=nfil(ifilt)
      ELSE 
         IF (inoise.eq.0) THEN
            READ(line,*,ERR=82) (kfil(j),j=1,ncomp),err_p(ifilt)
         ELSE
            READ(line,*,ERR=81) (kfil(j),j=1,ncomp),sn0(ifilt),
     &           am0(ifilt)
            IF (ABS(sn0(ifilt)).lt.err) THEN
               WRITE(*,*) 'Reference S/N must be > 0'
               STOP
            END IF
         END IF
      END IF
c read_filt subroutine 
      CALL read_filt(ncomp,kfil,wl(ifilt),surf(ifilt),bp1(ifilt),iband)
      GO TO 134
 135  n_filt=ifilt

      IF (n_filt.gt.mxfil) THEN
         WRITE(*,'(1x,a,i3,a)') 
     .        'Number of filters exceeding the maximum [max=',mxfil,']'
         STOP
      END IF
      WRITE(*,*) 'There are ',n_filt,' filters'
      CLOSE(10)
c ..... Reference filter
      ifilt=ifilt+1             
      nfil(ifilt)=nfil_ref
      kfil(1)=nfil(ifilt)
      CALL read_filt(1,kfil,wl(ifilt),surf(ifilt),bp1(ifilt),iband)

c maximum and minimum wavelength in filters
      wlmax=0.D0
      wlmin=1.D8
      DO i=1,n_filt
         wlmax=MAX(wlmax,r(np(i),i,1))
         wlmin=MIN(wlmin,r(1,i,1))
      END DO
c maximum wavelength at the maximum redshift
      wlmax=wlmax*(1.D0+zmax)
c minimum wavelength at the minimum redshift
      wlmin=wlmin*(1.D0+zmin)
c -----------------------------------------------------------------------
c                       Reading synthetic spectra 
c -----------------------------------------------------------------------
c ..... Vega
      WRITE (*,'(1x,a)') 'Vega SED:'
      OPEN(10,FILE=spec_vega,STATUS='old')
      READ(10,'(A)') line
      WRITE(*,'(a)') line(1:80)
c      scl=2.D-17
      scl=1.D0
      iii=1
 223  READ(10,*,ERR=222,END=222) wv,fv
      w_vega(iii)=DBLE(wv)
      f_vega(iii)=DBLE(fv)*scl
      iii=iii+1
      GO TO 223
 222  iw_vega=iii-1
      CLOSE(10)
      WRITE(*,'(1x,a,1x,i6,1x,a)') 'There are ',iw_vega,
     &     ' points in Vega'

c ..... SED
      WRITE(*,*) 'Reading synthetic spectra :'
      i_bc=0
      i_as=0
      i_pg=0
      DO i=1,n_files
         ntyp_bc(i)=-1
         ntyp_as(i)=-1
         ntyp_pg(i)=-1
      END DO 
   
      DO i=1,n_files
         last=INDEX(filesed(i),' ')
         WRITE(*,2005) i,filesed(i)(1:last)
c GISSEL's templates
         IF (sed_abc(i).eq.'BC') THEN
            OPEN(1,FILE=filesed(i),STATUS='old',
     .           FORM='unformatted',ERR=25)
            i_bc=i_bc+1
            IF (i_bc.gt.mxtyp_bc) THEN
               WRITE(*,'(a,i3)') 
     .              ' Number of GISSEL templates exceeding the maximum.' 
     .              //' Max = ',mxtyp_bc
               WRITE(*,'(a)') 
     .              ' Reduce GISSEL SEDs or modify mxtyp_bc in '
     .              //'dimensionz.dec and recompile'
               STOP
            END IF
            ntyp_bc(i)=i_bc
c ks = n of temporal intervals, t_bc and t_bc0 in [yr]
            READ (1) ks(i),(t_bc0(ii),ii=1,ks(i)),ml,mu,iseg,
     &	   (xx(j),lm(j),um(j),baux(j),cn(j),cc(j),j=1,iseg),
     &	   totm,totn,avs,jo,tau0,string_id
c replace value of tau if SFH is not exponentially declining
c SFHs following jo parameter: 
c jo=0: SSP; jo=1: exp. declining with gas recycling; 
c jo=2: burst of finite length; jo=3: constant; jo=4: exp. declining; 
c jo=5: burst added; jo=6: delayed; jo=7: input SFH; 
c jo=8: linearly decreasing
         IF (jo.eq.0) THEN      ! SSP 
            tau(i)=0.D0
         ELSE IF (jo.eq.3) THEN
            tau(i)=-1.D0        ! constant SFR
         ELSE IF (jo.eq.4.or.jo.eq.1) THEN
            tau(i)=tau0/1.D9         ! TAU models
         ELSE
            tau(i)=-10.D0       ! other SFHs
         END IF
         ic1=INDEX(string_id,'Z=')
         string_id=string_id(ic1+2:)
         read(string_id,*) zsun(i) 
c iw = number of wavelengths, w_bc wavelength in [A]
            READ (1) iw(i),(w_bc(ii,i_bc),ii=1,iw(i)) 
            IF (iw(i).gt.mxwl_bc) THEN
               WRITE(*,'(a,i6)') 'Number of wavelengths in GISSEL '
     .              //'templates exceeding the maximum. Max = ',mxwl_bc
               WRITE(*,'(a)') 
     .              ' Reduce GISSEL wavelenghts or modify mxwl_bc in '
     .              //'dimensionz.dec and recompile'
               STOP
            END IF
            IF (w_bc(iw(i),i_bc).lt.wlmax) THEN
               WRITE(*,'(a,i3,a,f12.2,a,f12.2)') 
     .              'Warning: Template ',i,' lambda_max is ',
     .              w_bc(iw(i),i_bc),
     .              ' , lambda_max(zmax) should be ',wlmax
               WRITE(*,'(a)') 'Decrease zmax or change the template'
            END IF
            IF (w_bc(1,i_bc).gt.wlmin) THEN
               WRITE(*,'(a,i3,a,f12.2,a,f12.2)') 
     .              'Warning: Template ',i,' lambda_min is ',
     .              w_bc(1,i_bc),
     .              ' , lambda_min(zmin) should be ',wlmin
               WRITE(*,'(a)') 'Increase zmin or change the template'
            END IF
            k=0
            DO j=1,ks(i)
               READ (1) iw(i),(ff(ii),ii=1,iw(i))
               IF ((irebin.eq.1.and.(t_bc0(j)/1.E9.le.0.01.and.
     &              (FLOAT(j)/10.-FLOAT(j/10)).lt.1.E-6)
     &              .or.(t_bc0(j)/1.E9.gt.0.01.and.
     &              t_bc0(j)/1.E9.le.3..and.
     &              (FLOAT(j-49)/3.-FLOAT((j-49)/3)).lt.1.E-6)
     &              .or.(t_bc0(j)/1.E9.gt.3..and.
     &              t_bc0(j)/1.E9.le.20..and.
     &              (FLOAT(j-15)/4.-FLOAT((j-15)/4)).lt.1.E-6)).or.
     &              irebin.eq.0) THEN
                  k=k+1
                  t_bc(k)=DBLE(t_bc0(j))
                  DO ii=1,iw(i)
                     IF (w_bc(ii,i_bc).lt.912.) THEN
                        f_bc(ii,k,i_bc)=0.D0
                     ELSE
                        f_bc(ii,k,i_bc)=DBLE(ff(ii))
                     END IF
                  END DO
               END IF
            END DO
            ks(i)=k
            CLOSE(1)

c ASCII SEDs
         ELSE IF (sed_abc(i).eq.'AS'.or.sed_abc(i).eq.'A ') THEN
            OPEN(1,FILE=filesed(i),STATUS='old',
     .           FORM='formatted',ERR=25)
            i_as=i_as+1
            IF (i_as.gt.mxtyp_as) THEN
               WRITE(*,'(a,i3)') 
     .              ' Number of ASCII templates exceeding the maximum.' 
     .              //' Max = ',mxtyp_as
               WRITE(*,'(a)') 
     .              ' Reduce ASCII SEDs or modify mxtyp_as in '
     .              //'dimensionz.dec and recompile'
               STOP
            END IF
            ntyp_as(i)=i_as
            ks(i)=1
            ii=1

 33         READ(1,'(A)',ERR=34,END=34) line_sed
            IF (line_sed(1:1).eq.'#'.or.line_sed.eq.' ') GO TO 33

            READ(line_sed,*) w_as(ii,i_as),f_as(ii,1,i_as)
            ii=ii+1
            IF (ii.gt.mxwl_as) THEN
               WRITE(*,'(a,i6)') 'Number of wavelengths in ASCII '
     .              //'templates exceeding the maximum. Max = ',mxwl_as
               WRITE(*,'(a)') 
     .              ' Reduce ASCII wavelenghts or modify mxwl_as in '
     .              //'dimensionz.dec and recompile'
               STOP
            END IF
            GO TO 33
 34         iw(i)=ii-1
            IF (w_as(iw(i),i_as).lt.wlmax) THEN
               WRITE(*,'(a,i3,a,f12.2,a,f12.2)') 
     .              'Warning: Template ',i,' lambda_max is ',
     .              w_as(iw(i),i_as),
     .              ' , lambda_max(zmax) should be ',wlmax
               WRITE(*,'(a)') 'Decrease zmax or change the template'
            END IF
            IF (w_as(1,i_as).gt.wlmin) THEN
               WRITE(*,'(a,i3,a,f12.2,a,f12.2)') 
     .              'Warning: Template ',i,' lambda_min is ',
     .              w_as(1,i_as),
     .              ' , lambda_min(zmin) should be ',wlmin
               WRITE(*,'(a)') 'Increase zmin or change the template'
            END IF
            CLOSE(1)

c PEGASE templates
         ELSE IF (sed_abc(i).eq.'PG') THEN
            OPEN(1,FILE=filesed(i),STATUS='old',
     .           FORM='formatted',ERR=25)
            i_pg=i_pg+1
            IF (i_pg.gt.mxtyp_pg) THEN
               WRITE(*,'(a,i3)') 
     .              ' Number of PEGASE templates exceeding the maximum.' 
     .              //' Max = ',mxtyp_pg
               WRITE(*,'(a)') 
     .              ' Reduce PEGASE SEDs or modify mxtyp_pg in '
     .              //'dimensionz.dec and recompile'
               STOP
            END IF
            ntyp_pg(i)=i_pg
 35         READ (1,'(a)',ERR=36,END=36) line_pg 
            IF (line_pg(1:5).eq.'*****') GO TO 37
            GO TO 35
 37         READ (1,*,ERR=36,END=36) ks(i),iw(i),nemline
            IF (ks(i).gt.mxage_pg) THEN
               WRITE(*,'(a,i4)') 
     .              ' Number of ages in PEGASE templates exceeding '
     .              //'the maximum. Max = ', mxage_pg
               WRITE(*,'(a)') 
     .              'Change the SED or modify mxage_pg in '
     .              //'dimensionz.dec and recompile'
               STOP
            END IF
            IF (iw(i).gt.mxwl_pg) THEN
               WRITE(*,'(a,i6)') 'Number of wavelengths in PEGASE '
     .              //'templates exceeding the maximum. Max = ',mxwl_pg
               WRITE(*,'(a)') 
     .              ' Reduce PEGASE wavelenghts or modify mxwl_pg in '
     .              //'dimensionz.dec and recompile'
               STOP
            END IF
            READ(1,*) (w_pg(j,i_pg),j=1,iw(i))
            IF (w_pg(iw(i),i_pg).lt.wlmax) THEN
               WRITE(*,'(a,i3,a,f12.2,a,f12.2)') 
     .              'Warning: Template ',i,' lambda_max is ',
     .              w_pg(iw(i),i_pg),
     .              ' , lambda_max(zmax) should be ',wlmax
               WRITE(*,'(a)') 'Decrease zmax or change the template'
            END IF
            IF (w_pg(1,i_pg).gt.wlmin) THEN
               WRITE(*,'(a,i3,a,f12.2,a,f12.2)') 
     .              'Warning: Template ',i,' lambda_min is ',
     .              w_pg(1,i_pg),
     .              ' , lambda_min(zmin) should be ',wlmin
               WRITE(*,'(a)') 'Increase zmin or change the template'
            END IF
            READ(1,*) (aa8,j=1,nemline)
            DO j=1,ks(i)
c 1st line: 1.age[Myr](int), 2.Mgal[Msun], 3.Mstar[Msun], 4.MWD[Msun],
c           5.MBHNS[Msun], 6.Msub[Msun], 7.Mgas[Msun], 8.Zgas, 
c           9.<Zstars>_mass, 10.<Zstars>_Lbol
               READ(1,*) it_pg,amgal,amstar,(aa8,k=1,7)
c 2nd line: 1.L_bol[erg/s], 2. tauV, 3.Ldust/Lbol, 4.SFR[Msun/Myr],
c           5. nLymcont[s-1], 6.nSNII[Myr-1], 7.nSNIa[Myr-1], 
c           8.<age>_mass[Myr], 9.<age>_Lbol[Myr]
               READ(1,*) aa8,aa8,aa8,sfr,aa8,aa8,aa8,aa8,aa8
               READ(1,*) (ff(k),k=1,iw(i))
               t_pg(j)=DBLE(it_pg) ! it_pg is age[Myr] (integer)
               DO k=1,iw(i)
                  f_pg(k,j,i_pg)=DBLE(ff(k))
               END DO
               READ(1,*) (aa,k=1,nemline)
            END DO
c normalise in solar units
            DO k=1,ks(i)
               DO ii=1,iw(i)
                  f_pg(ii,k,i_pg)=f_pg(ii,k,i_pg)/lsun
               END DO
            END DO
c Pegase SEDs already = 0 at lambda < 912.A
            DO k=1,ks(i)
               DO ii=1,iw(i)
                  IF (w_pg(ii,i_pg).lt.912.) f_pg(ii,k,i_pg)=0.
               END DO
            END DO
 36         CLOSE(1)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         ELSE
            WRITE(*,*) 'Don''t know how to read :'
            WRITE(*,'(A)') filesed(i)(1:INDEX(filesed(i),' '))
            STOP
         END IF
      END DO
 2005 FORMAT(' Type ', I3, ' : ', A)
      WRITE(*,'(1x,a,i3,a)') 'Read ',i_bc,' GISSEL SEDs'
      WRITE(*,'(1x,a,i3,a)') '     ',i_as,' ASCII  SEDs'
      WRITE(*,'(1x,a,i3,a)') '     ',i_pg,' PEGASE SEDs'
c -----------------------------------------------------------------------
c                    Filters and .out_cat file
c -----------------------------------------------------------------------
      OPEN(18,FILE=outfile,STATUS='unknown')
      WRITE(18,'(a)')
     .     '##########################################################'
      WRITE(18,'(a,1x,a)')
     .     '# This is the output file of make_catalog - Version '//vv
      WRITE(18,'(a)')
     .     '##########################################################'
      CALL fdate(date)
c      CALL fdate_(date)   ! IBM
      WRITE(18,'(a)') '# Date: '//date
      WRITE(18,'(a)') '# Output catalogues : '
      last=INDEX(spectra1,' ')-1
      WRITE(18,'(2x,a)')  spectra1(1:last)
      last=INDEX(spectra2,' ')-1
      WRITE(18,'(2x,a)')  spectra2(1:last)
      WRITE(18,'(a)') 
     .     '# Templates SEDs:'
      DO ityp=1,n_files
         last=INDEX(filesed(ityp),' ')-1
         WRITE(18,'(2x,i4,2x,a,2x,a)') ityp,filesed(ityp)(1:last),
     .     sed_abc(ityp)
      END DO
      WRITE(18,'(a)') '# Characteristics of filters'
      IF (inoise.eq.1) THEN
         IF (magtyp.eq.0.or.magtyp.eq.1) THEN
c ..... Computing limiting magnitudes
            DO kk=1,n_filt
               sn_0=sn0(kk)
               am_0=am0(kk)
               amlimit(kk)=zero(f_sn,am1,am2,err)
            END DO
         ELSE IF (magtyp.eq.2) THEN
            DO kk=1,n_filt
               amlimit(kk)=am0(kk)/sn0(kk)
            END DO
         END IF
      END IF

      IF (inoise.eq.1) THEN
         IF (magtyp.eq.0.or.magtyp.eq.1) THEN 
            WRITE(*,'(a)') 
     .           '#  n       wl_eff       surface   conv_AB  mag_lim'
            WRITE(18,'(a)') 
     .           '#  n       wl_eff       surface   conv_AB  mag_lim'
         ELSE IF (magtyp.eq.2) THEN
            WRITE(*,'(a)') 
     .           '#  n       wl_eff       surface   conv_AB    flux_lim'
            WRITE(18,'(a)') 
     .           '#  n       wl_eff       surface   conv_AB    flux_lim'
         END IF
      ELSE
         WRITE(*,'(a)') 
     .        '#  n       wl_eff       surface   conv_AB'
         WRITE(18,'(a)') 
     .        '#  n       wl_eff       surface   conv_AB'
      END IF
      z0=0.D0

c ..... Conversion from AB to standard magnitudes: conv_mag = AB - Vega
c computing AB magnitude of Vega
      DO k=1,n_filt+1
         vega(k)=filter(k,w_vega,f_vega,iw_vega,z0)
         DO i=1,np(k)
            xlam(i)=r(i,k,1) ! lambda
            rr2(i)=r(i,k,2)/(xlam(i)*xlam(i)) ! R/lambda^2
         END DO
         f2(k)=c*trapz1(xlam,rr2,np(k))
         conv_mag(k)=-2.5D0*DLOG10(vega(k)/f2(k))-48.60D0
      END DO

      DO k=1,n_filt
         IF (inoise.eq.1) THEN
            IF (magtyp.eq.2) THEN
               WRITE(*,1996) nfil(k),wl(k),surf(k),conv_mag(k),
     .              amlimit(k)
               WRITE(18,1996) nfil(k),wl(k),surf(k),conv_mag(k),
     .              amlimit(k)
            ELSE IF(magtyp.eq.0.or.magtyp.eq.1) THEN
               WRITE(*,1997) nfil(k),wl(k),surf(k),conv_mag(k),
     .              amlimit(k)
               WRITE(18,1997) nfil(k),wl(k),surf(k),conv_mag(k),
     .              amlimit(k)
            END IF
         ELSE
            WRITE(*,1999) nfil(k),wl(k),surf(k),conv_mag(k)
            WRITE(18,1999) nfil(k),wl(k),surf(k),conv_mag(k)
         END IF
      END DO
 1997 FORMAT(2X,I3,1X,F12.3,1X,F12.3,2X,F7.3,4X,F7.3)
 1996 FORMAT(2X,I3,1X,F12.3,1X,F12.3,2X,F7.3,4X,E10.4)
 1999 FORMAT(2X,I3,1X,F12.3,1X,F12.3,2X,F7.3)

      nnn=n_filt+2
      WRITE(fmt,1002) nnn
      WRITE(fmtjy,1003) n_filt
 1002 FORMAT('(1x,i4,1x,f7.3,1x,i2,',i2,'2(1x,f7.3))')
 1003 FORMAT('(1x,i6,1x,f7.3,1x,i2,1x,f7.3,',
     .     i2,'(1x,e11.4),2(1x,f7.3))')

      WRITE(fmt2,2001) n_filt,n_filt
      WRITE(fmt2jy,2002) n_filt,n_filt
 2001 FORMAT('(i6,1x,',i2,'(f7.3,1x),',i2,'(f6.3,1x),2(i2,1x))')
 2002 FORMAT('(i6,1x,',i2,'(e11.4,1x),',i2,'(e11.4,1x),2(i2,1x))')

      WRITE(18,'(a)') '#    zmin      zmax'
      WRITE(18,'(4X,3(F5.2,5X))') zmin,zmax
      WRITE(18,'(a)') '#    AVmin     AVmax  red_law'
      WRITE(18,'(4X,2(F5.2,5X),I2)') avmin,avmax,law_rd
      WRITE(18,'(a)') 
     .     '#    Lyman_forest [factor(s) multiplying <tau_eff>]'
      IF (nlyf.eq.1) WRITE(18,'(4X,F6.3)') r_lyf
      IF (nlyf.eq.3) WRITE(18,'(4X,3(F6.3,2X))') 
     .     1.D0/r_lyf,r_lyf/r_lyf,r_lyf
      IF (magtyp.eq.0.or.magtyp.eq.1) WRITE(18,'(a)') 
     .     '#    magmin    magmax   ref_filter  mag type'
      IF (magtyp.eq.2) WRITE(18,'(a)') 
     .     '#    fluxmin     fluxmax    ref_filter  mag type'
      IF (magtyp.eq.0) WRITE(18,'(4X,2(F7.2,2X),4X,I3,8X,A)') 
     .     am_min,am_max,nfil(ifilt),'Vega'
      IF (magtyp.eq.1) WRITE(18,'(4X,2(F7.2,2X),4X,I3,8X,A)') 
     .     am_min,am_max,nfil(ifilt),'AB'
      IF (magtyp.eq.2) WRITE(18,'(5X,2(E10.4,2X),4X,I3,5X,A)') 
     .     am_min,am_max,nfil(ifilt),'muJy'
      WRITE(18,'(a)') '#    Omega_0   Omega_v  H_0'
      WRITE(18,'(4X,3(F5.2,5X))') om,ov,h0
c -----------------------------------------------------------------------
      age_form=tz(h0,om,ov,z_form) ! age of universe at z_form
      WRITE(18,'(a)') '#  Universe age at z_form   Galaxy age at z=0'
      WRITE(18,'(5X,F9.5,A4,11X,F9.5,A4)') age_form,' Gyr',
     .     tz(h0,om,ov,z0)-age_form,' Gyr'
      z_int=zmax-zmin 
      averr=avmax-avmin
c convert max and min fluxes or vega mags in min and max AB magnitudes,
c and err_min and err_p in magnitudes
      IF (magtyp.eq.0) THEN
         am_min=am_min+conv_mag(ifilt)
         am_max=am_max+conv_mag(ifilt)
      ELSE IF (magtyp.eq.2) THEN
         am_min=-2.5D0*DLOG10(am_max*1.D-29)-48.6
         am_max=-2.5D0*DLOG10(am_min*1.D-29)-48.6
      END IF

      OPEN(14,file=spectra1,status='unknown')
      OPEN(15,file=spectra2,status='unknown')
c ------------------------------------------------------------------------
c homogeneous distribution in z and type, mag random in the input range
c ------------------------------------------------------------------------
      DO i_ob=1,nob
         z=z_int*ran1(iseed)+zmin ! random z 
         bmag=am_min+ran1(iseed)*(am_max-am_min) ! random mag in ref.filter
         av=avmin+averr*ran1(iseed) ! random Av
         ityp=INT(n_files*ran1(iseed))+1 ! random type
         IF (nlyf.eq.1) THEN
            ilyf=1
            fact_lyf=1.D0
         ELSE 
            ilyf=INT(nlyf*ran1(iseed))+1
            fact_lyf=(r_lyf**(ilyf-1))*(1.D0/r_lyf)
         END IF
         age_z=tz(h0,om,ov,z)   ! age of universe at z [Gyr]
         IF (i_age.eq.0) THEN
            age=age_z-age_form
         ELSE IF (i_age.eq.1) THEN
            age=(age_z-age_form)*ran1(iseed) ! random age [Gyr]
         END IF

         IF (sed_abc(ityp).eq.'BC') THEN
            DO k=1,ks(ityp)-1
               IF (age.ge.t_bc(k)*1.D-9.and.age.lt.t_bc(k+1)*1.D-9) THEN
                  i1=k
                  i2=k+1
                  GO TO 22
               END IF
            END DO
 22         DO i=1,iw(ityp)     !lambda
               fl1(i)=f_bc(i,i1,ntyp_bc(ityp))
               fl2(i)=f_bc(i,i2,ntyp_bc(ityp))
               ww(i)=DBLE(w_bc(i,ntyp_bc(ityp)))
               IF (ww(i).lt.912.0D0) THEN
                  fl1(i)=0.0D0
                  fl2(i)=0.0D0
               END IF
            END DO
            
            tx=age
            t1=t_bc(i1)*1.D-9
            t2=t_bc(i2)*1.D-9
            a1=(t2-tx)/(t2-t1)
            a2=1.D0-a1
            DO i=1,iw(ityp)
               yz(i)=a1*fl1(i)+a2*fl2(i)
            END DO

         ELSE IF (sed_abc(ityp).eq.'AS'.or.sed_abc(ityp).eq.'A ') THEN
            age=19.999D0
            DO i=1,iw(ityp)
               yz(i)=f_as(i,1,ntyp_as(ityp))
               ww(i)=DBLE(w_as(i,ntyp_as(ityp)))
               IF (ww(i).lt.912.0D0) yz(i)=0.0D0
            END DO

         ELSE IF (sed_abc(ityp).eq.'PG') THEN
            DO k=1,ks(ityp)-1
               IF (age.ge.t_pg(k)*1.D-3.and.age.lt.t_pg(k+1)*1.D-3) THEN
                  i1=k
                  i2=k+1
                  GO TO 23
               END IF
            END DO
 23         DO i=1,iw(ityp)     !lambda
               fl1(i)=f_pg(i,i1,ntyp_pg(ityp))
               fl2(i)=f_pg(i,i2,ntyp_pg(ityp))
               ww(i)=DBLE(w_pg(i,ntyp_pg(ityp)))
               IF (ww(i).lt.912.0D0) THEN
                  fl1(i)=0.0D0
                  fl2(i)=0.0D0
               END IF
            END DO
            
            tx=age
            t1=t_pg(i1)*1.D-3
            t2=t_pg(i2)*1.D-3
            a1=(t2-tx)/(t2-t1)
            a2=1.D0-a1
            DO i=1,iw(ityp)
               yz(i)=a1*fl1(i)+a2*fl2(i)
            END DO
         END IF

         IF (av.gt.0.0D0) THEN
            CALL red_spec(ww,yz,av,yob,1,iw(ityp),law_rd)
            DO k=1,iw(ityp)
               yz(k)=yob(k)
            END DO
         END IF
c ... lyman alpha forest
         CALL lyman_forest(ww,yz,iw(ityp),z)
c flux from template in reference filter
         flux=filter(ifilt,ww,yz,iw(ityp),z)/f2(ifilt)
         IF (flux.eq.0.D0) THEN
            WRITE(*,'(a,1x,f6.3,1x,a)') 'Object at redshift ',z, 
     .           'non detected in the reference filter'
            WRITE(*,*) 'Select a redder REF_FILTER or a lower Z_MAX'
            STOP
         END IF
c flux from random magnitude
         fl_ref=10**(-0.4D0*(bmag+48.6D0))
c template normalisation
         bb=fl_ref/flux
         DO kk=1,n_filt
            flux=filter(kk,ww,yz,iw(ityp),z)/f2(kk)
            IF (flux.gt.0.D0) THEN
               amag(kk)=-2.5D0*DLOG10(bb*flux)-48.6
               IF (magtyp.eq.0) THEN
                  amag(kk)=amag(kk)+conv_mag(kk)
               ELSE IF (magtyp.eq.2) THEN
                  fl_jy(kk)=flux*1.D+29
               END IF
            ELSE 
               IF (magtyp.eq.0.or.magtyp.eq.1) THEN
                  amag(kk)=99.D0
               ELSE IF (magtyp.eq.2) THEN
                  fl_jy(kk)=-99.D0
               END IF
            END IF
         END DO
c model catalog (no noise added)
         IF (magtyp.eq.0.or.magtyp.eq.1) THEN
            WRITE(14,fmt) i_ob,z,ityp,age,(amag(kk),kk=1,n_filt),
     .           av,fact_lyf
         ELSE
            WRITE(14,fmtjy) i_ob,z,ityp,age,(fl_jy(kk),kk=1,n_filt),
     .           av,fact_lyf
         END IF
c errors
         IF (inoise.eq.1) THEN
            IF (magtyp.eq.0.or.magtyp.eq.1) THEN
               DO kk=1,n_filt
                  err_p(kk)=1.D0
                  IF (amag(kk).ne.99.D0) THEN 
                     sn=sn0(kk)*10.D0**(-0.4D0*(amag(kk)-am0(kk)))
                     IF (sn.lt.1.D0) THEN 
                        amag(kk)=99.D0
                     ELSE
c ***** to be revised
                        sig=DSQRT((2.5D0*DLOG10(1.D0+1.D0/sn))**2
     .                       +err_min**2)
                        dif=rangauss(iseed)
                        amag(kk)=amag(kk)+dif*sig
                        err_p(kk)=sig
                     END IF
                  END IF
               END DO
            ELSE IF (magtyp.eq.2) THEN
               DO kk=1,n_filt
                  IF (fl_jy(kk).ge.0.D0) THEN
                     sn=sn0(kk)*fl_jy(kk)/am0(kk)
                     IF (sn.lt.1.D0) THEN 
                        fl_jy(kk)=-99.D0
                     ELSE
                        sig=DSQRT((fl_jy(kk)/sn)**2+err_min**2)
                        dif=rangauss(iseed)
                        fl_jy(kk)=fl_jy(kk)+dif*sig
                        err_p(kk)=sig
                     END IF
                  END IF
               END DO
            END IF
         ELSE IF (inoise.eq.0) THEN
            IF (magtyp.eq.0.or.magtyp.eq.1) THEN
               DO kk=1,n_filt
                  IF (amag(kk).ne.99.D0) THEN 
                     sig=err_p(kk)
                     dif=rangauss(iseed)
                     amag(kk)=amag(kk)+dif*sig
                  END IF
               END DO
            ELSE
               DO kk=1,n_filt
                  IF (fl_jy(kk).ge.0.D0) THEN
                     sn=sn0(kk)*10.D0**(-0.4D0*(amag(kk)-am0(kk)))
                     IF (sn.lt.1.D0) THEN 
                        fl_jy(kk)=-99.D0
                     ELSE
                        sig=err_p(kk)
                        dif=rangauss(iseed)
                        fl_jy(kk)=fl_jy(kk)+dif*sig
                     END IF
                  END IF
               END DO
            END IF
         END IF
c catalog with errors
         IF (magtyp.eq.0.or.magtyp.eq.1) THEN
            WRITE(15,fmt2) i_ob,(amag(kk),kk=1,n_filt),
     .           (err_p(kk),kk=1,n_filt)
         ELSE IF (magtyp.eq.2) THEN
            WRITE(15,fmt2jy) i_ob,(fl_jy(kk),kk=1,n_filt),
     .           (err_p(kk),kk=1,n_filt)
         END IF
      END DO
      CLOSE(14)
      CLOSE(15)

      time_tot=DBLE(cputime())-time_tot
      WRITE(*,'(a)') ' Done !!!'
      WRITE(*,*) 'Total CPU time involved :', time_tot, ' seconds'
      WRITE(18,'(a,1x,f8.2,1x,a)') '#  Total CPU time involved :',  
     .     time_tot,' seconds'
      CLOSE(18)
      STOP
 25   STOP 'Error opening synthetic spectra files'
 78   STOP 'Error opening templates file'
 80   STOP 'Error opening filters file'
 81   STOP 'Error reading filters file (format: #filter s/n mag)'
 82   STOP 'Error reading filters file (format: #filter sigma)'
 3    STOP 'Program exits because of error reading A0 V s.e.d. file'
      END
c............................................................
      FUNCTION f_sn(am)
      REAL*8 f_sn,am,sn_0,am_0
      COMMON/s2n/sn_0,am_0
      f_sn=sn_0*10.D0**(-0.4D0*(am-am_0))-1.D0
      RETURN
      END
c............................................................

      REAL*8 FUNCTION ran1(idum)
      IMPLICIT NONE
      INTEGER j,m1,ia1,ic1,ix1,m2,ia2,ic2,ix2,m3,ia3,ic3,ix3,iff,idum
      REAL*8 rm1,rm2,rr
      DIMENSION rr(97)
      PARAMETER (m1=259200,ia1=7141,ic1=54773,rm1=3.8580247D-6)
      PARAMETER (m2=134456,ia2=8121,ic2=28411,rm2=7.4373773D-6)
      PARAMETER (m3=243000,ia3=4561,ic3=51349)
      SAVE rr,ix1,ix2,ix3
      DATA iff /0/
      IF (idum.lt.0.or.iff.eq.0) THEN
         iff=1
         ix1=MOD(ic1-idum,m1)
         ix1=MOD(ia1*ix1+ic1,m1)
         ix2=MOD(ix1,m2)
         ix1=MOD(ia1*ix1+ic1,m1)
         ix3=MOD(ix1,m3)
         DO j=1,97
            ix1=MOD(ia1*ix1+ic1,m1)
            ix2=MOD(ia2*ix2+ic2,m2)
            rr(j)=DBLE((FLOAT(ix1)+FLOAT(ix2)*rm2)*rm1)
         END DO
         idum=1
      END IF
      ix1=MOD(ia1*ix1+ic1,m1)
      ix2=MOD(ia2*ix2+ic2,m2)
      ix3=MOD(ia3*ix3+ic3,m3)
      j=1+(97*ix3)/m3
      IF (j.gt.97.or.j.lt.1) PAUSE
      ran1=rr(j)
      rr(j)=DBLE((FLOAT(ix1)+FLOAT(ix2)*rm2)*rm1)
      RETURN
      END

c............................................................
c  Normal (Gaussian) deviates with unit variance
c  Returns normally distributed deviate with zero mean
c............................................................
      FUNCTION rangauss(idum)
      IMPLICIT NONE
      REAL*8 a,b,rg,rangauss,ran1
      INTEGER idum
 50   a=ran1(idum)
      b=ran1(idum)
      b=1.7156D0*(b-0.5D0)
      rg=b/a
      IF (rg**2.gt.-4.D0*DLOG(a)) GO TO 50
      rangauss=rg
      RETURN
      END
